UART2_driver_ucPortCountLeadingZeros:
;portmacro.h,183 :: 		static inline uint8_t ucPortCountLeadingZeros(uint32_t ulBitmap)
;portmacro.h,185 :: 		asm CLZ R0, R0;
CLZ	R0, R0
;portmacro.h,186 :: 		return R0;
UXTB	R0, R0
;portmacro.h,187 :: 		}
L_end_ucPortCountLeadingZeros:
BX	LR
; end of UART2_driver_ucPortCountLeadingZeros
UART2_driver_vPortRaiseBASEPRI:
;portmacro.h,229 :: 		portFORCE_INLINE static void vPortRaiseBASEPRI( void )
;portmacro.h,234 :: 		CPU_REG_SET(CPU_BASEPRI, ulNewBASEPRI);
MOV	R0, #16
MOV	R12, R0
MSR	#17, R12
;portmacro.h,236 :: 		asm ISB;
ISB	#15
;portmacro.h,237 :: 		asm DSB;
DSB	#15
;portmacro.h,238 :: 		}
L_end_vPortRaiseBASEPRI:
BX	LR
; end of UART2_driver_vPortRaiseBASEPRI
UART2_driver_ulPortRaiseBASEPRI:
;portmacro.h,241 :: 		portFORCE_INLINE static uint32_t ulPortRaiseBASEPRI( void )
;portmacro.h,245 :: 		ulOriginalBASEPRI = CPU_REG_GET(CPU_BASEPRI);
MRS	R12, #17
MOV	R0, R12
; ulOriginalBASEPRI start address is: 4 (R1)
MOV	R1, R0
;portmacro.h,247 :: 		CPU_REG_SET(CPU_BASEPRI, ulNewBASEPRI);
MOV	R0, #16
MOV	R12, R0
MSR	#17, R12
;portmacro.h,249 :: 		asm ISB;
ISB	#15
;portmacro.h,250 :: 		asm DSB;
DSB	#15
;portmacro.h,254 :: 		return ulOriginalBASEPRI;
MOV	R0, R1
; ulOriginalBASEPRI end address is: 4 (R1)
;portmacro.h,255 :: 		}
L_end_ulPortRaiseBASEPRI:
BX	LR
; end of UART2_driver_ulPortRaiseBASEPRI
UART2_driver_vPortSetBASEPRI:
;portmacro.h,258 :: 		portFORCE_INLINE static void vPortSetBASEPRI( uint32_t ulNewMaskValue )
; ulNewMaskValue start address is: 0 (R0)
; ulNewMaskValue end address is: 0 (R0)
; ulNewMaskValue start address is: 0 (R0)
;portmacro.h,260 :: 		CPU_REG_SET(CPU_BASEPRI, ulNewMaskValue);
MOV	R1, R0
; ulNewMaskValue end address is: 0 (R0)
MOV	R12, R1
MSR	#17, R12
;portmacro.h,261 :: 		}
L_end_vPortSetBASEPRI:
BX	LR
; end of UART2_driver_vPortSetBASEPRI
_UART2_Interrupt:
;UART2_driver.c,75 :: 		void UART2_Interrupt() iv IVT_INT_USART2 ics ICS_AUTO {
SUB	SP, SP, #12
STR	LR, [SP, #0]
;UART2_driver.c,78 :: 		BaseType_t xHigherPriorityTaskWoken = pdFALSE;
MOV	R0, #0
STR	R0, [SP, #8]
;UART2_driver.c,80 :: 		if ((RXNE_USART2_SR_bit) /* || (ORE_bit) */ ) {
MOVW	R1, #lo_addr(RXNE_USART2_SR_bit+0)
MOVT	R1, #hi_addr(RXNE_USART2_SR_bit+0)
_LX	[R1, ByteOffset(RXNE_USART2_SR_bit+0)]
CMP	R0, #0
IT	EQ
BEQ	L_UART2_Interrupt0
;UART2_driver.c,81 :: 		R_data = USART2_DR;                // Fetch a byte from UART hardware
MOVW	R0, #lo_addr(USART2_DR+0)
MOVT	R0, #hi_addr(USART2_DR+0)
LDR	R0, [R0, #0]
STRB	R0, [SP, #4]
;UART2_driver.c,82 :: 		xQueueSendFromISR(U2RcvByteQueueHandle,&R_data,&xHigherPriorityTaskWoken);
ADD	R2, SP, #8
ADD	R1, SP, #4
MOVW	R0, #lo_addr(_U2RcvByteQueueHandle+0)
MOVT	R0, #hi_addr(_U2RcvByteQueueHandle+0)
LDR	R0, [R0, #0]
MOV	R3, #0
BL	_xQueueGenericSendFromISR+0
;UART2_driver.c,83 :: 		}
L_UART2_Interrupt0:
;UART2_driver.c,85 :: 		if ((TXE_USART2_SR_bit)&&(TXEIE_USART2_CR1_bit)) {
MOVW	R1, #lo_addr(TXE_USART2_SR_bit+0)
MOVT	R1, #hi_addr(TXE_USART2_SR_bit+0)
_LX	[R1, ByteOffset(TXE_USART2_SR_bit+0)]
CMP	R0, #0
IT	EQ
BEQ	L__UART2_Interrupt50
MOVW	R1, #lo_addr(TXEIE_USART2_CR1_bit+0)
MOVT	R1, #hi_addr(TXEIE_USART2_CR1_bit+0)
_LX	[R1, ByteOffset(TXEIE_USART2_CR1_bit+0)]
CMP	R0, #0
IT	EQ
BEQ	L__UART2_Interrupt49
L__UART2_Interrupt48:
;UART2_driver.c,86 :: 		T_data = U2XmtBuf[U2XmtBufPtr++];  // Get a byte from the transmit buffer
MOVW	R2, #lo_addr(_U2XmtBufPtr+0)
MOVT	R2, #hi_addr(_U2XmtBufPtr+0)
LDRB	R1, [R2, #0]
MOVW	R0, #lo_addr(_U2XmtBuf+0)
MOVT	R0, #hi_addr(_U2XmtBuf+0)
LDR	R0, [R0, #0]
ADDS	R0, R0, R1
LDRB	R1, [R0, #0]
; T_data start address is: 12 (R3)
UXTB	R3, R1
MOV	R0, R2
LDRB	R0, [R0, #0]
ADDS	R0, R0, #1
STRB	R0, [R2, #0]
;UART2_driver.c,87 :: 		if (T_data == NUL) {               // If it is the end of message marker
CMP	R1, #0
IT	NE
BNE	L_UART2_Interrupt4
; T_data end address is: 12 (R3)
;UART2_driver.c,88 :: 		TXEIE_USART2_CR1_bit = 0;     // Disable transmitter interrupts
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(TXEIE_USART2_CR1_bit+0)
MOVT	R0, #hi_addr(TXEIE_USART2_CR1_bit+0)
_SX	[R0, ByteOffset(TXEIE_USART2_CR1_bit+0)]
;UART2_driver.c,89 :: 		xSemaphoreGiveFromISR(U2XmtSemHandle,&xHigherPriorityTaskWoken);
ADD	R1, SP, #8
MOVW	R0, #lo_addr(_U2XmtSemHandle+0)
MOVT	R0, #hi_addr(_U2XmtSemHandle+0)
LDR	R0, [R0, #0]
BL	_xQueueGiveFromISR+0
;UART2_driver.c,90 :: 		} else {
IT	AL
BAL	L_UART2_Interrupt5
L_UART2_Interrupt4:
;UART2_driver.c,91 :: 		USART2_DR = T_data;           // Transfer data byte to transmit register
; T_data start address is: 12 (R3)
MOVW	R0, #lo_addr(USART2_DR+0)
MOVT	R0, #hi_addr(USART2_DR+0)
STR	R3, [R0, #0]
; T_data end address is: 12 (R3)
;UART2_driver.c,92 :: 		}
L_UART2_Interrupt5:
;UART2_driver.c,85 :: 		if ((TXE_USART2_SR_bit)&&(TXEIE_USART2_CR1_bit)) {
L__UART2_Interrupt50:
L__UART2_Interrupt49:
;UART2_driver.c,94 :: 		portYIELD_FROM_ISR(xHigherPriorityTaskWoken);
LDR	R0, [SP, #8]
CMP	R0, #0
IT	EQ
BEQ	L_UART2_Interrupt6
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(PENDSVSET_bit+0)
MOVT	R1, #hi_addr(PENDSVSET_bit+0)
_LX	[R1, ByteOffset(PENDSVSET_bit+0)]
BFI	R0, R2, BitPos(PENDSVSET_bit+0), #1
_SX	[R1, ByteOffset(PENDSVSET_bit+0)]
DSB	#15
ISB	#15
L_UART2_Interrupt6:
;UART2_driver.c,95 :: 		}
L_end_UART2_Interrupt:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _UART2_Interrupt
_UART2_SetBaud:
;UART2_driver.c,100 :: 		void UART2_SetBaud(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;UART2_driver.c,103 :: 		GPIODEN_bit = 1;             // Set GPIOD clock enable bit
MOVS	R2, #1
SXTB	R2, R2
MOVW	R0, #lo_addr(GPIODEN_bit+0)
MOVT	R0, #hi_addr(GPIODEN_bit+0)
_SX	[R0, ByteOffset(GPIODEN_bit+0)]
;UART2_driver.c,105 :: 		GPIOD_MODER |= 0x00002800;   // Set port D MODER bits 6 and 5 to 10: alternate function mode
MOVW	R0, #lo_addr(GPIOD_MODER+0)
MOVT	R0, #hi_addr(GPIOD_MODER+0)
LDR	R0, [R0, #0]
ORR	R1, R0, #10240
MOVW	R0, #lo_addr(GPIOD_MODER+0)
MOVT	R0, #hi_addr(GPIOD_MODER+0)
STR	R1, [R0, #0]
;UART2_driver.c,106 :: 		GPIOD_AFRL |= 0x07700000;    // Select alternate function 0111: AF7 for bits 6 and 5
MOVW	R0, #lo_addr(GPIOD_AFRL+0)
MOVT	R0, #hi_addr(GPIOD_AFRL+0)
LDR	R0, [R0, #0]
ORR	R1, R0, #124780544
MOVW	R0, #lo_addr(GPIOD_AFRL+0)
MOVT	R0, #hi_addr(GPIOD_AFRL+0)
STR	R1, [R0, #0]
;UART2_driver.c,108 :: 		USART2EN_bit = 1;            // Set USART2 clock enable bit
MOVW	R0, #lo_addr(USART2EN_bit+0)
MOVT	R0, #hi_addr(USART2EN_bit+0)
_SX	[R0, ByteOffset(USART2EN_bit+0)]
;UART2_driver.c,109 :: 		USART2_CR1 |= 0x0000200C;    // Set UE, TE, and RE in USART2 control register 1
MOVW	R0, #lo_addr(USART2_CR1+0)
MOVT	R0, #hi_addr(USART2_CR1+0)
LDR	R1, [R0, #0]
MOVW	R0, #8204
ORRS	R1, R0
MOVW	R0, #lo_addr(USART2_CR1+0)
MOVT	R0, #hi_addr(USART2_CR1+0)
STR	R1, [R0, #0]
;UART2_driver.c,111 :: 		USART2_BRR = 0x00000C35;     // Set baud rate register for 9600 with 30MHz on APB1
MOVW	R1, #3125
MOVW	R0, #lo_addr(USART2_BRR+0)
MOVT	R0, #hi_addr(USART2_BRR+0)
STR	R1, [R0, #0]
;UART2_driver.c,118 :: 		NVIC_IntEnable(IVT_INT_USART2); // Set interrupt vector
MOVW	R0, #54
BL	_NVIC_IntEnable+0
;UART2_driver.c,119 :: 		}
L_end_UART2_SetBaud:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART2_SetBaud
_UART2_RxQueueInit:
;UART2_driver.c,124 :: 		void UART2_RxQueueInit(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;UART2_driver.c,125 :: 		U2RcvByteQueueHandle = xQueueCreate(U2_RCV_BYTE_Q_LENGTH, sizeof(char));
MOVS	R2, #0
MOVS	R1, #1
MOVS	R0, #128
BL	_xQueueGenericCreate+0
MOVW	R1, #lo_addr(_U2RcvByteQueueHandle+0)
MOVT	R1, #hi_addr(_U2RcvByteQueueHandle+0)
STR	R0, [R1, #0]
;UART2_driver.c,127 :: 		}
L_end_UART2_RxQueueInit:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART2_RxQueueInit
_UART2_StartRx:
;UART2_driver.c,132 :: 		void UART2_StartRx(void) {
;UART2_driver.c,133 :: 		RXNEIE_USART2_CR1_bit = 1;        // Interrupt when receive buffer is full (RXNE=1)
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(RXNEIE_USART2_CR1_bit+0)
MOVT	R0, #hi_addr(RXNEIE_USART2_CR1_bit+0)
_SX	[R0, ByteOffset(RXNEIE_USART2_CR1_bit+0)]
;UART2_driver.c,134 :: 		}
L_end_UART2_StartRx:
BX	LR
; end of _UART2_StartRx
_UART2_RcvInit:
;UART2_driver.c,139 :: 		void UART2_RcvInit(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;UART2_driver.c,140 :: 		UART2_SetBaud();
BL	_UART2_SetBaud+0
;UART2_driver.c,141 :: 		UART2_RxQueueInit();
BL	_UART2_RxQueueInit+0
;UART2_driver.c,142 :: 		UART2_StartRx();
BL	_UART2_StartRx+0
;UART2_driver.c,143 :: 		}
L_end_UART2_RcvInit:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART2_RcvInit
_UART2_Rx:
;UART2_driver.c,148 :: 		void UART2_Rx(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;UART2_driver.c,149 :: 		U2_RxFuncPtr();    // Use the function pointer to go to a state
MOVW	R4, #lo_addr(_U2_RxFuncPtr+0)
MOVT	R4, #hi_addr(_U2_RxFuncPtr+0)
LDR	R4, [R4, #0]
BLX	R4
;UART2_driver.c,150 :: 		}
L_end_UART2_Rx:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART2_Rx
_UART2_Rx1:
;UART2_driver.c,155 :: 		void UART2_Rx1(void) {
SUB	SP, SP, #8
STR	LR, [SP, #0]
;UART2_driver.c,158 :: 		xQueueReceive(U2RcvByteQueueHandle, &RxChar, 0xFFFFFFFFU); // Block here
ADD	R1, SP, #4
MOVW	R0, #lo_addr(_U2RcvByteQueueHandle+0)
MOVT	R0, #hi_addr(_U2RcvByteQueueHandle+0)
LDR	R0, [R0, #0]
MOV	R3, #0
MOV	R2, #-1
BL	_xQueueGenericReceive+0
;UART2_driver.c,160 :: 		switch (RxChar) {
IT	AL
BAL	L_UART2_Rx17
;UART2_driver.c,161 :: 		case NUL:         // Discard NUL character
L_UART2_Rx19:
;UART2_driver.c,162 :: 		break;
IT	AL
BAL	L_UART2_Rx18
;UART2_driver.c,164 :: 		case '\r':        // Use return character
L_UART2_Rx110:
;UART2_driver.c,171 :: 		break;
IT	AL
BAL	L_UART2_Rx18
;UART2_driver.c,173 :: 		case '\n':        // Use newline character
L_UART2_Rx111:
;UART2_driver.c,175 :: 		U2RcvBuf[U2RcvBufPtr++] = RxChar;  // Put received character into buffer
MOVW	R2, #lo_addr(_U2RcvBufPtr+0)
MOVT	R2, #hi_addr(_U2RcvBufPtr+0)
LDRB	R1, [R2, #0]
MOVW	R0, #lo_addr(_U2RcvBuf+0)
MOVT	R0, #hi_addr(_U2RcvBuf+0)
ADDS	R1, R0, R1
LDRB	R0, [SP, #4]
STRB	R0, [R1, #0]
MOV	R0, R2
LDRB	R0, [R0, #0]
ADDS	R1, R0, #1
UXTB	R1, R1
STRB	R1, [R2, #0]
;UART2_driver.c,176 :: 		U2RcvBuf[U2RcvBufPtr] = 0;         // End marker
MOVW	R0, #lo_addr(_U2RcvBuf+0)
MOVT	R0, #hi_addr(_U2RcvBuf+0)
ADDS	R1, R0, R1
MOVS	R0, #0
STRB	R0, [R1, #0]
;UART2_driver.c,177 :: 		U2RcvBufPtr = 0;                   // Point to start of buffer
MOVS	R0, #0
STRB	R0, [R2, #0]
;UART2_driver.c,178 :: 		U2_RxFuncPtr = UART2_Rx2;          // Go to state 2
MOVW	R1, #lo_addr(_UART2_Rx2+0)
MOVT	R1, #hi_addr(_UART2_Rx2+0)
MOVW	R0, #lo_addr(_U2_RxFuncPtr+0)
MOVT	R0, #hi_addr(_U2_RxFuncPtr+0)
STR	R1, [R0, #0]
;UART2_driver.c,180 :: 		break;
IT	AL
BAL	L_UART2_Rx18
;UART2_driver.c,182 :: 		default:
L_UART2_Rx112:
;UART2_driver.c,183 :: 		if (U2RcvBufPtr <  sizeof(U2RcvBuf)-2)     // Prevents buffer overrun
MOVW	R0, #lo_addr(_U2RcvBufPtr+0)
MOVT	R0, #hi_addr(_U2RcvBufPtr+0)
LDRB	R0, [R0, #0]
CMP	R0, #254
IT	GE
BGE	L_UART2_Rx113
;UART2_driver.c,184 :: 		U2RcvBuf[U2RcvBufPtr++] = RxChar;       // Put character in buffer
MOVW	R2, #lo_addr(_U2RcvBufPtr+0)
MOVT	R2, #hi_addr(_U2RcvBufPtr+0)
LDRB	R1, [R2, #0]
MOVW	R0, #lo_addr(_U2RcvBuf+0)
MOVT	R0, #hi_addr(_U2RcvBuf+0)
ADDS	R1, R0, R1
LDRB	R0, [SP, #4]
STRB	R0, [R1, #0]
MOV	R0, R2
LDRB	R0, [R0, #0]
ADDS	R0, R0, #1
STRB	R0, [R2, #0]
L_UART2_Rx113:
;UART2_driver.c,185 :: 		break;
IT	AL
BAL	L_UART2_Rx18
;UART2_driver.c,186 :: 		}
L_UART2_Rx17:
LDRB	R0, [SP, #4]
CMP	R0, #0
IT	EQ
BEQ	L_UART2_Rx19
LDRB	R0, [SP, #4]
CMP	R0, #13
IT	EQ
BEQ	L_UART2_Rx110
LDRB	R0, [SP, #4]
CMP	R0, #10
IT	EQ
BEQ	L_UART2_Rx111
IT	AL
BAL	L_UART2_Rx112
L_UART2_Rx18:
;UART2_driver.c,187 :: 		}
L_end_UART2_Rx1:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _UART2_Rx1
_UART2_Rx2:
;UART2_driver.c,193 :: 		void UART2_Rx2(void) {
SUB	SP, SP, #8
STR	LR, [SP, #0]
;UART2_driver.c,197 :: 		switch (U2RcvBuf[0]) {
IT	AL
BAL	L_UART2_Rx214
;UART2_driver.c,201 :: 		case 'a':  // Diagnostic test for UART2
L_UART2_Rx216:
;UART2_driver.c,202 :: 		UART2_PutQueue("Command 'a' received\r\n");
MOVW	R0, #lo_addr(?lstr1_UART2_driver+0)
MOVT	R0, #hi_addr(?lstr1_UART2_driver+0)
BL	_UART2_PutQueue+0
;UART2_driver.c,203 :: 		break;
IT	AL
BAL	L_UART2_Rx215
;UART2_driver.c,204 :: 		case 'b':
L_UART2_Rx217:
;UART2_driver.c,205 :: 		break;
IT	AL
BAL	L_UART2_Rx215
;UART2_driver.c,206 :: 		case 'c':
L_UART2_Rx218:
;UART2_driver.c,207 :: 		break;
IT	AL
BAL	L_UART2_Rx215
;UART2_driver.c,208 :: 		case 'd':
L_UART2_Rx219:
;UART2_driver.c,209 :: 		break;
IT	AL
BAL	L_UART2_Rx215
;UART2_driver.c,210 :: 		case 'e':
L_UART2_Rx220:
;UART2_driver.c,211 :: 		break;
IT	AL
BAL	L_UART2_Rx215
;UART2_driver.c,212 :: 		case 'f':
L_UART2_Rx221:
;UART2_driver.c,213 :: 		break;
IT	AL
BAL	L_UART2_Rx215
;UART2_driver.c,214 :: 		case 'g':
L_UART2_Rx222:
;UART2_driver.c,215 :: 		break;
IT	AL
BAL	L_UART2_Rx215
;UART2_driver.c,216 :: 		case 'h':
L_UART2_Rx223:
;UART2_driver.c,217 :: 		break;
IT	AL
BAL	L_UART2_Rx215
;UART2_driver.c,218 :: 		case 'i':
L_UART2_Rx224:
;UART2_driver.c,219 :: 		break;
IT	AL
BAL	L_UART2_Rx215
;UART2_driver.c,220 :: 		case 'j':
L_UART2_Rx225:
;UART2_driver.c,221 :: 		break;
IT	AL
BAL	L_UART2_Rx215
;UART2_driver.c,222 :: 		case 'k':
L_UART2_Rx226:
;UART2_driver.c,223 :: 		break;
IT	AL
BAL	L_UART2_Rx215
;UART2_driver.c,224 :: 		case 'l':
L_UART2_Rx227:
;UART2_driver.c,225 :: 		break;
IT	AL
BAL	L_UART2_Rx215
;UART2_driver.c,226 :: 		case 'm':
L_UART2_Rx228:
;UART2_driver.c,227 :: 		break;
IT	AL
BAL	L_UART2_Rx215
;UART2_driver.c,228 :: 		case 'n':
L_UART2_Rx229:
;UART2_driver.c,229 :: 		break;
IT	AL
BAL	L_UART2_Rx215
;UART2_driver.c,230 :: 		case 'o':
L_UART2_Rx230:
;UART2_driver.c,231 :: 		break;
IT	AL
BAL	L_UART2_Rx215
;UART2_driver.c,232 :: 		case 'p':
L_UART2_Rx231:
;UART2_driver.c,233 :: 		break;
IT	AL
BAL	L_UART2_Rx215
;UART2_driver.c,234 :: 		case 'q':
L_UART2_Rx232:
;UART2_driver.c,235 :: 		break;
IT	AL
BAL	L_UART2_Rx215
;UART2_driver.c,236 :: 		case 'r':
L_UART2_Rx233:
;UART2_driver.c,237 :: 		break;
IT	AL
BAL	L_UART2_Rx215
;UART2_driver.c,238 :: 		case 's':
L_UART2_Rx234:
;UART2_driver.c,239 :: 		break;
IT	AL
BAL	L_UART2_Rx215
;UART2_driver.c,240 :: 		case 't':
L_UART2_Rx235:
;UART2_driver.c,241 :: 		break;
IT	AL
BAL	L_UART2_Rx215
;UART2_driver.c,242 :: 		case 'u':
L_UART2_Rx236:
;UART2_driver.c,243 :: 		break;
IT	AL
BAL	L_UART2_Rx215
;UART2_driver.c,244 :: 		case 'v':
L_UART2_Rx237:
;UART2_driver.c,245 :: 		break;
IT	AL
BAL	L_UART2_Rx215
;UART2_driver.c,246 :: 		case 'w':
L_UART2_Rx238:
;UART2_driver.c,247 :: 		break;
IT	AL
BAL	L_UART2_Rx215
;UART2_driver.c,248 :: 		case 'x':
L_UART2_Rx239:
;UART2_driver.c,249 :: 		break;
IT	AL
BAL	L_UART2_Rx215
;UART2_driver.c,250 :: 		case 'y':
L_UART2_Rx240:
;UART2_driver.c,251 :: 		break;
IT	AL
BAL	L_UART2_Rx215
;UART2_driver.c,252 :: 		case 'z': // Force a system reset
L_UART2_Rx241:
;UART2_driver.c,253 :: 		SystemReset();
BL	_SystemReset+0
;UART2_driver.c,254 :: 		break;
IT	AL
BAL	L_UART2_Rx215
;UART2_driver.c,256 :: 		default:
L_UART2_Rx242:
;UART2_driver.c,257 :: 		UART2_PutQueue("Unknown command: ");
MOVW	R0, #lo_addr(?lstr2_UART2_driver+0)
MOVT	R0, #hi_addr(?lstr2_UART2_driver+0)
BL	_UART2_PutQueue+0
;UART2_driver.c,259 :: 		BufNum = GetBuffer();    // Get a free buffer
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;UART2_driver.c,260 :: 		(void)sprintf(BufNum,"%c\r\n",U2RcvBuf[0]);
MOVW	R1, #lo_addr(_U2RcvBuf+0)
MOVT	R1, #hi_addr(_U2RcvBuf+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_3_UART2_driver+0)
MOVT	R1, #hi_addr(?lstr_3_UART2_driver+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;UART2_driver.c,261 :: 		UART2_PutQueue(BufNum);  // Send the message
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_UART2_PutQueue+0
;UART2_driver.c,262 :: 		break;
IT	AL
BAL	L_UART2_Rx215
;UART2_driver.c,263 :: 		}
L_UART2_Rx214:
MOVW	R0, #lo_addr(_U2RcvBuf+0)
MOVT	R0, #hi_addr(_U2RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #97
IT	EQ
BEQ	L_UART2_Rx216
MOVW	R0, #lo_addr(_U2RcvBuf+0)
MOVT	R0, #hi_addr(_U2RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #98
IT	EQ
BEQ	L_UART2_Rx217
MOVW	R0, #lo_addr(_U2RcvBuf+0)
MOVT	R0, #hi_addr(_U2RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #99
IT	EQ
BEQ	L_UART2_Rx218
MOVW	R0, #lo_addr(_U2RcvBuf+0)
MOVT	R0, #hi_addr(_U2RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #100
IT	EQ
BEQ	L_UART2_Rx219
MOVW	R0, #lo_addr(_U2RcvBuf+0)
MOVT	R0, #hi_addr(_U2RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #101
IT	EQ
BEQ	L_UART2_Rx220
MOVW	R0, #lo_addr(_U2RcvBuf+0)
MOVT	R0, #hi_addr(_U2RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #102
IT	EQ
BEQ	L_UART2_Rx221
MOVW	R0, #lo_addr(_U2RcvBuf+0)
MOVT	R0, #hi_addr(_U2RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #103
IT	EQ
BEQ	L_UART2_Rx222
MOVW	R0, #lo_addr(_U2RcvBuf+0)
MOVT	R0, #hi_addr(_U2RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #104
IT	EQ
BEQ	L_UART2_Rx223
MOVW	R0, #lo_addr(_U2RcvBuf+0)
MOVT	R0, #hi_addr(_U2RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #105
IT	EQ
BEQ	L_UART2_Rx224
MOVW	R0, #lo_addr(_U2RcvBuf+0)
MOVT	R0, #hi_addr(_U2RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #106
IT	EQ
BEQ	L_UART2_Rx225
MOVW	R0, #lo_addr(_U2RcvBuf+0)
MOVT	R0, #hi_addr(_U2RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #107
IT	EQ
BEQ	L_UART2_Rx226
MOVW	R0, #lo_addr(_U2RcvBuf+0)
MOVT	R0, #hi_addr(_U2RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #108
IT	EQ
BEQ	L_UART2_Rx227
MOVW	R0, #lo_addr(_U2RcvBuf+0)
MOVT	R0, #hi_addr(_U2RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #109
IT	EQ
BEQ	L_UART2_Rx228
MOVW	R0, #lo_addr(_U2RcvBuf+0)
MOVT	R0, #hi_addr(_U2RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #110
IT	EQ
BEQ	L_UART2_Rx229
MOVW	R0, #lo_addr(_U2RcvBuf+0)
MOVT	R0, #hi_addr(_U2RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #111
IT	EQ
BEQ	L_UART2_Rx230
MOVW	R0, #lo_addr(_U2RcvBuf+0)
MOVT	R0, #hi_addr(_U2RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #112
IT	EQ
BEQ	L_UART2_Rx231
MOVW	R0, #lo_addr(_U2RcvBuf+0)
MOVT	R0, #hi_addr(_U2RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #113
IT	EQ
BEQ	L_UART2_Rx232
MOVW	R0, #lo_addr(_U2RcvBuf+0)
MOVT	R0, #hi_addr(_U2RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #114
IT	EQ
BEQ	L_UART2_Rx233
MOVW	R0, #lo_addr(_U2RcvBuf+0)
MOVT	R0, #hi_addr(_U2RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #115
IT	EQ
BEQ	L_UART2_Rx234
MOVW	R0, #lo_addr(_U2RcvBuf+0)
MOVT	R0, #hi_addr(_U2RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #116
IT	EQ
BEQ	L_UART2_Rx235
MOVW	R0, #lo_addr(_U2RcvBuf+0)
MOVT	R0, #hi_addr(_U2RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #117
IT	EQ
BEQ	L_UART2_Rx236
MOVW	R0, #lo_addr(_U2RcvBuf+0)
MOVT	R0, #hi_addr(_U2RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #118
IT	EQ
BEQ	L_UART2_Rx237
MOVW	R0, #lo_addr(_U2RcvBuf+0)
MOVT	R0, #hi_addr(_U2RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #119
IT	EQ
BEQ	L_UART2_Rx238
MOVW	R0, #lo_addr(_U2RcvBuf+0)
MOVT	R0, #hi_addr(_U2RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #120
IT	EQ
BEQ	L_UART2_Rx239
MOVW	R0, #lo_addr(_U2RcvBuf+0)
MOVT	R0, #hi_addr(_U2RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #121
IT	EQ
BEQ	L_UART2_Rx240
MOVW	R0, #lo_addr(_U2RcvBuf+0)
MOVT	R0, #hi_addr(_U2RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #122
IT	EQ
BEQ	L_UART2_Rx241
IT	AL
BAL	L_UART2_Rx242
L_UART2_Rx215:
;UART2_driver.c,264 :: 		U2_RxFuncPtr = UART2_Rx1;     // Go back to state 1
MOVW	R1, #lo_addr(_UART2_Rx1+0)
MOVT	R1, #hi_addr(_UART2_Rx1+0)
MOVW	R0, #lo_addr(_U2_RxFuncPtr+0)
MOVT	R0, #hi_addr(_U2_RxFuncPtr+0)
STR	R1, [R0, #0]
;UART2_driver.c,265 :: 		}
L_end_UART2_Rx2:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _UART2_Rx2
_UART2_RcvTask:
;UART2_driver.c,271 :: 		void UART2_RcvTask(void *pvParameters) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;UART2_driver.c,273 :: 		UART2_RcvInit();
BL	_UART2_RcvInit+0
;UART2_driver.c,275 :: 		while (1) {
L_UART2_RcvTask43:
;UART2_driver.c,276 :: 		UART2_Rx();    // Check for incoming UART2 messages
BL	_UART2_Rx+0
;UART2_driver.c,280 :: 		}
IT	AL
BAL	L_UART2_RcvTask43
;UART2_driver.c,281 :: 		}
L_end_UART2_RcvTask:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART2_RcvTask
_UART2_PutQueue:
;UART2_driver.c,297 :: 		void UART2_PutQueue(char *msg) {
SUB	SP, SP, #8
STR	LR, [SP, #0]
STR	R0, [SP, #4]
;UART2_driver.c,300 :: 		rtnCode = xQueueSend(U2XmtPointerQueue, &msg, 0); // No blocking
ADD	R2, SP, #4
MOVW	R1, #lo_addr(_U2XmtPointerQueue+0)
MOVT	R1, #hi_addr(_U2XmtPointerQueue+0)
LDR	R1, [R1, #0]
MOV	R3, #0
MOV	R0, R1
MOV	R1, R2
MOVS	R2, #0
BL	_xQueueGenericSend+0
;UART2_driver.c,302 :: 		if (rtnCode == pdFAIL)
CMP	R0, #0
IT	NE
BNE	L_UART2_PutQueue45
;UART2_driver.c,303 :: 		USB_PutQueue("Failed to enter message pointer into UART2 queue\r\n");
MOVW	R1, #lo_addr(?lstr4_UART2_driver+0)
MOVT	R1, #hi_addr(?lstr4_UART2_driver+0)
MOV	R0, R1
BL	_USB_PutQueue+0
L_UART2_PutQueue45:
;UART2_driver.c,304 :: 		}
L_end_UART2_PutQueue:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _UART2_PutQueue
_UART2_StartTx:
;UART2_driver.c,309 :: 		void UART2_StartTx(void) {
;UART2_driver.c,310 :: 		TXEIE_USART2_CR1_bit = 1;         // Interrupt when transmit buffer is empty (TXE=1)
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(TXEIE_USART2_CR1_bit+0)
MOVT	R0, #hi_addr(TXEIE_USART2_CR1_bit+0)
_SX	[R0, ByteOffset(TXEIE_USART2_CR1_bit+0)]
;UART2_driver.c,311 :: 		}
L_end_UART2_StartTx:
BX	LR
; end of _UART2_StartTx
_UART2_SendMsg:
;UART2_driver.c,316 :: 		void UART2_SendMsg(char *s) {
; s start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; s end address is: 0 (R0)
; s start address is: 0 (R0)
;UART2_driver.c,317 :: 		U2XmtBuf = s;            // Pointer to the message for the interrupt handler
MOVW	R1, #lo_addr(_U2XmtBuf+0)
MOVT	R1, #hi_addr(_U2XmtBuf+0)
STR	R0, [R1, #0]
; s end address is: 0 (R0)
;UART2_driver.c,318 :: 		U2XmtBufPtr = 0;         // Set character counter to start of text message
MOVS	R2, #0
MOVW	R1, #lo_addr(_U2XmtBufPtr+0)
MOVT	R1, #hi_addr(_U2XmtBufPtr+0)
STRB	R2, [R1, #0]
;UART2_driver.c,319 :: 		UART2_StartTx();         // Start the transmitter
BL	_UART2_StartTx+0
;UART2_driver.c,320 :: 		}
L_end_UART2_SendMsg:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART2_SendMsg
_UART2_Tx:
;UART2_driver.c,326 :: 		void UART2_Tx(void) {
SUB	SP, SP, #8
STR	LR, [SP, #0]
;UART2_driver.c,330 :: 		xSemaphoreTake(U2XmtSemHandle, portMAX_DELAY); // Block here
MOVW	R0, #lo_addr(_U2XmtSemHandle+0)
MOVT	R0, #hi_addr(_U2XmtSemHandle+0)
LDR	R0, [R0, #0]
MOV	R3, #0
MOV	R2, #-1
MOVS	R1, #0
BL	_xQueueGenericReceive+0
;UART2_driver.c,331 :: 		rtnCode = xQueueReceive(U2XmtPointerQueue, &pcReceivedAddr, 0xFFFFFFFFU); // Block here
ADD	R1, SP, #4
MOVW	R0, #lo_addr(_U2XmtPointerQueue+0)
MOVT	R0, #hi_addr(_U2XmtPointerQueue+0)
LDR	R0, [R0, #0]
MOV	R3, #0
MOV	R2, #-1
BL	_xQueueGenericReceive+0
;UART2_driver.c,333 :: 		UART2_SendMsg(pcReceivedAddr);
LDR	R0, [SP, #4]
BL	_UART2_SendMsg+0
;UART2_driver.c,334 :: 		}
L_end_UART2_Tx:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _UART2_Tx
_UART2_XmtTask:
;UART2_driver.c,340 :: 		void UART2_XmtTask(void *pvParameters) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;UART2_driver.c,342 :: 		U2XmtSemHandle = xSemaphoreCreateBinary(); // Semaphore indicating transmitter is idle
MOVS	R2, #3
MOVS	R1, #0
MOV	R0, #1
BL	_xQueueGenericCreate+0
MOVW	R1, #lo_addr(_U2XmtSemHandle+0)
MOVT	R1, #hi_addr(_U2XmtSemHandle+0)
STR	R0, [R1, #0]
;UART2_driver.c,345 :: 		U2XmtPointerQueue = xQueueCreate(64, sizeof(char *)); // Queue of message pointers
MOVS	R2, #0
MOVS	R1, #4
MOVS	R0, #64
BL	_xQueueGenericCreate+0
MOVW	R1, #lo_addr(_U2XmtPointerQueue+0)
MOVT	R1, #hi_addr(_U2XmtPointerQueue+0)
STR	R0, [R1, #0]
;UART2_driver.c,348 :: 		xSemaphoreGive(U2XmtSemHandle); // Initialize semaphore
MOVW	R1, #lo_addr(_U2XmtSemHandle+0)
MOVT	R1, #hi_addr(_U2XmtSemHandle+0)
LDR	R1, [R1, #0]
MOV	R3, #0
MOV	R2, #0
MOV	R0, R1
MOVS	R1, #0
BL	_xQueueGenericSend+0
;UART2_driver.c,349 :: 		UART2_PutQueue("UART2 task started\r\n");
MOVW	R1, #lo_addr(?lstr5_UART2_driver+0)
MOVT	R1, #hi_addr(?lstr5_UART2_driver+0)
MOV	R0, R1
BL	_UART2_PutQueue+0
;UART2_driver.c,351 :: 		while (1) {
L_UART2_XmtTask46:
;UART2_driver.c,352 :: 		UART2_Tx();    // Check for outgoing UART2 messages
BL	_UART2_Tx+0
;UART2_driver.c,356 :: 		}
IT	AL
BAL	L_UART2_XmtTask46
;UART2_driver.c,357 :: 		}
L_end_UART2_XmtTask:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART2_XmtTask
