MyTimers_ucPortCountLeadingZeros:
;portmacro.h,183 :: 		static inline uint8_t ucPortCountLeadingZeros(uint32_t ulBitmap)
;portmacro.h,185 :: 		asm CLZ R0, R0;
CLZ	R0, R0
;portmacro.h,186 :: 		return R0;
UXTB	R0, R0
;portmacro.h,187 :: 		}
L_end_ucPortCountLeadingZeros:
BX	LR
; end of MyTimers_ucPortCountLeadingZeros
MyTimers_vPortRaiseBASEPRI:
;portmacro.h,229 :: 		portFORCE_INLINE static void vPortRaiseBASEPRI( void )
;portmacro.h,234 :: 		CPU_REG_SET(CPU_BASEPRI, ulNewBASEPRI);
MOV	R0, #16
MOV	R12, R0
MSR	#17, R12
;portmacro.h,236 :: 		asm ISB;
ISB	#15
;portmacro.h,237 :: 		asm DSB;
DSB	#15
;portmacro.h,238 :: 		}
L_end_vPortRaiseBASEPRI:
BX	LR
; end of MyTimers_vPortRaiseBASEPRI
MyTimers_ulPortRaiseBASEPRI:
;portmacro.h,241 :: 		portFORCE_INLINE static uint32_t ulPortRaiseBASEPRI( void )
;portmacro.h,245 :: 		ulOriginalBASEPRI = CPU_REG_GET(CPU_BASEPRI);
MRS	R12, #17
MOV	R0, R12
; ulOriginalBASEPRI start address is: 4 (R1)
MOV	R1, R0
;portmacro.h,247 :: 		CPU_REG_SET(CPU_BASEPRI, ulNewBASEPRI);
MOV	R0, #16
MOV	R12, R0
MSR	#17, R12
;portmacro.h,249 :: 		asm ISB;
ISB	#15
;portmacro.h,250 :: 		asm DSB;
DSB	#15
;portmacro.h,254 :: 		return ulOriginalBASEPRI;
MOV	R0, R1
; ulOriginalBASEPRI end address is: 4 (R1)
;portmacro.h,255 :: 		}
L_end_ulPortRaiseBASEPRI:
BX	LR
; end of MyTimers_ulPortRaiseBASEPRI
MyTimers_vPortSetBASEPRI:
;portmacro.h,258 :: 		portFORCE_INLINE static void vPortSetBASEPRI( uint32_t ulNewMaskValue )
; ulNewMaskValue start address is: 0 (R0)
; ulNewMaskValue end address is: 0 (R0)
; ulNewMaskValue start address is: 0 (R0)
;portmacro.h,260 :: 		CPU_REG_SET(CPU_BASEPRI, ulNewMaskValue);
MOV	R1, R0
; ulNewMaskValue end address is: 0 (R0)
MOV	R12, R1
MSR	#17, R12
;portmacro.h,261 :: 		}
L_end_vPortSetBASEPRI:
BX	LR
; end of MyTimers_vPortSetBASEPRI
_Timer_Initialize:
;MyTimers.c,107 :: 		void Timer_Initialize(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,108 :: 		init_timerpool();        // Make all timers free
BL	_init_timerpool+0
;MyTimers.c,109 :: 		Timer11_Initialize();    // This timer is used instead of SysTick for softwre timers
BL	_Timer11_Initialize+0
;MyTimers.c,110 :: 		Timer11_Start();
BL	_Timer11_Start+0
;MyTimers.c,111 :: 		}
L_end_Timer_Initialize:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer_Initialize
_TimerCheck:
;MyTimers.c,116 :: 		void TimerCheck() {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,117 :: 		if (TimerFlag == 1) {
MOVW	R0, #lo_addr(_TimerFlag+0)
MOVT	R0, #hi_addr(_TimerFlag+0)
LDRSH	R0, [R0, #0]
CMP	R0, #1
IT	NE
BNE	L_TimerCheck0
;MyTimers.c,118 :: 		TimerFlag = 0;                 // Reset 1 second flag
MOVS	R1, #0
SXTH	R1, R1
MOVW	R0, #lo_addr(_TimerFlag+0)
MOVT	R0, #hi_addr(_TimerFlag+0)
STRH	R1, [R0, #0]
;MyTimers.c,120 :: 		IndTog();                      // Diagnostic
BL	_IndTog+0
;MyTimers.c,121 :: 		}
L_TimerCheck0:
;MyTimers.c,122 :: 		}
L_end_TimerCheck:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _TimerCheck
_init_timerpool:
;MyTimers.c,149 :: 		void init_timerpool(void) {
;MyTimers.c,152 :: 		for (i=0; i < NUMTIMERS; i++) {
; i start address is: 8 (R2)
MOVS	R2, #0
; i end address is: 8 (R2)
L_init_timerpool1:
; i start address is: 8 (R2)
CMP	R2, #15
IT	CS
BCS	L_init_timerpool2
;MyTimers.c,153 :: 		TimerPool[i].TimerField = 0;
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R1, R0, R1
MOVS	R0, #0
STR	R0, [R1, #0]
;MyTimers.c,154 :: 		TimerPool[i].Free = TRUE;
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
ADDS	R1, R0, #4
MOVS	R0, #1
STRB	R0, [R1, #0]
;MyTimers.c,152 :: 		for (i=0; i < NUMTIMERS; i++) {
ADDS	R2, R2, #1
UXTB	R2, R2
;MyTimers.c,155 :: 		}
; i end address is: 8 (R2)
IT	AL
BAL	L_init_timerpool1
L_init_timerpool2:
;MyTimers.c,156 :: 		}
L_end_init_timerpool:
BX	LR
; end of _init_timerpool
_get_timer:
;MyTimers.c,164 :: 		unsigned short int get_timer(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,167 :: 		for (i=0; i < NUMTIMERS; i++) {
; i start address is: 8 (R2)
MOVS	R2, #0
; i end address is: 8 (R2)
L_get_timer4:
; i start address is: 8 (R2)
CMP	R2, #15
IT	CS
BCS	L_get_timer5
;MyTimers.c,168 :: 		if (TimerPool[i].Free == TRUE) {  // If a free timer is found
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
ADDS	R0, R0, #4
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	NE
BNE	L_get_timer7
;MyTimers.c,169 :: 		TimerPool[i].Free = FALSE;    // Mark it reserved
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
ADDS	R1, R0, #4
MOVS	R0, #0
STRB	R0, [R1, #0]
;MyTimers.c,170 :: 		return i;                     // Return timer handle
UXTB	R0, R2
; i end address is: 8 (R2)
IT	AL
BAL	L_end_get_timer
;MyTimers.c,171 :: 		}
L_get_timer7:
;MyTimers.c,167 :: 		for (i=0; i < NUMTIMERS; i++) {
; i start address is: 8 (R2)
ADDS	R2, R2, #1
UXTB	R2, R2
;MyTimers.c,172 :: 		}
; i end address is: 8 (R2)
IT	AL
BAL	L_get_timer4
L_get_timer5:
;MyTimers.c,175 :: 		USB_PutQueue("TIMERS: No Timers, Resetting..\r\n");
MOVW	R0, #lo_addr(?lstr1_MyTimers+0)
MOVT	R0, #hi_addr(?lstr1_MyTimers+0)
BL	_USB_PutQueue+0
;MyTimers.c,176 :: 		SystemReset();
BL	_SystemReset+0
;MyTimers.c,177 :: 		return (0);
MOVS	R0, #0
;MyTimers.c,178 :: 		}
L_end_get_timer:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _get_timer
_free_timer:
;MyTimers.c,186 :: 		void free_timer(unsigned short int nbr) {
; nbr start address is: 0 (R0)
; nbr end address is: 0 (R0)
; nbr start address is: 0 (R0)
;MyTimers.c,187 :: 		if (nbr > (NUMTIMERS-1))          // Make a simple check
CMP	R0, #14
IT	LE
BLE	L_free_timer8
; nbr end address is: 0 (R0)
;MyTimers.c,188 :: 		return;
IT	AL
BAL	L_end_free_timer
L_free_timer8:
;MyTimers.c,190 :: 		TimerPool[nbr].Free = TRUE;
; nbr start address is: 0 (R0)
LSLS	R2, R0, #3
; nbr end address is: 0 (R0)
MOVW	R1, #lo_addr(_TimerPool+0)
MOVT	R1, #hi_addr(_TimerPool+0)
ADDS	R1, R1, R2
ADDS	R2, R1, #4
MOVS	R1, #1
STRB	R1, [R2, #0]
;MyTimers.c,191 :: 		}
L_end_free_timer:
BX	LR
; end of _free_timer
_set_timer:
;MyTimers.c,200 :: 		void set_timer(unsigned short int nbr, unsigned long int tout) {
; tout start address is: 4 (R1)
; nbr start address is: 0 (R0)
; tout end address is: 4 (R1)
; nbr end address is: 0 (R0)
; nbr start address is: 0 (R0)
; tout start address is: 4 (R1)
;MyTimers.c,201 :: 		if (nbr > (NUMTIMERS-1))          // Make a simple check
CMP	R0, #14
IT	LE
BLE	L_set_timer9
; nbr end address is: 0 (R0)
; tout end address is: 4 (R1)
;MyTimers.c,202 :: 		return;
IT	AL
BAL	L_end_set_timer
L_set_timer9:
;MyTimers.c,204 :: 		if (TimerPool[nbr].Free == TRUE)
; tout start address is: 4 (R1)
; nbr start address is: 0 (R0)
LSLS	R3, R0, #3
MOVW	R2, #lo_addr(_TimerPool+0)
MOVT	R2, #hi_addr(_TimerPool+0)
ADDS	R2, R2, R3
ADDS	R2, R2, #4
LDRB	R2, [R2, #0]
CMP	R2, #1
IT	NE
BNE	L_set_timer10
; nbr end address is: 0 (R0)
; tout end address is: 4 (R1)
;MyTimers.c,205 :: 		return;
IT	AL
BAL	L_end_set_timer
L_set_timer10:
;MyTimers.c,207 :: 		TimerPool[nbr].TimerField = tout;
; tout start address is: 4 (R1)
; nbr start address is: 0 (R0)
LSLS	R3, R0, #3
; nbr end address is: 0 (R0)
MOVW	R2, #lo_addr(_TimerPool+0)
MOVT	R2, #hi_addr(_TimerPool+0)
ADDS	R2, R2, R3
STR	R1, [R2, #0]
; tout end address is: 4 (R1)
;MyTimers.c,208 :: 		}
L_end_set_timer:
BX	LR
; end of _set_timer
_check_timer:
;MyTimers.c,216 :: 		unsigned long int check_timer(unsigned short int nbr) {
; nbr start address is: 0 (R0)
; nbr end address is: 0 (R0)
; nbr start address is: 0 (R0)
;MyTimers.c,217 :: 		return TimerPool[nbr].TimerField;
LSLS	R2, R0, #3
; nbr end address is: 0 (R0)
MOVW	R1, #lo_addr(_TimerPool+0)
MOVT	R1, #hi_addr(_TimerPool+0)
ADDS	R1, R1, R2
LDR	R1, [R1, #0]
MOV	R0, R1
;MyTimers.c,218 :: 		}
L_end_check_timer:
BX	LR
; end of _check_timer
_irqhandler_timer:
;MyTimers.c,226 :: 		void irqhandler_timer(void) {
;MyTimers.c,229 :: 		for (i=0; i<NUMTIMERS; i++) {
; i start address is: 8 (R2)
MOVS	R2, #0
; i end address is: 8 (R2)
L_irqhandler_timer11:
; i start address is: 8 (R2)
CMP	R2, #15
IT	CS
BCS	L_irqhandler_timer12
;MyTimers.c,230 :: 		if (TimerPool[i].Free == FALSE && TimerPool[i].TimerField != 0)
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
ADDS	R0, R0, #4
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L__irqhandler_timer38
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
LDR	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L__irqhandler_timer37
L__irqhandler_timer36:
;MyTimers.c,231 :: 		TimerPool[i].TimerField--;
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R1, R0, R1
LDR	R0, [R1, #0]
SUBS	R0, R0, #1
STR	R0, [R1, #0]
;MyTimers.c,230 :: 		if (TimerPool[i].Free == FALSE && TimerPool[i].TimerField != 0)
L__irqhandler_timer38:
L__irqhandler_timer37:
;MyTimers.c,229 :: 		for (i=0; i<NUMTIMERS; i++) {
ADDS	R2, R2, #1
UXTB	R2, R2
;MyTimers.c,232 :: 		}
; i end address is: 8 (R2)
IT	AL
BAL	L_irqhandler_timer11
L_irqhandler_timer12:
;MyTimers.c,233 :: 		}
L_end_irqhandler_timer:
BX	LR
; end of _irqhandler_timer
_Timer1_Initialize:
;MyTimers.c,250 :: 		void Timer1_Initialize(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,255 :: 		Ratio = PWM_TIM1_Init(50);  // Set frequency to 50Hz or period to 20ms
MOVS	R0, #50
BL	_PWM_TIM1_Init+0
MOVW	R1, #lo_addr(_Ratio+0)
MOVT	R1, #hi_addr(_Ratio+0)
STRH	R0, [R1, #0]
;MyTimers.c,256 :: 		PWM_TIM1_Set_Duty(Ratio/2, _PWM_NON_INVERTED, _PWM_CHANNEL1);  // Set duty cycle to one-half of period
LSRS	R0, R0, #1
MOVS	R2, #0
MOVS	R1, #0
BL	_PWM_TIM1_Set_Duty+0
;MyTimers.c,257 :: 		PWM_TIM1_Start(_PWM_CHANNEL1, &_GPIO_MODULE_TIM1_CH1_PE9);
MOVW	R1, #lo_addr(__GPIO_MODULE_TIM1_CH1_PE9+0)
MOVT	R1, #hi_addr(__GPIO_MODULE_TIM1_CH1_PE9+0)
MOVS	R0, #0
BL	_PWM_TIM1_Start+0
;MyTimers.c,260 :: 		TIM1_PSC = 49;          // Set the prescale register to divide by 49+1=50
MOVS	R1, #49
MOVW	R0, #lo_addr(TIM1_PSC+0)
MOVT	R0, #hi_addr(TIM1_PSC+0)
STR	R1, [R0, #0]
;MyTimers.c,261 :: 		TIM1_ARR = 24000;       // Set the auto-load register to divide by 24000
MOVW	R1, #24000
MOVW	R0, #lo_addr(TIM1_ARR+0)
MOVT	R0, #hi_addr(TIM1_ARR+0)
STR	R1, [R0, #0]
;MyTimers.c,265 :: 		TIM1_CCR1 = 12000;      // The count to be loaded into TIM1_CCR1 is 10/20*24000=12000
MOVW	R1, #12000
MOVW	R0, #lo_addr(TIM1_CCR1+0)
MOVT	R0, #hi_addr(TIM1_CCR1+0)
STR	R1, [R0, #0]
;MyTimers.c,266 :: 		Ratio = TIM1_CCR1;      // Replace library value with calculated value
MOVW	R0, #lo_addr(TIM1_CCR1+0)
MOVT	R0, #hi_addr(TIM1_CCR1+0)
LDR	R1, [R0, #0]
MOVW	R0, #lo_addr(_Ratio+0)
MOVT	R0, #hi_addr(_Ratio+0)
STRH	R1, [R0, #0]
;MyTimers.c,267 :: 		CEN_bit = 1;            // Enable counter
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(CEN_bit+0)
MOVT	R0, #hi_addr(CEN_bit+0)
_SX	[R0, ByteOffset(CEN_bit+0)]
;MyTimers.c,268 :: 		}
L_end_Timer1_Initialize:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer1_Initialize
_PwmUp:
;MyTimers.c,273 :: 		void PwmUp(void) {
SUB	SP, SP, #8
STR	LR, [SP, #0]
;MyTimers.c,276 :: 		Ratio = TIM1_CCR1;
MOVW	R0, #lo_addr(TIM1_CCR1+0)
MOVT	R0, #hi_addr(TIM1_CCR1+0)
LDR	R1, [R0, #0]
MOVW	R0, #lo_addr(_Ratio+0)
MOVT	R0, #hi_addr(_Ratio+0)
STRH	R1, [R0, #0]
;MyTimers.c,277 :: 		if (Ratio < 24000) {
LDRH	R1, [R0, #0]
MOVW	R0, #24000
CMP	R1, R0
IT	CS
BCS	L_PwmUp17
;MyTimers.c,278 :: 		Ratio += 480;
MOVW	R2, #lo_addr(_Ratio+0)
MOVT	R2, #hi_addr(_Ratio+0)
LDRH	R0, [R2, #0]
ADD	R1, R0, #480
UXTH	R1, R1
STRH	R1, [R2, #0]
;MyTimers.c,279 :: 		TIM1_CCR1 = Ratio;
MOVW	R0, #lo_addr(TIM1_CCR1+0)
MOVT	R0, #hi_addr(TIM1_CCR1+0)
STR	R1, [R0, #0]
;MyTimers.c,280 :: 		}
L_PwmUp17:
;MyTimers.c,282 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;MyTimers.c,283 :: 		sprintf(BufNum,"Duty: %d\r\n",Ratio);
MOVW	R1, #lo_addr(_Ratio+0)
MOVT	R1, #hi_addr(_Ratio+0)
LDRH	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_2_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_2_MyTimers+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;MyTimers.c,284 :: 		USB_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_USB_PutQueue+0
;MyTimers.c,285 :: 		}
L_end_PwmUp:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _PwmUp
_PwmDn:
;MyTimers.c,290 :: 		void PwmDn(void) {
SUB	SP, SP, #8
STR	LR, [SP, #0]
;MyTimers.c,293 :: 		Ratio = TIM1_CCR1;
MOVW	R0, #lo_addr(TIM1_CCR1+0)
MOVT	R0, #hi_addr(TIM1_CCR1+0)
LDR	R1, [R0, #0]
MOVW	R0, #lo_addr(_Ratio+0)
MOVT	R0, #hi_addr(_Ratio+0)
STRH	R1, [R0, #0]
;MyTimers.c,294 :: 		if (Ratio > 0) {
LDRH	R0, [R0, #0]
CMP	R0, #0
IT	LS
BLS	L_PwmDn18
;MyTimers.c,295 :: 		Ratio -= 480;
MOVW	R2, #lo_addr(_Ratio+0)
MOVT	R2, #hi_addr(_Ratio+0)
LDRH	R0, [R2, #0]
SUB	R1, R0, #480
UXTH	R1, R1
STRH	R1, [R2, #0]
;MyTimers.c,296 :: 		TIM1_CCR1 = Ratio;
MOVW	R0, #lo_addr(TIM1_CCR1+0)
MOVT	R0, #hi_addr(TIM1_CCR1+0)
STR	R1, [R0, #0]
;MyTimers.c,297 :: 		}
L_PwmDn18:
;MyTimers.c,299 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;MyTimers.c,300 :: 		sprintf(BufNum,"Duty: %d\r\n",Ratio);
MOVW	R1, #lo_addr(_Ratio+0)
MOVT	R1, #hi_addr(_Ratio+0)
LDRH	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_3_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_3_MyTimers+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;MyTimers.c,301 :: 		USB_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_USB_PutQueue+0
;MyTimers.c,302 :: 		}
L_end_PwmDn:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _PwmDn
_PwmMaxOn:
;MyTimers.c,307 :: 		void PwmMaxOn(void) {
SUB	SP, SP, #8
STR	LR, [SP, #0]
;MyTimers.c,310 :: 		Ratio = 24000;
MOVW	R1, #24000
MOVW	R0, #lo_addr(_Ratio+0)
MOVT	R0, #hi_addr(_Ratio+0)
STRH	R1, [R0, #0]
;MyTimers.c,311 :: 		TIM1_CCR1 = Ratio;
MOVW	R1, #24000
MOVW	R0, #lo_addr(TIM1_CCR1+0)
MOVT	R0, #hi_addr(TIM1_CCR1+0)
STR	R1, [R0, #0]
;MyTimers.c,314 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,315 :: 		sprintf(BufNum,"Duty: %d\r\n",Ratio);
MOVW	R1, #lo_addr(_Ratio+0)
MOVT	R1, #hi_addr(_Ratio+0)
LDRH	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_4_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_4_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,316 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,317 :: 		}
L_end_PwmMaxOn:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _PwmMaxOn
_PwmMaxOff:
;MyTimers.c,322 :: 		void PwmMaxOff(void) {
SUB	SP, SP, #8
STR	LR, [SP, #0]
;MyTimers.c,325 :: 		Ratio = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Ratio+0)
MOVT	R0, #hi_addr(_Ratio+0)
STRH	R1, [R0, #0]
;MyTimers.c,326 :: 		TIM1_CCR1 = Ratio;
MOVW	R1, #0
MOVW	R0, #lo_addr(TIM1_CCR1+0)
MOVT	R0, #hi_addr(TIM1_CCR1+0)
STR	R1, [R0, #0]
;MyTimers.c,329 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,330 :: 		sprintf(BufNum,"Duty: %d\r\n",Ratio);
MOVW	R1, #lo_addr(_Ratio+0)
MOVT	R1, #hi_addr(_Ratio+0)
LDRH	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_5_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_5_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,331 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,332 :: 		}
L_end_PwmMaxOff:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _PwmMaxOff
_Timer3Interrupt:
;MyTimers.c,339 :: 		void Timer3Interrupt() iv IVT_INT_TIM3 ics ICS_AUTO {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,340 :: 		UIF_TIM3_SR_bit = 0;
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(UIF_TIM3_SR_bit+0)
MOVT	R0, #hi_addr(UIF_TIM3_SR_bit+0)
_SX	[R0, ByteOffset(UIF_TIM3_SR_bit+0)]
;MyTimers.c,341 :: 		IndTog();
BL	_IndTog+0
;MyTimers.c,342 :: 		}
L_end_Timer3Interrupt:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer3Interrupt
_Timer3_Initialize:
;MyTimers.c,353 :: 		void Timer3_Initialize(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,364 :: 		NVIC_IntEnable(IVT_INT_TIM3);// Allow interrupts in NVIC
MOVW	R0, #45
BL	_NVIC_IntEnable+0
;MyTimers.c,367 :: 		TIM3EN_bit = 1;               // Enable TIM3 clock in RCC_APB1ENR.B1
MOVS	R2, #1
SXTB	R2, R2
MOVW	R0, #lo_addr(TIM3EN_bit+0)
MOVT	R0, #hi_addr(TIM3EN_bit+0)
_SX	[R0, ByteOffset(TIM3EN_bit+0)]
;MyTimers.c,373 :: 		TIM3_PSC  = 6000;            // Prescaler value
MOVW	R1, #6000
MOVW	R0, #lo_addr(TIM3_PSC+0)
MOVT	R0, #hi_addr(TIM3_PSC+0)
STR	R1, [R0, #0]
;MyTimers.c,374 :: 		TIM3_ARR  = 10000;           // Pulse width value
MOVW	R1, #10000
MOVW	R0, #lo_addr(TIM3_ARR+0)
MOVT	R0, #hi_addr(TIM3_ARR+0)
STR	R1, [R0, #0]
;MyTimers.c,375 :: 		TIM3_CCR1 = 10;              // Delay value
MOVS	R1, #10
MOVW	R0, #lo_addr(TIM3_CCR1+0)
MOVT	R0, #hi_addr(TIM3_CCR1+0)
STR	R1, [R0, #0]
;MyTimers.c,377 :: 		TIM3_DIER = 0x0001;          // Update interrupt enable
MOVS	R1, #1
MOVW	R0, #lo_addr(TIM3_DIER+0)
MOVT	R0, #hi_addr(TIM3_DIER+0)
STR	R1, [R0, #0]
;MyTimers.c,378 :: 		UIE_TIM3_DIER_bit = 1;       // Set update interrupt enable
MOVW	R0, #lo_addr(UIE_TIM3_DIER_bit+0)
MOVT	R0, #hi_addr(UIE_TIM3_DIER_bit+0)
_SX	[R0, ByteOffset(UIE_TIM3_DIER_bit+0)]
;MyTimers.c,379 :: 		URS_TIM3_CR1_bit = 0;        // Clear update request source
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(URS_TIM3_CR1_bit+0)
MOVT	R0, #hi_addr(URS_TIM3_CR1_bit+0)
_SX	[R0, ByteOffset(URS_TIM3_CR1_bit+0)]
;MyTimers.c,385 :: 		USB_PutQueue("Timer3 initialized\r\n");
MOVW	R0, #lo_addr(?lstr6_MyTimers+0)
MOVT	R0, #hi_addr(?lstr6_MyTimers+0)
BL	_USB_PutQueue+0
;MyTimers.c,386 :: 		}
L_end_Timer3_Initialize:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer3_Initialize
_Timer3_Ch1_Start:
;MyTimers.c,390 :: 		void Timer3_Ch1_Start(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,392 :: 		CEN_TIM3_CR1_bit = 1;         // Enable timer 3 channel 1
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(CEN_TIM3_CR1_bit+0)
MOVT	R0, #hi_addr(CEN_TIM3_CR1_bit+0)
_SX	[R0, ByteOffset(CEN_TIM3_CR1_bit+0)]
;MyTimers.c,394 :: 		USB_PutQueue("Timer3 started\r\n");
MOVW	R0, #lo_addr(?lstr7_MyTimers+0)
MOVT	R0, #hi_addr(?lstr7_MyTimers+0)
BL	_USB_PutQueue+0
;MyTimers.c,395 :: 		}
L_end_Timer3_Ch1_Start:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer3_Ch1_Start
_Timer3_Ch1_Stop:
;MyTimers.c,400 :: 		void Timer3_Ch1_Stop(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,402 :: 		CEN_TIM3_CR1_bit = 0;         // Disable timer 3 channel 1
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(CEN_TIM3_CR1_bit+0)
MOVT	R0, #hi_addr(CEN_TIM3_CR1_bit+0)
_SX	[R0, ByteOffset(CEN_TIM3_CR1_bit+0)]
;MyTimers.c,404 :: 		USB_PutQueue("Timer3 stopped\r\n");
MOVW	R0, #lo_addr(?lstr8_MyTimers+0)
MOVT	R0, #hi_addr(?lstr8_MyTimers+0)
BL	_USB_PutQueue+0
;MyTimers.c,405 :: 		}
L_end_Timer3_Ch1_Stop:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer3_Ch1_Stop
_Timer3_Update:
;MyTimers.c,410 :: 		void Timer3_Update(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,411 :: 		UG_TIM3_EGR_bit = 1;         // Generate update
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(UG_TIM3_EGR_bit+0)
MOVT	R0, #hi_addr(UG_TIM3_EGR_bit+0)
_SX	[R0, ByteOffset(UG_TIM3_EGR_bit+0)]
;MyTimers.c,412 :: 		USB_PutQueue("Timer3 interrupt generated\r\n");
MOVW	R0, #lo_addr(?lstr9_MyTimers+0)
MOVT	R0, #hi_addr(?lstr9_MyTimers+0)
BL	_USB_PutQueue+0
;MyTimers.c,413 :: 		}
L_end_Timer3_Update:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer3_Update
_Timer4Interrupt:
;MyTimers.c,422 :: 		void Timer4Interrupt() iv IVT_INT_TIM4 ics ICS_AUTO {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,423 :: 		UIF_TIM4_SR_bit = 0;
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(UIF_TIM4_SR_bit+0)
MOVT	R0, #hi_addr(UIF_TIM4_SR_bit+0)
_SX	[R0, ByteOffset(UIF_TIM4_SR_bit+0)]
;MyTimers.c,424 :: 		IndTog();
BL	_IndTog+0
;MyTimers.c,425 :: 		}
L_end_Timer4Interrupt:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer4Interrupt
_Timer4_Initialize:
;MyTimers.c,434 :: 		void Timer4_Initialize(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,435 :: 		GPIODEN_bit = 1;             // Set GPIOD clock enable bit
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIODEN_bit+0)
MOVT	R0, #hi_addr(GPIODEN_bit+0)
_SX	[R0, ByteOffset(GPIODEN_bit+0)]
;MyTimers.c,438 :: 		GPIOD_MODER &= 0xCFFFFFFF;   // Clear port D MODER-14 bits
MOVW	R0, #lo_addr(GPIOD_MODER+0)
MOVT	R0, #hi_addr(GPIOD_MODER+0)
LDR	R1, [R0, #0]
MVN	R0, #805306368
ANDS	R1, R0
MOVW	R0, #lo_addr(GPIOD_MODER+0)
MOVT	R0, #hi_addr(GPIOD_MODER+0)
STR	R1, [R0, #0]
;MyTimers.c,441 :: 		GPIOD_MODER |= 0x20000000;   // Set port D MODER-14 to 10: alternate function mode
MOVW	R0, #lo_addr(GPIOD_MODER+0)
MOVT	R0, #hi_addr(GPIOD_MODER+0)
LDR	R0, [R0, #0]
ORR	R1, R0, #536870912
MOVW	R0, #lo_addr(GPIOD_MODER+0)
MOVT	R0, #hi_addr(GPIOD_MODER+0)
STR	R1, [R0, #0]
;MyTimers.c,444 :: 		GPIOD_AFRH  &= 0xF0FFFFFF;   // Clear port D AFRH-14 bits
MOVW	R0, #lo_addr(GPIOD_AFRH+0)
MOVT	R0, #hi_addr(GPIOD_AFRH+0)
LDR	R1, [R0, #0]
MVN	R0, #251658240
ANDS	R1, R0
MOVW	R0, #lo_addr(GPIOD_AFRH+0)
MOVT	R0, #hi_addr(GPIOD_AFRH+0)
STR	R1, [R0, #0]
;MyTimers.c,447 :: 		GPIOD_AFRH  |= 0x02000000;   // Set port d AFRH-14 to 0010: AF2 TIM4_CH3
MOVW	R0, #lo_addr(GPIOD_AFRH+0)
MOVT	R0, #hi_addr(GPIOD_AFRH+0)
LDR	R0, [R0, #0]
ORR	R1, R0, #33554432
MOVW	R0, #lo_addr(GPIOD_AFRH+0)
MOVT	R0, #hi_addr(GPIOD_AFRH+0)
STR	R1, [R0, #0]
;MyTimers.c,452 :: 		NVIC_IntEnable(IVT_INT_TIM4);// Allow interrupts in NVIC
MOVW	R0, #46
BL	_NVIC_IntEnable+0
;MyTimers.c,455 :: 		TIM4EN_bit = 1;               // Enable TIM4 clock in RCC_APB1ENR.B2
MOVS	R2, #1
SXTB	R2, R2
MOVW	R0, #lo_addr(TIM4EN_bit+0)
MOVT	R0, #hi_addr(TIM4EN_bit+0)
_SX	[R0, ByteOffset(TIM4EN_bit+0)]
;MyTimers.c,457 :: 		TIM4_CR1  = 0x0008;          // Set OPM bit (one-pulse mode)
MOVS	R1, #8
MOVW	R0, #lo_addr(TIM4_CR1+0)
MOVT	R0, #hi_addr(TIM4_CR1+0)
STR	R1, [R0, #0]
;MyTimers.c,458 :: 		TIM4_ARR  = 10000;           // Pulse width value
MOVW	R1, #10000
MOVW	R0, #lo_addr(TIM4_ARR+0)
MOVT	R0, #hi_addr(TIM4_ARR+0)
STR	R1, [R0, #0]
;MyTimers.c,461 :: 		TIM4_CCR3 = 10;              // Pulse delay value for CH3
MOVS	R1, #10
MOVW	R0, #lo_addr(TIM4_CCR3+0)
MOVT	R0, #hi_addr(TIM4_CCR3+0)
STR	R1, [R0, #0]
;MyTimers.c,462 :: 		TIM4_PSC  = 99;              // Prescaler value
MOVS	R1, #99
MOVW	R0, #lo_addr(TIM4_PSC+0)
MOVT	R0, #hi_addr(TIM4_PSC+0)
STR	R1, [R0, #0]
;MyTimers.c,464 :: 		UG_TIM4_EGR_bit = 1;         // Generate update
MOVW	R0, #lo_addr(UG_TIM4_EGR_bit+0)
MOVT	R0, #hi_addr(UG_TIM4_EGR_bit+0)
_SX	[R0, ByteOffset(UG_TIM4_EGR_bit+0)]
;MyTimers.c,468 :: 		TIM4_CCMR2_Output = 0x0070;  // PWM mode 2 for CH3
MOVS	R1, #112
MOVW	R0, #lo_addr(TIM4_CCMR2_Output+0)
MOVT	R0, #hi_addr(TIM4_CCMR2_Output+0)
STR	R1, [R0, #0]
;MyTimers.c,472 :: 		TIM4_CCER = 0x0100;          // Channels 3 is connected to output
MOVW	R1, #256
MOVW	R0, #lo_addr(TIM4_CCER+0)
MOVT	R0, #hi_addr(TIM4_CCER+0)
STR	R1, [R0, #0]
;MyTimers.c,474 :: 		USB_PutQueue("Timer4 initialized\r\n");
MOVW	R0, #lo_addr(?lstr10_MyTimers+0)
MOVT	R0, #hi_addr(?lstr10_MyTimers+0)
BL	_USB_PutQueue+0
;MyTimers.c,475 :: 		}
L_end_Timer4_Initialize:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer4_Initialize
_Timer4_Ch1_Start:
;MyTimers.c,479 :: 		void Timer4_Ch1_Start(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,480 :: 		CEN_TIM4_CR1_bit = 1;         // Enable timer 4 channel 3
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(CEN_TIM4_CR1_bit+0)
MOVT	R0, #hi_addr(CEN_TIM4_CR1_bit+0)
_SX	[R0, ByteOffset(CEN_TIM4_CR1_bit+0)]
;MyTimers.c,481 :: 		USB_PutQueue("Timer4 started\r\n");
MOVW	R0, #lo_addr(?lstr11_MyTimers+0)
MOVT	R0, #hi_addr(?lstr11_MyTimers+0)
BL	_USB_PutQueue+0
;MyTimers.c,482 :: 		}
L_end_Timer4_Ch1_Start:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer4_Ch1_Start
_Timer5_interrupt:
;MyTimers.c,489 :: 		void Timer5_interrupt() iv IVT_INT_TIM5 {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,490 :: 		UIF_TIM5_SR_bit = 0;
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(UIF_TIM5_SR_bit+0)
MOVT	R0, #hi_addr(UIF_TIM5_SR_bit+0)
_SX	[R0, ByteOffset(UIF_TIM5_SR_bit+0)]
;MyTimers.c,491 :: 		Timer5Flag = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Timer5Flag+0)
MOVT	R0, #hi_addr(_Timer5Flag+0)
STRB	R1, [R0, #0]
;MyTimers.c,495 :: 		IndTog();
BL	_IndTog+0
;MyTimers.c,496 :: 		}
L_end_Timer5_interrupt:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer5_interrupt
_Timer5_Initialize:
;MyTimers.c,505 :: 		void Timer5_Initialize(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,506 :: 		TIM5EN_bit = 1;                   // Enable TIM5 clock in RCC_APB1ENR
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(TIM5EN_bit+0)
MOVT	R0, #hi_addr(TIM5EN_bit+0)
_SX	[R0, ByteOffset(TIM5EN_bit+0)]
;MyTimers.c,507 :: 		CEN_TIM5_CR1_bit = 0;             // Disable timer 5 while setting registers
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(CEN_TIM5_CR1_bit+0)
MOVT	R0, #hi_addr(CEN_TIM5_CR1_bit+0)
_SX	[R0, ByteOffset(CEN_TIM5_CR1_bit+0)]
;MyTimers.c,509 :: 		TIM5_PSC = 5999;                  // Prescaler divide by 6000
MOVW	R1, #5999
MOVW	R0, #lo_addr(TIM5_PSC+0)
MOVT	R0, #hi_addr(TIM5_PSC+0)
STR	R1, [R0, #0]
;MyTimers.c,510 :: 		TIM5_ARR = 10000;                 // Reload value to 10000
MOVW	R1, #10000
MOVW	R0, #lo_addr(TIM5_ARR+0)
MOVT	R0, #hi_addr(TIM5_ARR+0)
STR	R1, [R0, #0]
;MyTimers.c,511 :: 		NVIC_IntEnable(IVT_INT_TIM5);     // Set timer 5 interrupt vector
MOVW	R0, #66
BL	_NVIC_IntEnable+0
;MyTimers.c,512 :: 		UIE_TIM5_DIER_bit = 1;            // Enable timer5 update interrupts
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(UIE_TIM5_DIER_bit+0)
MOVT	R0, #hi_addr(UIE_TIM5_DIER_bit+0)
_SX	[R0, ByteOffset(UIE_TIM5_DIER_bit+0)]
;MyTimers.c,514 :: 		USB_PutQueue("Timer5 initialized\r\n");
MOVW	R0, #lo_addr(?lstr12_MyTimers+0)
MOVT	R0, #hi_addr(?lstr12_MyTimers+0)
BL	_USB_PutQueue+0
;MyTimers.c,515 :: 		}
L_end_Timer5_Initialize:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer5_Initialize
_Timer5Start:
;MyTimers.c,520 :: 		void Timer5Start(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,522 :: 		CEN_TIM5_CR1_bit = 1;              // Start timer5
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(CEN_TIM5_CR1_bit+0)
MOVT	R0, #hi_addr(CEN_TIM5_CR1_bit+0)
_SX	[R0, ByteOffset(CEN_TIM5_CR1_bit+0)]
;MyTimers.c,523 :: 		USB_PutQueue("Timer5 started\r\n");
MOVW	R0, #lo_addr(?lstr13_MyTimers+0)
MOVT	R0, #hi_addr(?lstr13_MyTimers+0)
BL	_USB_PutQueue+0
;MyTimers.c,524 :: 		}
L_end_Timer5Start:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer5Start
_Timer5Stop:
;MyTimers.c,529 :: 		void Timer5Stop(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,530 :: 		CEN_TIM5_CR1_bit = 0;             // Stop timer5
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(CEN_TIM5_CR1_bit+0)
MOVT	R0, #hi_addr(CEN_TIM5_CR1_bit+0)
_SX	[R0, ByteOffset(CEN_TIM5_CR1_bit+0)]
;MyTimers.c,531 :: 		USB_PutQueue("Timer5 stopped\r\n");
MOVW	R0, #lo_addr(?lstr14_MyTimers+0)
MOVT	R0, #hi_addr(?lstr14_MyTimers+0)
BL	_USB_PutQueue+0
;MyTimers.c,532 :: 		}
L_end_Timer5Stop:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer5Stop
_Timer6Interrupt:
;MyTimers.c,544 :: 		void Timer6Interrupt() iv IVT_INT_TIM6_DAC ics ICS_AUTO {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,545 :: 		UIF_TIM6_SR_bit = 0;   // Clear Update Interrupt Flag in TIM6_SR
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(UIF_TIM6_SR_bit+0)
MOVT	R0, #hi_addr(UIF_TIM6_SR_bit+0)
_SX	[R0, ByteOffset(UIF_TIM6_SR_bit+0)]
;MyTimers.c,549 :: 		IndTog();
BL	_IndTog+0
;MyTimers.c,550 :: 		}
L_end_Timer6Interrupt:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer6Interrupt
_Timer6_Initialize:
;MyTimers.c,559 :: 		void Timer6_Initialize(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,560 :: 		TIM6EN_bit = 1;          // Enable TIM6 clock in RCC_APB1ENR
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(TIM6EN_bit+0)
MOVT	R0, #hi_addr(TIM6EN_bit+0)
_SX	[R0, ByteOffset(TIM6EN_bit+0)]
;MyTimers.c,561 :: 		CEN_TIM6_CR1_bit = 0;    // Disable timer
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(CEN_TIM6_CR1_bit+0)
MOVT	R0, #hi_addr(CEN_TIM6_CR1_bit+0)
_SX	[R0, ByteOffset(CEN_TIM6_CR1_bit+0)]
;MyTimers.c,562 :: 		TIM6_PSC = 5999;         // Set the prescaler register to divide by 5999+1=6000
MOVW	R1, #5999
MOVW	R0, #lo_addr(TIM6_PSC+0)
MOVT	R0, #hi_addr(TIM6_PSC+0)
STR	R1, [R0, #0]
;MyTimers.c,563 :: 		TIM6_ARR = 10000;        // Set the auto-reload register to divide by 10000
MOVW	R1, #10000
MOVW	R0, #lo_addr(TIM6_ARR+0)
MOVT	R0, #hi_addr(TIM6_ARR+0)
STR	R1, [R0, #0]
;MyTimers.c,564 :: 		TIM6_CR2bits.MMS = 0x0;  // Update event is reset
MOVS	R2, #0
MOVW	R1, #lo_addr(TIM6_CR2bits+0)
MOVT	R1, #hi_addr(TIM6_CR2bits+0)
LDRB	R0, [R1, #0]
BFI	R0, R2, #4, #3
STRB	R0, [R1, #0]
;MyTimers.c,566 :: 		NVIC_IntEnable(IVT_INT_TIM6_DAC);  // Set interrupt vector
MOVW	R0, #70
BL	_NVIC_IntEnable+0
;MyTimers.c,567 :: 		UIE_TIM6_DIER_bit = 1;   // Enable TIM6 interrupts in TIM6_DIER
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(UIE_TIM6_DIER_bit+0)
MOVT	R0, #hi_addr(UIE_TIM6_DIER_bit+0)
_SX	[R0, ByteOffset(UIE_TIM6_DIER_bit+0)]
;MyTimers.c,568 :: 		USB_PutQueue("Timer6 initialized\r\n");
MOVW	R0, #lo_addr(?lstr15_MyTimers+0)
MOVT	R0, #hi_addr(?lstr15_MyTimers+0)
BL	_USB_PutQueue+0
;MyTimers.c,569 :: 		}
L_end_Timer6_Initialize:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer6_Initialize
_Timer6Start:
;MyTimers.c,573 :: 		void Timer6Start(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,574 :: 		CEN_TIM6_CR1_bit = 1;     // Enable counter in TIM6_CR1
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(CEN_TIM6_CR1_bit+0)
MOVT	R0, #hi_addr(CEN_TIM6_CR1_bit+0)
_SX	[R0, ByteOffset(CEN_TIM6_CR1_bit+0)]
;MyTimers.c,575 :: 		USB_PutQueue("Timer6 started\r\n");
MOVW	R0, #lo_addr(?lstr16_MyTimers+0)
MOVT	R0, #hi_addr(?lstr16_MyTimers+0)
BL	_USB_PutQueue+0
;MyTimers.c,576 :: 		}
L_end_Timer6Start:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer6Start
_Timer6Stop:
;MyTimers.c,581 :: 		void Timer6Stop(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,582 :: 		CEN_TIM6_CR1_bit = 0;    // Disable timer
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(CEN_TIM6_CR1_bit+0)
MOVT	R0, #hi_addr(CEN_TIM6_CR1_bit+0)
_SX	[R0, ByteOffset(CEN_TIM6_CR1_bit+0)]
;MyTimers.c,583 :: 		USB_PutQueue("Timer6 stopped\r\n");
MOVW	R0, #lo_addr(?lstr17_MyTimers+0)
MOVT	R0, #hi_addr(?lstr17_MyTimers+0)
BL	_USB_PutQueue+0
;MyTimers.c,584 :: 		}
L_end_Timer6Stop:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer6Stop
_Timer7Interrupt:
;MyTimers.c,596 :: 		void Timer7Interrupt() iv IVT_INT_TIM7 ics ICS_AUTO {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,597 :: 		UIF_TIM7_SR_bit = 0;   // Clear Update Interrupt Flag in TIM7_SR
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(UIF_TIM7_SR_bit+0)
MOVT	R0, #hi_addr(UIF_TIM7_SR_bit+0)
_SX	[R0, ByteOffset(UIF_TIM7_SR_bit+0)]
;MyTimers.c,601 :: 		IndTog();
BL	_IndTog+0
;MyTimers.c,602 :: 		}
L_end_Timer7Interrupt:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer7Interrupt
_Timer7_Initialize:
;MyTimers.c,611 :: 		void Timer7_Initialize(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,612 :: 		TIM7EN_bit = 1;          // Enable TIM7 clock in RCC_APB1ENR
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(TIM7EN_bit+0)
MOVT	R0, #hi_addr(TIM7EN_bit+0)
_SX	[R0, ByteOffset(TIM7EN_bit+0)]
;MyTimers.c,613 :: 		CEN_TIM7_CR1_bit = 0;    // Disable timer
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(CEN_TIM7_CR1_bit+0)
MOVT	R0, #hi_addr(CEN_TIM7_CR1_bit+0)
_SX	[R0, ByteOffset(CEN_TIM7_CR1_bit+0)]
;MyTimers.c,614 :: 		TIM7_PSC = 5999;         // Set the prescaler register to divide by 5999+1=6000
MOVW	R1, #5999
MOVW	R0, #lo_addr(TIM7_PSC+0)
MOVT	R0, #hi_addr(TIM7_PSC+0)
STR	R1, [R0, #0]
;MyTimers.c,615 :: 		TIM7_ARR = 1000;         // Set the auto-reload register to divide by 10000
MOVW	R1, #1000
MOVW	R0, #lo_addr(TIM7_ARR+0)
MOVT	R0, #hi_addr(TIM7_ARR+0)
STR	R1, [R0, #0]
;MyTimers.c,616 :: 		TIM7_CR2bits.MMS = 0x0;  // Update event is reset
MOVS	R2, #0
MOVW	R1, #lo_addr(TIM7_CR2bits+0)
MOVT	R1, #hi_addr(TIM7_CR2bits+0)
LDRB	R0, [R1, #0]
BFI	R0, R2, #4, #3
STRB	R0, [R1, #0]
;MyTimers.c,618 :: 		NVIC_IntEnable(IVT_INT_TIM7);  // Set interrupt vector
MOVW	R0, #71
BL	_NVIC_IntEnable+0
;MyTimers.c,619 :: 		UIE_TIM7_DIER_bit = 1;   // Enable TIM7 interrupts in TIM7_DIER
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(UIE_TIM7_DIER_bit+0)
MOVT	R0, #hi_addr(UIE_TIM7_DIER_bit+0)
_SX	[R0, ByteOffset(UIE_TIM7_DIER_bit+0)]
;MyTimers.c,621 :: 		USB_PutQueue("Timer7 initialized\r\n");
MOVW	R0, #lo_addr(?lstr18_MyTimers+0)
MOVT	R0, #hi_addr(?lstr18_MyTimers+0)
BL	_USB_PutQueue+0
;MyTimers.c,622 :: 		}
L_end_Timer7_Initialize:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer7_Initialize
_Timer7Start:
;MyTimers.c,627 :: 		void Timer7Start(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,628 :: 		CEN_TIM7_CR1_bit = 1;     // Enable counter in TIM7_CR1
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(CEN_TIM7_CR1_bit+0)
MOVT	R0, #hi_addr(CEN_TIM7_CR1_bit+0)
_SX	[R0, ByteOffset(CEN_TIM7_CR1_bit+0)]
;MyTimers.c,629 :: 		USB_PutQueue("Timer7 started\r\n");
MOVW	R0, #lo_addr(?lstr19_MyTimers+0)
MOVT	R0, #hi_addr(?lstr19_MyTimers+0)
BL	_USB_PutQueue+0
;MyTimers.c,630 :: 		}
L_end_Timer7Start:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer7Start
_Timer7Stop:
;MyTimers.c,635 :: 		void Timer7Stop(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,636 :: 		CEN_TIM7_CR1_bit = 0;    // Disable timer
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(CEN_TIM7_CR1_bit+0)
MOVT	R0, #hi_addr(CEN_TIM7_CR1_bit+0)
_SX	[R0, ByteOffset(CEN_TIM7_CR1_bit+0)]
;MyTimers.c,637 :: 		USB_PutQueue("Timer7 stopped\r\n");
MOVW	R0, #lo_addr(?lstr20_MyTimers+0)
MOVT	R0, #hi_addr(?lstr20_MyTimers+0)
BL	_USB_PutQueue+0
;MyTimers.c,638 :: 		}
L_end_Timer7Stop:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer7Stop
_Timer8_Initialize:
;MyTimers.c,648 :: 		void Timer8_Initialize(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,650 :: 		GPIOCEN_bit = 1;             // Set GPIOC clock enable bit
MOVS	R2, #1
SXTB	R2, R2
MOVW	R0, #lo_addr(GPIOCEN_bit+0)
MOVT	R0, #hi_addr(GPIOCEN_bit+0)
_SX	[R0, ByteOffset(GPIOCEN_bit+0)]
;MyTimers.c,651 :: 		GPIOC_MODER &= 0xFFFF3FFF;   // Clear port C MODER-7 bits
MOVW	R0, #lo_addr(GPIOC_MODER+0)
MOVT	R0, #hi_addr(GPIOC_MODER+0)
LDR	R1, [R0, #0]
MVN	R0, #49152
ANDS	R1, R0
MOVW	R0, #lo_addr(GPIOC_MODER+0)
MOVT	R0, #hi_addr(GPIOC_MODER+0)
STR	R1, [R0, #0]
;MyTimers.c,652 :: 		GPIOC_MODER |= 0x00008000;   // Set port C MODER-7 bits to 10: alternate function mode
MOVW	R0, #lo_addr(GPIOC_MODER+0)
MOVT	R0, #hi_addr(GPIOC_MODER+0)
LDR	R0, [R0, #0]
ORR	R1, R0, #32768
MOVW	R0, #lo_addr(GPIOC_MODER+0)
MOVT	R0, #hi_addr(GPIOC_MODER+0)
STR	R1, [R0, #0]
;MyTimers.c,653 :: 		GPIOC_AFRL  &= 0x0FFFFFFF;   // Clear port C AFRL-7 bits
MOVW	R0, #lo_addr(GPIOC_AFRL+0)
MOVT	R0, #hi_addr(GPIOC_AFRL+0)
LDR	R1, [R0, #0]
MVN	R0, #-268435456
ANDS	R1, R0
MOVW	R0, #lo_addr(GPIOC_AFRL+0)
MOVT	R0, #hi_addr(GPIOC_AFRL+0)
STR	R1, [R0, #0]
;MyTimers.c,654 :: 		GPIOC_AFRL  |= 0x30000000;   // Set port C AFRL-7 bits to 0011: AF3 TIM8_CH2
MOVW	R0, #lo_addr(GPIOC_AFRL+0)
MOVT	R0, #hi_addr(GPIOC_AFRL+0)
LDR	R0, [R0, #0]
ORR	R1, R0, #805306368
MOVW	R0, #lo_addr(GPIOC_AFRL+0)
MOVT	R0, #hi_addr(GPIOC_AFRL+0)
STR	R1, [R0, #0]
;MyTimers.c,657 :: 		TIM8EN_bit = 1;               // Enable TIM8 clock in RCC_APB2ENR.B1
MOVW	R0, #lo_addr(TIM8EN_bit+0)
MOVT	R0, #hi_addr(TIM8EN_bit+0)
_SX	[R0, ByteOffset(TIM8EN_bit+0)]
;MyTimers.c,658 :: 		TIM8_CR1  = 0x0008;          // Set OPM bit (one-pulse mode)
MOVS	R1, #8
MOVW	R0, #lo_addr(TIM8_CR1+0)
MOVT	R0, #hi_addr(TIM8_CR1+0)
STR	R1, [R0, #0]
;MyTimers.c,659 :: 		TIM8_PSC  = 119;             // Prescaler value to divide by 120
MOVS	R1, #119
MOVW	R0, #lo_addr(TIM8_PSC+0)
MOVT	R0, #hi_addr(TIM8_PSC+0)
STR	R1, [R0, #0]
;MyTimers.c,660 :: 		TIM8_ARR  = 10000;           // Set auto-reload register to divide by 10000
MOVW	R1, #10000
MOVW	R0, #lo_addr(TIM8_ARR+0)
MOVT	R0, #hi_addr(TIM8_ARR+0)
STR	R1, [R0, #0]
;MyTimers.c,661 :: 		TIM8_CCR2 = 20;              // Delay value
MOVS	R1, #20
MOVW	R0, #lo_addr(TIM8_CCR2+0)
MOVT	R0, #hi_addr(TIM8_CCR2+0)
STR	R1, [R0, #0]
;MyTimers.c,663 :: 		UG_TIM8_EGR_bit = 1;         // Generate update
MOVW	R0, #lo_addr(UG_TIM8_EGR_bit+0)
MOVT	R0, #hi_addr(UG_TIM8_EGR_bit+0)
_SX	[R0, ByteOffset(UG_TIM8_EGR_bit+0)]
;MyTimers.c,666 :: 		TIM8_CCMR1_Output = 0x7000;  // PWM mode 2 for CH2
MOVW	R1, #28672
MOVW	R0, #lo_addr(TIM8_CCMR1_Output+0)
MOVT	R0, #hi_addr(TIM8_CCMR1_Output+0)
STR	R1, [R0, #0]
;MyTimers.c,667 :: 		TIM8_CCER = 0x0010;          // Channels 2 is connected to output
MOVS	R1, #16
MOVW	R0, #lo_addr(TIM8_CCER+0)
MOVT	R0, #hi_addr(TIM8_CCER+0)
STR	R1, [R0, #0]
;MyTimers.c,668 :: 		TIM8_BDTR = 0x8000;
MOVW	R1, #32768
MOVW	R0, #lo_addr(TIM8_BDTR+0)
MOVT	R0, #hi_addr(TIM8_BDTR+0)
STR	R1, [R0, #0]
;MyTimers.c,669 :: 		USB_PutQueue("Timer8 initialized\r\n");
MOVW	R0, #lo_addr(?lstr21_MyTimers+0)
MOVT	R0, #hi_addr(?lstr21_MyTimers+0)
BL	_USB_PutQueue+0
;MyTimers.c,670 :: 		}
L_end_Timer8_Initialize:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer8_Initialize
_Timer8_Ch2_Start:
;MyTimers.c,675 :: 		void Timer8_Ch2_Start(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,676 :: 		CEN_TIM8_CR1_bit = 1;         // Enable timer 8 channel 2
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(CEN_TIM8_CR1_bit+0)
MOVT	R0, #hi_addr(CEN_TIM8_CR1_bit+0)
_SX	[R0, ByteOffset(CEN_TIM8_CR1_bit+0)]
;MyTimers.c,677 :: 		USB_PutQueue("Timer8 started\r\n");
MOVW	R0, #lo_addr(?lstr22_MyTimers+0)
MOVT	R0, #hi_addr(?lstr22_MyTimers+0)
BL	_USB_PutQueue+0
;MyTimers.c,678 :: 		}
L_end_Timer8_Ch2_Start:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer8_Ch2_Start
_Timer10_Initialize:
;MyTimers.c,687 :: 		void Timer10_Initialize(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,692 :: 		RatioBuz = PWM_TIM10_Init(800);   // Set frequency to 800Hz
MOVW	R0, #800
BL	_PWM_TIM10_Init+0
MOVW	R1, #lo_addr(_RatioBuz+0)
MOVT	R1, #hi_addr(_RatioBuz+0)
STRH	R0, [R1, #0]
;MyTimers.c,694 :: 		PWM_TIM10_Set_Duty(RatioBuz/2, _PWM_NON_INVERTED, _PWM_CHANNEL1);  // Set duty cycle to one-half of period
LSRS	R0, R0, #1
MOVS	R2, #0
MOVS	R1, #0
BL	_PWM_TIM10_Set_Duty+0
;MyTimers.c,696 :: 		USB_PutQueue("Timer10 initialized\r\n");
MOVW	R0, #lo_addr(?lstr23_MyTimers+0)
MOVT	R0, #hi_addr(?lstr23_MyTimers+0)
BL	_USB_PutQueue+0
;MyTimers.c,697 :: 		}
L_end_Timer10_Initialize:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer10_Initialize
_BuzzerOn:
;MyTimers.c,702 :: 		void BuzzerOn(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,703 :: 		PWM_TIM10_Start(_PWM_CHANNEL1, &_GPIO_MODULE_TIM10_CH1_PB8);
MOVW	R1, #lo_addr(__GPIO_MODULE_TIM10_CH1_PB8+0)
MOVT	R1, #hi_addr(__GPIO_MODULE_TIM10_CH1_PB8+0)
MOVS	R0, #0
BL	_PWM_TIM10_Start+0
;MyTimers.c,704 :: 		}
L_end_BuzzerOn:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _BuzzerOn
_BuzzerOff:
;MyTimers.c,709 :: 		void BuzzerOff(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,710 :: 		PWM_TIM10_Stop(_PWM_CHANNEL1);
MOVS	R0, #0
BL	_PWM_TIM10_Stop+0
;MyTimers.c,711 :: 		}
L_end_BuzzerOff:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _BuzzerOff
_TimeBuzzer:
;MyTimers.c,716 :: 		void TimeBuzzer(unsigned Msec) {
; Msec start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; Msec end address is: 0 (R0)
; Msec start address is: 0 (R0)
;MyTimers.c,717 :: 		TIM7_ARR = Msec;
MOVW	R1, #lo_addr(TIM7_ARR+0)
MOVT	R1, #hi_addr(TIM7_ARR+0)
STR	R0, [R1, #0]
; Msec end address is: 0 (R0)
;MyTimers.c,718 :: 		BuzzerOn();
BL	_BuzzerOn+0
;MyTimers.c,719 :: 		Timer7Start();
BL	_Timer7Start+0
;MyTimers.c,720 :: 		}
L_end_TimeBuzzer:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _TimeBuzzer
_Timer11Interrupt:
;MyTimers.c,728 :: 		void Timer11Interrupt() iv IVT_INT_TIM1_TRG_COM_TIM11 ics ICS_AUTO {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,729 :: 		UIF_TIM11_SR_bit = 0;   // Clear Update Interrupt Flag in TIM11_SR
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(UIF_TIM11_SR_bit+0)
MOVT	R0, #hi_addr(UIF_TIM11_SR_bit+0)
_SX	[R0, ByteOffset(UIF_TIM11_SR_bit+0)]
;MyTimers.c,731 :: 		SysTimeCnt++;
MOVW	R1, #lo_addr(_SysTimeCnt+0)
MOVT	R1, #hi_addr(_SysTimeCnt+0)
LDR	R0, [R1, #0]
ADDS	R0, R0, #1
STR	R0, [R1, #0]
;MyTimers.c,734 :: 		for (CntrPtr = 0; CntrPtr < 2; CntrPtr++) {
MOVS	R1, #0
MOVW	R0, #lo_addr(_CntrPtr+0)
MOVT	R0, #hi_addr(_CntrPtr+0)
STRB	R1, [R0, #0]
L_Timer11Interrupt19:
MOVW	R0, #lo_addr(_CntrPtr+0)
MOVT	R0, #hi_addr(_CntrPtr+0)
LDRB	R0, [R0, #0]
CMP	R0, #2
IT	CS
BCS	L_Timer11Interrupt20
;MyTimers.c,735 :: 		if (DelayCntr[CntrPtr] > 0)
MOVW	R0, #lo_addr(_CntrPtr+0)
MOVT	R0, #hi_addr(_CntrPtr+0)
LDRB	R0, [R0, #0]
LSLS	R1, R0, #1
MOVW	R0, #lo_addr(_DelayCntr+0)
MOVT	R0, #hi_addr(_DelayCntr+0)
ADDS	R0, R0, R1
LDRH	R0, [R0, #0]
CMP	R0, #0
IT	LS
BLS	L_Timer11Interrupt22
;MyTimers.c,736 :: 		DelayCntr[CntrPtr]--;
MOVW	R0, #lo_addr(_CntrPtr+0)
MOVT	R0, #hi_addr(_CntrPtr+0)
LDRB	R0, [R0, #0]
LSLS	R1, R0, #1
MOVW	R0, #lo_addr(_DelayCntr+0)
MOVT	R0, #hi_addr(_DelayCntr+0)
ADDS	R1, R0, R1
LDRH	R0, [R1, #0]
SUBS	R0, R0, #1
STRH	R0, [R1, #0]
L_Timer11Interrupt22:
;MyTimers.c,734 :: 		for (CntrPtr = 0; CntrPtr < 2; CntrPtr++) {
MOVW	R1, #lo_addr(_CntrPtr+0)
MOVT	R1, #hi_addr(_CntrPtr+0)
LDRB	R0, [R1, #0]
ADDS	R0, R0, #1
STRB	R0, [R1, #0]
;MyTimers.c,737 :: 		}
IT	AL
BAL	L_Timer11Interrupt19
L_Timer11Interrupt20:
;MyTimers.c,739 :: 		Msec += 1;                    // Increment millisecond counter
MOVW	R2, #lo_addr(_Msec+0)
MOVT	R2, #hi_addr(_Msec+0)
LDRH	R0, [R2, #0]
ADDS	R1, R0, #1
UXTH	R1, R1
STRH	R1, [R2, #0]
;MyTimers.c,740 :: 		if (Msec > 999) {             // Count to 1000
MOVW	R0, #999
CMP	R1, R0
IT	LS
BLS	L_Timer11Interrupt23
;MyTimers.c,741 :: 		Msec = 0;                 // Set it to 0
MOVS	R1, #0
MOVW	R0, #lo_addr(_Msec+0)
MOVT	R0, #hi_addr(_Msec+0)
STRH	R1, [R0, #0]
;MyTimers.c,742 :: 		TimerFlag = 1;            // Set 1 second flag
MOVS	R1, #1
SXTH	R1, R1
MOVW	R0, #lo_addr(_TimerFlag+0)
MOVT	R0, #hi_addr(_TimerFlag+0)
STRH	R1, [R0, #0]
;MyTimers.c,743 :: 		}
L_Timer11Interrupt23:
;MyTimers.c,744 :: 		irqhandler_timer();           // Service timer pool
BL	_irqhandler_timer+0
;MyTimers.c,745 :: 		}
L_end_Timer11Interrupt:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer11Interrupt
_Timer11_Initialize:
;MyTimers.c,754 :: 		void Timer11_Initialize(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,755 :: 		TIM11EN_bit = 1;              // Enable TIM11 clock in RCC_APB2ENR
MOVS	R2, #1
SXTB	R2, R2
MOVW	R0, #lo_addr(TIM11EN_bit+0)
MOVT	R0, #hi_addr(TIM11EN_bit+0)
_SX	[R0, ByteOffset(TIM11EN_bit+0)]
;MyTimers.c,756 :: 		CEN_TIM11_CR1_bit = 0;        // Disable timer while setting registers
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(CEN_TIM11_CR1_bit+0)
MOVT	R0, #hi_addr(CEN_TIM11_CR1_bit+0)
_SX	[R0, ByteOffset(CEN_TIM11_CR1_bit+0)]
;MyTimers.c,759 :: 		TIM11_PSC = 119;              // Set the prescaler register to divide by 119+1=120
MOVS	R1, #119
MOVW	R0, #lo_addr(TIM11_PSC+0)
MOVT	R0, #hi_addr(TIM11_PSC+0)
STR	R1, [R0, #0]
;MyTimers.c,760 :: 		TIM11_ARR = 1000;             // Set the auto-reload register to divide by 1000
MOVW	R1, #1000
MOVW	R0, #lo_addr(TIM11_ARR+0)
MOVT	R0, #hi_addr(TIM11_ARR+0)
STR	R1, [R0, #0]
;MyTimers.c,766 :: 		UG_TIM11_EGR_bit = 1;         // Generate update
MOVW	R0, #lo_addr(UG_TIM11_EGR_bit+0)
MOVT	R0, #hi_addr(UG_TIM11_EGR_bit+0)
_SX	[R0, ByteOffset(UG_TIM11_EGR_bit+0)]
;MyTimers.c,768 :: 		NVIC_IntEnable(IVT_INT_TIM1_TRG_COM_TIM11);  // Set interrupt vector
MOVW	R0, #42
BL	_NVIC_IntEnable+0
;MyTimers.c,769 :: 		UIE_TIM11_DIER_bit = 1;       // Update interrupt enabled
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(UIE_TIM11_DIER_bit+0)
MOVT	R0, #hi_addr(UIE_TIM11_DIER_bit+0)
_SX	[R0, ByteOffset(UIE_TIM11_DIER_bit+0)]
;MyTimers.c,771 :: 		USB_PutQueue("Timer11 initialized\r\n");
MOVW	R0, #lo_addr(?lstr24_MyTimers+0)
MOVT	R0, #hi_addr(?lstr24_MyTimers+0)
BL	_USB_PutQueue+0
;MyTimers.c,772 :: 		}
L_end_Timer11_Initialize:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer11_Initialize
_Timer11_Start:
;MyTimers.c,777 :: 		void Timer11_Start(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,779 :: 		CEN_TIM11_CR1_bit = 1;              // Start timer5
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(CEN_TIM11_CR1_bit+0)
MOVT	R0, #hi_addr(CEN_TIM11_CR1_bit+0)
_SX	[R0, ByteOffset(CEN_TIM11_CR1_bit+0)]
;MyTimers.c,780 :: 		USB_PutQueue("Timer11 started\r\n");
MOVW	R0, #lo_addr(?lstr25_MyTimers+0)
MOVT	R0, #hi_addr(?lstr25_MyTimers+0)
BL	_USB_PutQueue+0
;MyTimers.c,781 :: 		}
L_end_Timer11_Start:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer11_Start
_Timer11_Stop:
;MyTimers.c,786 :: 		void Timer11_Stop(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,787 :: 		CEN_TIM11_CR1_bit = 0;        // Stop timer
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(CEN_TIM11_CR1_bit+0)
MOVT	R0, #hi_addr(CEN_TIM11_CR1_bit+0)
_SX	[R0, ByteOffset(CEN_TIM11_CR1_bit+0)]
;MyTimers.c,788 :: 		USB_PutQueue("Timer11 stopped\r\n");
MOVW	R0, #lo_addr(?lstr26_MyTimers+0)
MOVT	R0, #hi_addr(?lstr26_MyTimers+0)
BL	_USB_PutQueue+0
;MyTimers.c,789 :: 		}
L_end_Timer11_Stop:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer11_Stop
_Timer11_Update:
;MyTimers.c,794 :: 		void Timer11_Update(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,795 :: 		UG_TIM11_EGR_bit = 1;         // Generate update
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(UG_TIM11_EGR_bit+0)
MOVT	R0, #hi_addr(UG_TIM11_EGR_bit+0)
_SX	[R0, ByteOffset(UG_TIM11_EGR_bit+0)]
;MyTimers.c,796 :: 		USB_PutQueue("Timer11 interrupt generated\r\n");
MOVW	R0, #lo_addr(?lstr27_MyTimers+0)
MOVT	R0, #hi_addr(?lstr27_MyTimers+0)
BL	_USB_PutQueue+0
;MyTimers.c,797 :: 		}
L_end_Timer11_Update:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer11_Update
_DisplayTIM3Regs:
;MyTimers.c,813 :: 		void DisplayTIM3Regs(void) {
SUB	SP, SP, #8
STR	LR, [SP, #0]
;MyTimers.c,816 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,817 :: 		sprintf(BufNum,"RCC_APB1ENR: %08LX\r\n",RCC_APB1ENR);
MOVW	R1, #lo_addr(RCC_APB1ENR+0)
MOVT	R1, #hi_addr(RCC_APB1ENR+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_28_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_28_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,818 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,820 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,821 :: 		sprintf(BufNum,"TIM3_CR1:    %04X\r\n",TIM3_CR1);
MOVW	R1, #lo_addr(TIM3_CR1+0)
MOVT	R1, #hi_addr(TIM3_CR1+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_29_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_29_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,822 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,824 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,825 :: 		sprintf(BufNum,"TIM3_CR2:    %04X\r\n",TIM3_CR2);
MOVW	R1, #lo_addr(TIM3_CR2+0)
MOVT	R1, #hi_addr(TIM3_CR2+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_30_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_30_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,826 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,828 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,829 :: 		sprintf(BufNum,"TIM3_SMCR:   %04X\r\n",TIM3_SMCR);
MOVW	R1, #lo_addr(TIM3_SMCR+0)
MOVT	R1, #hi_addr(TIM3_SMCR+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_31_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_31_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,830 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,832 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,833 :: 		sprintf(BufNum,"TIM3_DIER:   %04X\r\n",TIM3_DIER);
MOVW	R1, #lo_addr(TIM3_DIER+0)
MOVT	R1, #hi_addr(TIM3_DIER+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_32_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_32_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,834 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,836 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,837 :: 		sprintf(BufNum,"TIM3_SR:     %04X\r\n",TIM3_SR);
MOVW	R1, #lo_addr(TIM3_SR+0)
MOVT	R1, #hi_addr(TIM3_SR+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_33_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_33_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,838 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,840 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,841 :: 		sprintf(BufNum,"TIM3_EGR:    %04X\r\n",TIM3_EGR);
MOVW	R1, #lo_addr(TIM3_EGR+0)
MOVT	R1, #hi_addr(TIM3_EGR+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_34_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_34_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,842 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,844 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,845 :: 		sprintf(BufNum,"TIM3_CCMR1:  %04X\r\n",TIM3_CCMR1_Output);
MOVW	R1, #lo_addr(TIM3_CCMR1_Output+0)
MOVT	R1, #hi_addr(TIM3_CCMR1_Output+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_35_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_35_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,846 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,848 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,849 :: 		sprintf(BufNum,"TIM3_CCMR2:  %04X\r\n",TIM3_CCMR2_Output);
MOVW	R1, #lo_addr(TIM3_CCMR2_Output+0)
MOVT	R1, #hi_addr(TIM3_CCMR2_Output+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_36_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_36_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,850 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,852 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,853 :: 		sprintf(BufNum,"TIM3_CCER:   %04X\r\n",TIM3_CCER);
MOVW	R1, #lo_addr(TIM3_CCER+0)
MOVT	R1, #hi_addr(TIM3_CCER+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_37_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_37_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,854 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,856 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,857 :: 		sprintf(BufNum,"TIM3_CNT:    %04X\r\n",TIM3_CNT);
MOVW	R1, #lo_addr(TIM3_CNT+0)
MOVT	R1, #hi_addr(TIM3_CNT+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_38_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_38_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,858 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,860 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,861 :: 		sprintf(BufNum,"TIM3_PSC:    %04X\r\n",TIM3_PSC);
MOVW	R1, #lo_addr(TIM3_PSC+0)
MOVT	R1, #hi_addr(TIM3_PSC+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_39_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_39_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,862 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,864 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,865 :: 		sprintf(BufNum,"TIM3_ARR:    %04X\r\n",TIM3_ARR);
MOVW	R1, #lo_addr(TIM3_ARR+0)
MOVT	R1, #hi_addr(TIM3_ARR+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_40_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_40_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,866 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,868 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,869 :: 		sprintf(BufNum,"TIM3_CCR1    %04X\r\n",TIM3_CCR1);
MOVW	R1, #lo_addr(TIM3_CCR1+0)
MOVT	R1, #hi_addr(TIM3_CCR1+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_41_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_41_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,870 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,872 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,873 :: 		sprintf(BufNum,"TIM3_CCR2    %04X\r\n",TIM3_CCR2);
MOVW	R1, #lo_addr(TIM3_CCR2+0)
MOVT	R1, #hi_addr(TIM3_CCR2+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_42_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_42_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,874 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,876 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,877 :: 		sprintf(BufNum,"TIM3_CCR3    %04X\r\n",TIM3_CCR3);
MOVW	R1, #lo_addr(TIM3_CCR3+0)
MOVT	R1, #hi_addr(TIM3_CCR3+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_43_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_43_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,878 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,880 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,881 :: 		sprintf(BufNum,"TIM3_CCR4    %04X\r\n",TIM3_CCR4);
MOVW	R1, #lo_addr(TIM3_CCR4+0)
MOVT	R1, #hi_addr(TIM3_CCR4+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_44_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_44_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,882 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,884 :: 		}
L_end_DisplayTIM3Regs:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _DisplayTIM3Regs
_DisplayTIM4Regs:
;MyTimers.c,889 :: 		void DisplayTIM4Regs(void) {
SUB	SP, SP, #8
STR	LR, [SP, #0]
;MyTimers.c,892 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,893 :: 		sprintf(BufNum,"RCC_APB1ENR: %08LX\r\n",RCC_APB1ENR);
MOVW	R1, #lo_addr(RCC_APB1ENR+0)
MOVT	R1, #hi_addr(RCC_APB1ENR+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_45_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_45_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,894 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,896 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,897 :: 		sprintf(BufNum,"TIM4_CR1:    %04X\r\n",TIM4_CR1);
MOVW	R1, #lo_addr(TIM4_CR1+0)
MOVT	R1, #hi_addr(TIM4_CR1+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_46_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_46_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,898 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,900 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,901 :: 		sprintf(BufNum,"TIM4_CR2:    %04X\r\n",TIM4_CR2);
MOVW	R1, #lo_addr(TIM4_CR2+0)
MOVT	R1, #hi_addr(TIM4_CR2+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_47_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_47_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,902 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,904 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,905 :: 		sprintf(BufNum,"TIM4_SMCR:   %04X\r\n",TIM4_SMCR);
MOVW	R1, #lo_addr(TIM4_SMCR+0)
MOVT	R1, #hi_addr(TIM4_SMCR+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_48_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_48_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,906 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,908 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,909 :: 		sprintf(BufNum,"TIM4_DIER:   %04X\r\n",TIM4_DIER);
MOVW	R1, #lo_addr(TIM4_DIER+0)
MOVT	R1, #hi_addr(TIM4_DIER+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_49_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_49_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,910 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,912 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,913 :: 		sprintf(BufNum,"TIM4_SR:     %04X\r\n",TIM4_SR);
MOVW	R1, #lo_addr(TIM4_SR+0)
MOVT	R1, #hi_addr(TIM4_SR+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_50_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_50_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,914 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,916 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,917 :: 		sprintf(BufNum,"TIM4_EGR:    %04X\r\n",TIM4_EGR);
MOVW	R1, #lo_addr(TIM4_EGR+0)
MOVT	R1, #hi_addr(TIM4_EGR+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_51_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_51_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,918 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,920 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,921 :: 		sprintf(BufNum,"TIM4_CCMR1:  %04X\r\n",TIM4_CCMR1_Output);
MOVW	R1, #lo_addr(TIM4_CCMR1_Output+0)
MOVT	R1, #hi_addr(TIM4_CCMR1_Output+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_52_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_52_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,922 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,924 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,925 :: 		sprintf(BufNum,"TIM4_CCMR2:  %04X\r\n",TIM4_CCMR2_Output);
MOVW	R1, #lo_addr(TIM4_CCMR2_Output+0)
MOVT	R1, #hi_addr(TIM4_CCMR2_Output+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_53_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_53_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,926 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,928 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,929 :: 		sprintf(BufNum,"TIM4_CCER:   %04X\r\n",TIM4_CCER);
MOVW	R1, #lo_addr(TIM4_CCER+0)
MOVT	R1, #hi_addr(TIM4_CCER+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_54_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_54_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,930 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,932 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,933 :: 		sprintf(BufNum,"TIM4_CNT:    %04X\r\n",TIM4_CNT);
MOVW	R1, #lo_addr(TIM4_CNT+0)
MOVT	R1, #hi_addr(TIM4_CNT+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_55_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_55_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,934 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,936 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,937 :: 		sprintf(BufNum,"TIM4_PSC:    %04X\r\n",TIM4_PSC);
MOVW	R1, #lo_addr(TIM4_PSC+0)
MOVT	R1, #hi_addr(TIM4_PSC+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_56_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_56_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,938 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,940 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,941 :: 		sprintf(BufNum,"TIM4_ARR:    %04X\r\n",TIM4_ARR);
MOVW	R1, #lo_addr(TIM4_ARR+0)
MOVT	R1, #hi_addr(TIM4_ARR+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_57_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_57_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,942 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,944 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,945 :: 		sprintf(BufNum,"TIM4_CCR1    %04X\r\n",TIM4_CCR1);
MOVW	R1, #lo_addr(TIM4_CCR1+0)
MOVT	R1, #hi_addr(TIM4_CCR1+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_58_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_58_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,946 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,948 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,949 :: 		sprintf(BufNum,"TIM4_CCR2    %04X\r\n",TIM4_CCR2);
MOVW	R1, #lo_addr(TIM4_CCR2+0)
MOVT	R1, #hi_addr(TIM4_CCR2+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_59_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_59_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,950 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,952 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,953 :: 		sprintf(BufNum,"TIM4_CCR3    %04X\r\n",TIM4_CCR3);
MOVW	R1, #lo_addr(TIM4_CCR3+0)
MOVT	R1, #hi_addr(TIM4_CCR3+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_60_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_60_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,954 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,956 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,957 :: 		sprintf(BufNum,"TIM4_CCR4    %04X\r\n",TIM4_CCR4);
MOVW	R1, #lo_addr(TIM4_CCR4+0)
MOVT	R1, #hi_addr(TIM4_CCR4+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_61_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_61_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,958 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,960 :: 		}
L_end_DisplayTIM4Regs:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _DisplayTIM4Regs
_DisplayTIM8Regs:
;MyTimers.c,965 :: 		void DisplayTIM8Regs(void) {
SUB	SP, SP, #8
STR	LR, [SP, #0]
;MyTimers.c,968 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,969 :: 		sprintf(BufNum,"RCC_APB2ENR: %08LX\r\n",RCC_APB2ENR);
MOVW	R1, #lo_addr(RCC_APB2ENR+0)
MOVT	R1, #hi_addr(RCC_APB2ENR+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_62_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_62_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,970 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,972 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,973 :: 		sprintf(BufNum,"TIM8_CR1:    %04X\r\n",TIM8_CR1);
MOVW	R1, #lo_addr(TIM8_CR1+0)
MOVT	R1, #hi_addr(TIM8_CR1+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_63_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_63_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,974 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,976 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,977 :: 		sprintf(BufNum,"TIM8_CR2:    %04X\r\n",TIM8_CR2);
MOVW	R1, #lo_addr(TIM8_CR2+0)
MOVT	R1, #hi_addr(TIM8_CR2+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_64_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_64_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,978 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,980 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,981 :: 		sprintf(BufNum,"TIM8_SMCR:   %04X\r\n",TIM8_SMCR);
MOVW	R1, #lo_addr(TIM8_SMCR+0)
MOVT	R1, #hi_addr(TIM8_SMCR+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_65_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_65_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,982 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,984 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,985 :: 		sprintf(BufNum,"TIM8_DIER:   %04X\r\n",TIM8_DIER);
MOVW	R1, #lo_addr(TIM8_DIER+0)
MOVT	R1, #hi_addr(TIM8_DIER+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_66_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_66_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,986 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,988 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,989 :: 		sprintf(BufNum,"TIM8_SR:     %04X\r\n",TIM8_SR);
MOVW	R1, #lo_addr(TIM8_SR+0)
MOVT	R1, #hi_addr(TIM8_SR+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_67_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_67_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,990 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,992 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,993 :: 		sprintf(BufNum,"TIM8_EGR:    %04X\r\n",TIM8_EGR);
MOVW	R1, #lo_addr(TIM8_EGR+0)
MOVT	R1, #hi_addr(TIM8_EGR+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_68_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_68_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,994 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,996 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,997 :: 		sprintf(BufNum,"TIM8_CCMR1:  %04X\r\n",TIM8_CCMR1_Output);
MOVW	R1, #lo_addr(TIM8_CCMR1_Output+0)
MOVT	R1, #hi_addr(TIM8_CCMR1_Output+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_69_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_69_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,998 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,1000 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,1001 :: 		sprintf(BufNum,"TIM8_CCMR2:  %04X\r\n",TIM8_CCMR2_Output);
MOVW	R1, #lo_addr(TIM8_CCMR2_Output+0)
MOVT	R1, #hi_addr(TIM8_CCMR2_Output+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_70_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_70_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,1002 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,1004 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,1005 :: 		sprintf(BufNum,"TIM8_CCER:   %04X\r\n",TIM8_CCER);
MOVW	R1, #lo_addr(TIM8_CCER+0)
MOVT	R1, #hi_addr(TIM8_CCER+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_71_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_71_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,1006 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,1008 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,1009 :: 		sprintf(BufNum,"TIM8_CNT:    %04X\r\n",TIM8_CNT);
MOVW	R1, #lo_addr(TIM8_CNT+0)
MOVT	R1, #hi_addr(TIM8_CNT+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_72_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_72_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,1010 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,1012 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,1013 :: 		sprintf(BufNum,"TIM8_PSC:    %04X\r\n",TIM8_PSC);
MOVW	R1, #lo_addr(TIM8_PSC+0)
MOVT	R1, #hi_addr(TIM8_PSC+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_73_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_73_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,1014 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,1016 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,1017 :: 		sprintf(BufNum,"TIM8_ARR:    %04X\r\n",TIM8_ARR);
MOVW	R1, #lo_addr(TIM8_ARR+0)
MOVT	R1, #hi_addr(TIM8_ARR+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_74_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_74_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,1018 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,1020 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,1021 :: 		sprintf(BufNum,"TIM8_CCR1    %04X\r\n",TIM8_CCR1);
MOVW	R1, #lo_addr(TIM8_CCR1+0)
MOVT	R1, #hi_addr(TIM8_CCR1+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_75_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_75_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,1022 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,1024 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,1025 :: 		sprintf(BufNum,"TIM8_CCR2    %04X\r\n",TIM8_CCR2);
MOVW	R1, #lo_addr(TIM8_CCR2+0)
MOVT	R1, #hi_addr(TIM8_CCR2+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_76_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_76_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,1026 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,1028 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,1029 :: 		sprintf(BufNum,"TIM8_CCR3    %04X\r\n",TIM8_CCR3);
MOVW	R1, #lo_addr(TIM8_CCR3+0)
MOVT	R1, #hi_addr(TIM8_CCR3+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_77_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_77_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,1030 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,1032 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,1033 :: 		sprintf(BufNum,"TIM8_CCR4    %04X\r\n",TIM8_CCR4);
MOVW	R1, #lo_addr(TIM8_CCR4+0)
MOVT	R1, #hi_addr(TIM8_CCR4+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_78_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_78_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,1034 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,1036 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,1037 :: 		sprintf(BufNum,"TIM8_BDTR    %04X\r\n",TIM8_BDTR);
MOVW	R1, #lo_addr(TIM8_BDTR+0)
MOVT	R1, #hi_addr(TIM8_BDTR+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_79_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_79_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,1038 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,1039 :: 		}
L_end_DisplayTIM8Regs:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _DisplayTIM8Regs
_DisplayTimer10Regs:
;MyTimers.c,1044 :: 		void DisplayTimer10Regs(void) {
SUB	SP, SP, #8
STR	LR, [SP, #0]
;MyTimers.c,1047 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,1048 :: 		sprintf(BufNum,"CR1 register: %04X",TIM10_CR1);
MOVW	R1, #lo_addr(TIM10_CR1+0)
MOVT	R1, #hi_addr(TIM10_CR1+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_80_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_80_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,1049 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,1051 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,1052 :: 		sprintf(BufNum,"DIER register: %04X",TIM10_DIER);
MOVW	R1, #lo_addr(TIM10_DIER+0)
MOVT	R1, #hi_addr(TIM10_DIER+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_81_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_81_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,1053 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,1055 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,1056 :: 		sprintf(BufNum,"SR register: %04X",TIM10_SR);
MOVW	R1, #lo_addr(TIM10_SR+0)
MOVT	R1, #hi_addr(TIM10_SR+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_82_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_82_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,1057 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,1059 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,1060 :: 		sprintf(BufNum,"EGR register: %04X",TIM10_EGR);
MOVW	R1, #lo_addr(TIM10_EGR+0)
MOVT	R1, #hi_addr(TIM10_EGR+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_83_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_83_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,1061 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,1063 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,1064 :: 		sprintf(BufNum,"CCMR1 register: %04X",TIM10_CCMR1_Output);
MOVW	R1, #lo_addr(TIM10_CCMR1_Output+0)
MOVT	R1, #hi_addr(TIM10_CCMR1_Output+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_84_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_84_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,1065 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,1067 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,1068 :: 		sprintf(BufNum,"ARR register: %04X",TIM10_ARR);
MOVW	R1, #lo_addr(TIM10_ARR+0)
MOVT	R1, #hi_addr(TIM10_ARR+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_85_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_85_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,1069 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,1071 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,1072 :: 		sprintf(BufNum,"CCR1 register: %04X",TIM10_CCR1);
MOVW	R1, #lo_addr(TIM10_CCR1+0)
MOVT	R1, #hi_addr(TIM10_CCR1+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_86_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_86_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,1073 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,1076 :: 		}
L_end_DisplayTimer10Regs:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _DisplayTimer10Regs
_DisplayGPIOCRegs:
;MyTimers.c,1081 :: 		void DisplayGPIOCRegs(void) {
SUB	SP, SP, #8
STR	LR, [SP, #0]
;MyTimers.c,1084 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,1085 :: 		sprintf(BufNum,"GPIOC_MODER    %08LX\r\n",GPIOC_MODER);
MOVW	R1, #lo_addr(GPIOC_MODER+0)
MOVT	R1, #hi_addr(GPIOC_MODER+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_87_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_87_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,1086 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,1088 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,1089 :: 		sprintf(BufNum,"GPIOC_AFRL     %08LX\r\n",GPIOC_AFRL);
MOVW	R1, #lo_addr(GPIOC_AFRL+0)
MOVT	R1, #hi_addr(GPIOC_AFRL+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_88_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_88_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,1090 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,1092 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;MyTimers.c,1093 :: 		sprintf(BufNum,"GPIOC_AFRH     %08LX\r\n",GPIOC_AFRH);
MOVW	R1, #lo_addr(GPIOC_AFRH+0)
MOVT	R1, #hi_addr(GPIOC_AFRH+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_89_MyTimers+0)
MOVT	R1, #hi_addr(?lstr_89_MyTimers+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,1094 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;MyTimers.c,1095 :: 		}
L_end_DisplayGPIOCRegs:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _DisplayGPIOCRegs
_prvOneShotTimerCallback:
;MyTimers.c,1113 :: 		void prvOneShotTimerCallback(TimerHandle_t xTimer) {
SUB	SP, SP, #12
STR	LR, [SP, #0]
;MyTimers.c,1118 :: 		xTimeNow = xTaskGetTickCount();
BL	_xTaskGetTickCount+0
STR	R0, [SP, #4]
;MyTimers.c,1121 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #8]
;MyTimers.c,1122 :: 		sprintf(BufNum,"One-shot time now: %08LX \r\n",xTimeNow);
LDR	R3, [SP, #4]
MOVW	R2, #lo_addr(?lstr_90_MyTimers+0)
MOVT	R2, #hi_addr(?lstr_90_MyTimers+0)
MOV	R1, R0
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
BL	_sprintf+0
ADD	SP, SP, #12
;MyTimers.c,1123 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #8]
BL	_USB_PutQueue+0
;MyTimers.c,1124 :: 		}
L_end_prvOneShotTimerCallback:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _prvOneShotTimerCallback
_CreateOneShotTimer:
;MyTimers.c,1129 :: 		void CreateOneShotTimer(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,1133 :: 		xOneShotTimer = xTimerCreate("OneShot",500,pdFALSE,0,prvOneShotTimerCallback);
MOVW	R1, #lo_addr(_prvOneShotTimerCallback+0)
MOVT	R1, #hi_addr(_prvOneShotTimerCallback+0)
MOVW	R0, #lo_addr(?lstr_91_MyTimers+0)
MOVT	R0, #hi_addr(?lstr_91_MyTimers+0)
PUSH	(R1)
MOVS	R3, #0
MOV	R2, #0
MOVW	R1, #500
BL	_xTimerCreate+0
ADD	SP, SP, #4
MOVW	R1, #lo_addr(_xOneShotTimer+0)
MOVT	R1, #hi_addr(_xOneShotTimer+0)
STR	R0, [R1, #0]
;MyTimers.c,1134 :: 		}
L_end_CreateOneShotTimer:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _CreateOneShotTimer
_StartOneShotTimer:
;MyTimers.c,1139 :: 		void StartOneShotTimer(void) {
SUB	SP, SP, #12
STR	LR, [SP, #0]
;MyTimers.c,1142 :: 		xTimerStarted = xTimerStart(xOneShotTimer, 0);
MOVS	R0, #0
STR	R0, [SP, #8]
BL	_xTaskGetTickCount+0
MOVW	R1, #lo_addr(_xOneShotTimer+0)
MOVT	R1, #hi_addr(_xOneShotTimer+0)
LDR	R2, [R1, #0]
LDR	R1, [SP, #8]
PUSH	(R1)
STR	R2, [SP, #8]
MOVS	R3, #0
MOV	R1, #1
MOV	R2, R0
LDR	R0, [SP, #8]
BL	_xTimerGenericCommand+0
ADD	SP, SP, #4
;MyTimers.c,1143 :: 		if (xTimerStarted == pdPASS) {
CMP	R0, #1
IT	NE
BNE	L_StartOneShotTimer24
;MyTimers.c,1144 :: 		USB_PutQueue("One-shot timer started\r\n");
MOVW	R0, #lo_addr(?lstr92_MyTimers+0)
MOVT	R0, #hi_addr(?lstr92_MyTimers+0)
BL	_USB_PutQueue+0
;MyTimers.c,1145 :: 		} else {
IT	AL
BAL	L_StartOneShotTimer25
L_StartOneShotTimer24:
;MyTimers.c,1146 :: 		USB_PutQueue("Error starting one-shot timer\r\n");
MOVW	R0, #lo_addr(?lstr93_MyTimers+0)
MOVT	R0, #hi_addr(?lstr93_MyTimers+0)
BL	_USB_PutQueue+0
;MyTimers.c,1147 :: 		}
L_StartOneShotTimer25:
;MyTimers.c,1148 :: 		}
L_end_StartOneShotTimer:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _StartOneShotTimer
_ChangeTimerPeriod:
;MyTimers.c,1153 :: 		void ChangeTimerPeriod(TickType_t Period) {
; Period start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; Period end address is: 0 (R0)
; Period start address is: 0 (R0)
;MyTimers.c,1156 :: 		xTimerChanged = xTimerChangePeriod(xOneShotTimer, Period, 0);
MOVS	R2, #0
MOVW	R1, #lo_addr(_xOneShotTimer+0)
MOVT	R1, #hi_addr(_xOneShotTimer+0)
LDR	R1, [R1, #0]
PUSH	(R2)
MOVS	R3, #0
MOV	R2, R0
; Period end address is: 0 (R0)
MOV	R0, R1
MOV	R1, #4
BL	_xTimerGenericCommand+0
ADD	SP, SP, #4
;MyTimers.c,1157 :: 		if (xTimerChanged == pdPASS) {
CMP	R0, #1
IT	NE
BNE	L_ChangeTimerPeriod26
;MyTimers.c,1158 :: 		USB_PutQueue("One-shot timer period changed\r\n");
MOVW	R1, #lo_addr(?lstr94_MyTimers+0)
MOVT	R1, #hi_addr(?lstr94_MyTimers+0)
MOV	R0, R1
BL	_USB_PutQueue+0
;MyTimers.c,1159 :: 		} else {
IT	AL
BAL	L_ChangeTimerPeriod27
L_ChangeTimerPeriod26:
;MyTimers.c,1160 :: 		USB_PutQueue("Could not change one-shot timer period\r\n");
MOVW	R1, #lo_addr(?lstr95_MyTimers+0)
MOVT	R1, #hi_addr(?lstr95_MyTimers+0)
MOV	R0, R1
BL	_USB_PutQueue+0
;MyTimers.c,1161 :: 		}
L_ChangeTimerPeriod27:
;MyTimers.c,1162 :: 		}
L_end_ChangeTimerPeriod:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _ChangeTimerPeriod
_SetAutoReloadOutput:
;MyTimers.c,1170 :: 		void SetAutoReloadOutput(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,1173 :: 		| _GPIO_CFG_OTYPE_PP);
MOVW	R2, #20
MOVT	R2, #8
;MyTimers.c,1172 :: 		GPIO_Config(&GPIOD_BASE,_GPIO_PINMASK_8, _GPIO_CFG_MODE_OUTPUT | _GPIO_CFG_SPEED_MAX
MOVW	R1, #256
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
;MyTimers.c,1173 :: 		| _GPIO_CFG_OTYPE_PP);
BL	_GPIO_Config+0
;MyTimers.c,1174 :: 		}
L_end_SetAutoReloadOutput:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _SetAutoReloadOutput
_prvAutoReloadTimerCallback:
;MyTimers.c,1179 :: 		void prvAutoReloadTimerCallback(TimerHandle_t xTimer) {
;MyTimers.c,1181 :: 		Ind = ~Ind; // Toggle PD8 LED
MOVW	R2, #lo_addr(GPIOD_ODR+0)
MOVT	R2, #hi_addr(GPIOD_ODR+0)
_LX	[R2, ByteOffset(GPIOD_ODR+0)]
EOR	R1, R1, #1
UXTB	R1, R1
_SX	[R2, ByteOffset(GPIOD_ODR+0)]
;MyTimers.c,1182 :: 		}
L_end_prvAutoReloadTimerCallback:
BX	LR
; end of _prvAutoReloadTimerCallback
_CreateAutoReloadTimer:
;MyTimers.c,1187 :: 		void CreateAutoReloadTimer(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,1189 :: 		SetAutoReloadOutput();
BL	_SetAutoReloadOutput+0
;MyTimers.c,1190 :: 		xAutoReloadTimer = xTimerCreate("AutoReload",500,pdTRUE,0,prvAutoReloadTimerCallback);
MOVW	R1, #lo_addr(_prvAutoReloadTimerCallback+0)
MOVT	R1, #hi_addr(_prvAutoReloadTimerCallback+0)
MOVW	R0, #lo_addr(?lstr_96_MyTimers+0)
MOVT	R0, #hi_addr(?lstr_96_MyTimers+0)
PUSH	(R1)
MOVS	R3, #0
MOV	R2, #1
MOVW	R1, #500
BL	_xTimerCreate+0
ADD	SP, SP, #4
MOVW	R1, #lo_addr(_xAutoReloadTimer+0)
MOVT	R1, #hi_addr(_xAutoReloadTimer+0)
STR	R0, [R1, #0]
;MyTimers.c,1191 :: 		}
L_end_CreateAutoReloadTimer:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _CreateAutoReloadTimer
_StartAutoReloadTimer:
;MyTimers.c,1196 :: 		void StartAutoReloadTimer(void) {
SUB	SP, SP, #12
STR	LR, [SP, #0]
;MyTimers.c,1199 :: 		xTimerStarted = xTimerStart(xAutoReloadTimer, 0);
MOVS	R0, #0
STR	R0, [SP, #8]
BL	_xTaskGetTickCount+0
MOVW	R1, #lo_addr(_xAutoReloadTimer+0)
MOVT	R1, #hi_addr(_xAutoReloadTimer+0)
LDR	R2, [R1, #0]
LDR	R1, [SP, #8]
PUSH	(R1)
STR	R2, [SP, #8]
MOVS	R3, #0
MOV	R1, #1
MOV	R2, R0
LDR	R0, [SP, #8]
BL	_xTimerGenericCommand+0
ADD	SP, SP, #4
;MyTimers.c,1200 :: 		if (xTimerStarted == pdPASS) {
CMP	R0, #1
IT	NE
BNE	L_StartAutoReloadTimer28
;MyTimers.c,1201 :: 		USB_PutQueue("Auto-reload timer started\r\n");
MOVW	R0, #lo_addr(?lstr97_MyTimers+0)
MOVT	R0, #hi_addr(?lstr97_MyTimers+0)
BL	_USB_PutQueue+0
;MyTimers.c,1202 :: 		} else {
IT	AL
BAL	L_StartAutoReloadTimer29
L_StartAutoReloadTimer28:
;MyTimers.c,1203 :: 		USB_PutQueue("Error starting auto-reload timer\r\n");
MOVW	R0, #lo_addr(?lstr98_MyTimers+0)
MOVT	R0, #hi_addr(?lstr98_MyTimers+0)
BL	_USB_PutQueue+0
;MyTimers.c,1204 :: 		}
L_StartAutoReloadTimer29:
;MyTimers.c,1205 :: 		}
L_end_StartAutoReloadTimer:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _StartAutoReloadTimer
_StopAutoReloadTimer:
;MyTimers.c,1210 :: 		void StopAutoReloadTimer(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,1213 :: 		xTimerStopped = xTimerStop(xAutoReloadTimer, 0);
MOVS	R1, #0
MOVW	R0, #lo_addr(_xAutoReloadTimer+0)
MOVT	R0, #hi_addr(_xAutoReloadTimer+0)
LDR	R0, [R0, #0]
PUSH	(R1)
MOVS	R3, #0
MOVS	R2, #0
MOV	R1, #3
BL	_xTimerGenericCommand+0
ADD	SP, SP, #4
;MyTimers.c,1214 :: 		if (xTimerStopped == pdPASS) {
CMP	R0, #1
IT	NE
BNE	L_StopAutoReloadTimer30
;MyTimers.c,1215 :: 		USB_PutQueue("Auto-reload timer stopped\r\n");
MOVW	R0, #lo_addr(?lstr99_MyTimers+0)
MOVT	R0, #hi_addr(?lstr99_MyTimers+0)
BL	_USB_PutQueue+0
;MyTimers.c,1216 :: 		} else {
IT	AL
BAL	L_StopAutoReloadTimer31
L_StopAutoReloadTimer30:
;MyTimers.c,1217 :: 		USB_PutQueue("Error stopping auto-reload timer\r\n");
MOVW	R0, #lo_addr(?lstr100_MyTimers+0)
MOVT	R0, #hi_addr(?lstr100_MyTimers+0)
BL	_USB_PutQueue+0
;MyTimers.c,1218 :: 		}
L_StopAutoReloadTimer31:
;MyTimers.c,1219 :: 		}
L_end_StopAutoReloadTimer:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _StopAutoReloadTimer
_ChangeReloadTimerPeriod:
;MyTimers.c,1224 :: 		void ChangeReloadTimerPeriod(TickType_t Period) {
; Period start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; Period end address is: 0 (R0)
; Period start address is: 0 (R0)
;MyTimers.c,1227 :: 		xTimer2Changed = xTimerChangePeriod(xAutoReloadTimer, Period, 0);
MOVS	R2, #0
MOVW	R1, #lo_addr(_xAutoReloadTimer+0)
MOVT	R1, #hi_addr(_xAutoReloadTimer+0)
LDR	R1, [R1, #0]
PUSH	(R2)
MOVS	R3, #0
MOV	R2, R0
; Period end address is: 0 (R0)
MOV	R0, R1
MOV	R1, #4
BL	_xTimerGenericCommand+0
ADD	SP, SP, #4
;MyTimers.c,1228 :: 		if (xTimer2Changed == pdPASS) {
CMP	R0, #1
IT	NE
BNE	L_ChangeReloadTimerPeriod32
;MyTimers.c,1229 :: 		USB_PutQueue("Auto-reload timer period changed\r\n");
MOVW	R1, #lo_addr(?lstr101_MyTimers+0)
MOVT	R1, #hi_addr(?lstr101_MyTimers+0)
MOV	R0, R1
BL	_USB_PutQueue+0
;MyTimers.c,1230 :: 		} else {
IT	AL
BAL	L_ChangeReloadTimerPeriod33
L_ChangeReloadTimerPeriod32:
;MyTimers.c,1231 :: 		USB_PutQueue("Could not change auto-reload timer period\r\n");
MOVW	R1, #lo_addr(?lstr102_MyTimers+0)
MOVT	R1, #hi_addr(?lstr102_MyTimers+0)
MOV	R0, R1
BL	_USB_PutQueue+0
;MyTimers.c,1232 :: 		}
L_ChangeReloadTimerPeriod33:
;MyTimers.c,1233 :: 		}
L_end_ChangeReloadTimerPeriod:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _ChangeReloadTimerPeriod
_IndOn:
;MyTimers.c,1242 :: 		void IndOn(void) {
;MyTimers.c,1243 :: 		Ind = 1;       // Set PD8 LED
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOD_ODR+0)
MOVT	R0, #hi_addr(GPIOD_ODR+0)
_SX	[R0, ByteOffset(GPIOD_ODR+0)]
;MyTimers.c,1244 :: 		}
L_end_IndOn:
BX	LR
; end of _IndOn
_IndOff:
;MyTimers.c,1246 :: 		void IndOff(void) {
;MyTimers.c,1247 :: 		Ind = 0;       // Clear PD8 LED
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOD_ODR+0)
MOVT	R0, #hi_addr(GPIOD_ODR+0)
_SX	[R0, ByteOffset(GPIOD_ODR+0)]
;MyTimers.c,1248 :: 		}
L_end_IndOff:
BX	LR
; end of _IndOff
_IndTog:
;MyTimers.c,1250 :: 		void IndTog(void) {
;MyTimers.c,1251 :: 		Ind = ~Ind;    // Toggle PD8 LED
MOVW	R1, #lo_addr(GPIOD_ODR+0)
MOVT	R1, #hi_addr(GPIOD_ODR+0)
_LX	[R1, ByteOffset(GPIOD_ODR+0)]
EOR	R0, R0, #1
UXTB	R0, R0
_SX	[R1, ByteOffset(GPIOD_ODR+0)]
;MyTimers.c,1252 :: 		}
L_end_IndTog:
BX	LR
; end of _IndTog
_timerTask:
;MyTimers.c,1259 :: 		void timerTask(void *pvParameters) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;MyTimers.c,1262 :: 		Timer8_Initialize();  // Initialize diagnostic timer 8 that can flash PC7 LED when started
BL	_Timer8_Initialize+0
;MyTimers.c,1264 :: 		while (1) {
L_timerTask34:
;MyTimers.c,1265 :: 		TimerCheck();    // Diagnostic
BL	_TimerCheck+0
;MyTimers.c,1266 :: 		}
IT	AL
BAL	L_timerTask34
;MyTimers.c,1267 :: 		}
L_end_timerTask:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _timerTask
