event_groups_ucPortCountLeadingZeros:
;portmacro.h,183 :: 		static inline uint8_t ucPortCountLeadingZeros(uint32_t ulBitmap)
;portmacro.h,185 :: 		asm CLZ R0, R0;
CLZ	R0, R0
;portmacro.h,186 :: 		return R0;
UXTB	R0, R0
;portmacro.h,187 :: 		}
L_end_ucPortCountLeadingZeros:
BX	LR
; end of event_groups_ucPortCountLeadingZeros
event_groups_vPortRaiseBASEPRI:
;portmacro.h,229 :: 		portFORCE_INLINE static void vPortRaiseBASEPRI( void )
;portmacro.h,234 :: 		CPU_REG_SET(CPU_BASEPRI, ulNewBASEPRI);
MOV	R0, #16
MOV	R12, R0
MSR	#17, R12
;portmacro.h,236 :: 		asm ISB;
ISB	#15
;portmacro.h,237 :: 		asm DSB;
DSB	#15
;portmacro.h,238 :: 		}
L_end_vPortRaiseBASEPRI:
BX	LR
; end of event_groups_vPortRaiseBASEPRI
event_groups_ulPortRaiseBASEPRI:
;portmacro.h,241 :: 		portFORCE_INLINE static uint32_t ulPortRaiseBASEPRI( void )
;portmacro.h,245 :: 		ulOriginalBASEPRI = CPU_REG_GET(CPU_BASEPRI);
MRS	R12, #17
MOV	R0, R12
; ulOriginalBASEPRI start address is: 4 (R1)
MOV	R1, R0
;portmacro.h,247 :: 		CPU_REG_SET(CPU_BASEPRI, ulNewBASEPRI);
MOV	R0, #16
MOV	R12, R0
MSR	#17, R12
;portmacro.h,249 :: 		asm ISB;
ISB	#15
;portmacro.h,250 :: 		asm DSB;
DSB	#15
;portmacro.h,254 :: 		return ulOriginalBASEPRI;
MOV	R0, R1
; ulOriginalBASEPRI end address is: 4 (R1)
;portmacro.h,255 :: 		}
L_end_ulPortRaiseBASEPRI:
BX	LR
; end of event_groups_ulPortRaiseBASEPRI
event_groups_vPortSetBASEPRI:
;portmacro.h,258 :: 		portFORCE_INLINE static void vPortSetBASEPRI( uint32_t ulNewMaskValue )
; ulNewMaskValue start address is: 0 (R0)
; ulNewMaskValue end address is: 0 (R0)
; ulNewMaskValue start address is: 0 (R0)
;portmacro.h,260 :: 		CPU_REG_SET(CPU_BASEPRI, ulNewMaskValue);
MOV	R1, R0
; ulNewMaskValue end address is: 0 (R0)
MOV	R12, R1
MSR	#17, R12
;portmacro.h,261 :: 		}
L_end_vPortSetBASEPRI:
BX	LR
; end of event_groups_vPortSetBASEPRI
_xEventGroupCreate:
;event_groups.c,174 :: 		EventGroupHandle_t xEventGroupCreate( void )
SUB	SP, SP, #8
STR	LR, [SP, #0]
;event_groups.c,179 :: 		pxEventBits = ( EventGroup_t * ) pvPortMalloc( sizeof( EventGroup_t ) );
MOVS	R0, #24
BL	_pvPortMalloc+0
; pxEventBits start address is: 4 (R1)
MOV	R1, R0
;event_groups.c,181 :: 		if( pxEventBits != NULL )
CMP	R0, #0
IT	EQ
BEQ	L_xEventGroupCreate0
;event_groups.c,183 :: 		pxEventBits->uxEventBits = 0;
MOVS	R0, #0
STR	R0, [R1, #0]
;event_groups.c,184 :: 		vListInitialise( &( pxEventBits->xTasksWaitingForBits ) );
ADDS	R0, R1, #4
STR	R1, [SP, #4]
BL	_vListInitialise+0
LDR	R1, [SP, #4]
;event_groups.c,196 :: 		}
IT	AL
BAL	L_xEventGroupCreate1
L_xEventGroupCreate0:
;event_groups.c,200 :: 		}
L_xEventGroupCreate1:
;event_groups.c,202 :: 		return ( EventGroupHandle_t ) pxEventBits;
MOV	R0, R1
; pxEventBits end address is: 4 (R1)
;event_groups.c,203 :: 		}
L_end_xEventGroupCreate:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _xEventGroupCreate
_xEventGroupSync:
;event_groups.c,208 :: 		EventBits_t xEventGroupSync( EventGroupHandle_t xEventGroup, const EventBits_t uxBitsToSet, const EventBits_t uxBitsToWaitFor, TickType_t xTicksToWait )
SUB	SP, SP, #32
STR	LR, [SP, #0]
STR	R0, [SP, #16]
STR	R1, [SP, #20]
STR	R2, [SP, #24]
STR	R3, [SP, #28]
;event_groups.c,211 :: 		EventGroup_t *pxEventBits = ( EventGroup_t * ) xEventGroup;
LDR	R4, [SP, #16]
STR	R4, [SP, #12]
;event_groups.c,213 :: 		BaseType_t xTimeoutOccurred = pdFALSE;
;event_groups.c,215 :: 		configASSERT( ( uxBitsToWaitFor & eventEVENT_BITS_CONTROL_BYTES ) == 0 );
LDR	R4, [SP, #24]
AND	R4, R4, #-16777216
CMP	R4, #0
MOVW	R4, #0
BNE	L__xEventGroupSync73
MOVS	R4, #1
L__xEventGroupSync73:
CMP	R4, #0
IT	NE
BNE	L_xEventGroupSync2
L_xEventGroupSync2:
;event_groups.c,216 :: 		configASSERT( uxBitsToWaitFor != 0 );
LDR	R4, [SP, #24]
CMP	R4, #0
MOVW	R4, #0
BEQ	L__xEventGroupSync74
MOVS	R4, #1
L__xEventGroupSync74:
CMP	R4, #0
IT	NE
BNE	L_xEventGroupSync3
L_xEventGroupSync3:
;event_groups.c,219 :: 		configASSERT( !( ( xTaskGetSchedulerState() == taskSCHEDULER_SUSPENDED ) && ( xTicksToWait != 0 ) ) );
BL	_xTaskGetSchedulerState+0
CMP	R0, #0
IT	NE
BNE	L_xEventGroupSync5
LDR	R4, [SP, #28]
CMP	R4, #0
IT	EQ
BEQ	L_xEventGroupSync5
MOVS	R4, #1
IT	AL
BAL	L_xEventGroupSync4
L_xEventGroupSync5:
MOVS	R4, #0
L_xEventGroupSync4:
CMP	R4, #0
MOVW	R4, #0
BNE	L__xEventGroupSync75
MOVS	R4, #1
L__xEventGroupSync75:
UXTB	R4, R4
CMP	R4, #0
IT	NE
BNE	L_xEventGroupSync6
L_xEventGroupSync6:
;event_groups.c,223 :: 		vTaskSuspendAll();
BL	_vTaskSuspendAll+0
;event_groups.c,225 :: 		uxOriginalBitValue = pxEventBits->uxEventBits;
LDR	R4, [SP, #12]
LDR	R4, [R4, #0]
; uxOriginalBitValue start address is: 0 (R0)
MOV	R0, R4
;event_groups.c,227 :: 		( void ) xEventGroupSetBits( xEventGroup, uxBitsToSet );
STR	R0, [SP, #4]
LDR	R1, [SP, #20]
LDR	R0, [SP, #16]
BL	_xEventGroupSetBits+0
LDR	R0, [SP, #4]
;event_groups.c,229 :: 		if( ( ( uxOriginalBitValue | uxBitsToSet ) & uxBitsToWaitFor ) == uxBitsToWaitFor )
LDR	R4, [SP, #20]
ORR	R5, R0, R4, LSL #0
LDR	R4, [SP, #24]
ANDS	R5, R4
LDR	R4, [SP, #24]
CMP	R5, R4
IT	NE
BNE	L_xEventGroupSync7
;event_groups.c,232 :: 		uxReturn = ( uxOriginalBitValue | uxBitsToSet );
LDR	R4, [SP, #20]
ORR	R4, R0, R4, LSL #0
; uxOriginalBitValue end address is: 0 (R0)
STR	R4, [SP, #8]
;event_groups.c,236 :: 		pxEventBits->uxEventBits &= ~uxBitsToWaitFor;
LDR	R4, [SP, #24]
MVN	R5, R4
LDR	R4, [SP, #12]
LDR	R4, [R4, #0]
AND	R5, R4, R5, LSL #0
LDR	R4, [SP, #12]
STR	R5, [R4, #0]
;event_groups.c,238 :: 		xTicksToWait = 0;
MOVS	R4, #0
STR	R4, [SP, #28]
;event_groups.c,239 :: 		}
IT	AL
BAL	L_xEventGroupSync8
L_xEventGroupSync7:
;event_groups.c,242 :: 		if( xTicksToWait != ( TickType_t ) 0 )
LDR	R4, [SP, #28]
CMP	R4, #0
IT	EQ
BEQ	L_xEventGroupSync9
;event_groups.c,249 :: 		vTaskPlaceOnUnorderedEventList( &( pxEventBits->xTasksWaitingForBits ), ( uxBitsToWaitFor | eventCLEAR_EVENTS_ON_EXIT_BIT | eventWAIT_FOR_ALL_BITS ), xTicksToWait );
LDR	R4, [SP, #24]
ORR	R4, R4, #16777216
ORR	R5, R4, #67108864
LDR	R4, [SP, #12]
ADDS	R4, R4, #4
LDR	R2, [SP, #28]
MOV	R1, R5
MOV	R0, R4
BL	_vTaskPlaceOnUnorderedEventList+0
;event_groups.c,255 :: 		uxReturn = 0;
MOVS	R4, #0
STR	R4, [SP, #8]
;event_groups.c,256 :: 		}
IT	AL
BAL	L_xEventGroupSync10
L_xEventGroupSync9:
;event_groups.c,261 :: 		uxReturn = pxEventBits->uxEventBits;
LDR	R4, [SP, #12]
LDR	R4, [R4, #0]
STR	R4, [SP, #8]
;event_groups.c,262 :: 		}
L_xEventGroupSync10:
;event_groups.c,263 :: 		}
L_xEventGroupSync8:
;event_groups.c,265 :: 		xAlreadyYielded = xTaskResumeAll();
BL	_xTaskResumeAll+0
; xAlreadyYielded start address is: 0 (R0)
;event_groups.c,267 :: 		if( xTicksToWait != ( TickType_t ) 0 )
LDR	R4, [SP, #28]
CMP	R4, #0
IT	EQ
BEQ	L_xEventGroupSync11
;event_groups.c,269 :: 		if( xAlreadyYielded == pdFALSE )
CMP	R0, #0
IT	NE
BNE	L_xEventGroupSync12
; xAlreadyYielded end address is: 0 (R0)
;event_groups.c,271 :: 		portYIELD_WITHIN_API();
MOVS	R6, #1
SXTB	R6, R6
MOVW	R5, #lo_addr(PENDSVSET_bit+0)
MOVT	R5, #hi_addr(PENDSVSET_bit+0)
_LX	[R5, ByteOffset(PENDSVSET_bit+0)]
BFI	R4, R6, BitPos(PENDSVSET_bit+0), #1
_SX	[R5, ByteOffset(PENDSVSET_bit+0)]
DSB	#15
ISB	#15
;event_groups.c,272 :: 		}
IT	AL
BAL	L_xEventGroupSync13
L_xEventGroupSync12:
;event_groups.c,276 :: 		}
L_xEventGroupSync13:
;event_groups.c,282 :: 		uxReturn = uxTaskResetEventItemValue();
BL	_uxTaskResetEventItemValue+0
STR	R0, [SP, #8]
;event_groups.c,284 :: 		if( ( uxReturn & eventUNBLOCKED_DUE_TO_BIT_SET ) == ( EventBits_t ) 0 )
AND	R4, R0, #33554432
CMP	R4, #0
IT	NE
BNE	L_xEventGroupSync14
;event_groups.c,287 :: 		taskENTER_CRITICAL();
BL	_vPortEnterCritical+0
;event_groups.c,289 :: 		uxReturn = pxEventBits->uxEventBits;
LDR	R4, [SP, #12]
LDR	R5, [R4, #0]
STR	R5, [SP, #8]
;event_groups.c,295 :: 		if( ( uxReturn & uxBitsToWaitFor ) == uxBitsToWaitFor )
LDR	R4, [SP, #24]
ANDS	R5, R4
LDR	R4, [SP, #24]
CMP	R5, R4
IT	NE
BNE	L_xEventGroupSync15
;event_groups.c,297 :: 		pxEventBits->uxEventBits &= ~uxBitsToWaitFor;
LDR	R4, [SP, #24]
MVN	R5, R4
LDR	R4, [SP, #12]
LDR	R4, [R4, #0]
AND	R5, R4, R5, LSL #0
LDR	R4, [SP, #12]
STR	R5, [R4, #0]
;event_groups.c,298 :: 		}
IT	AL
BAL	L_xEventGroupSync16
L_xEventGroupSync15:
;event_groups.c,302 :: 		}
L_xEventGroupSync16:
;event_groups.c,304 :: 		taskEXIT_CRITICAL();
BL	_vPortExitCritical+0
;event_groups.c,307 :: 		}
IT	AL
BAL	L_xEventGroupSync17
L_xEventGroupSync14:
;event_groups.c,311 :: 		}
L_xEventGroupSync17:
;event_groups.c,315 :: 		uxReturn &= ~eventEVENT_BITS_CONTROL_BYTES;
LDR	R5, [SP, #8]
MVN	R4, #-16777216
AND	R4, R5, R4, LSL #0
STR	R4, [SP, #8]
;event_groups.c,316 :: 		}
L_xEventGroupSync11:
;event_groups.c,320 :: 		return uxReturn;
LDR	R0, [SP, #8]
;event_groups.c,321 :: 		}
L_end_xEventGroupSync:
LDR	LR, [SP, #0]
ADD	SP, SP, #32
BX	LR
; end of _xEventGroupSync
_xEventGroupWaitBits:
;event_groups.c,324 :: 		EventBits_t xEventGroupWaitBits( EventGroupHandle_t xEventGroup, const EventBits_t uxBitsToWaitFor, const BaseType_t xClearOnExit, const BaseType_t xWaitForAllBits, TickType_t xTicksToWait )
; xEventGroup start address is: 0 (R0)
SUB	SP, SP, #28
STR	LR, [SP, #0]
STR	R1, [SP, #16]
STR	R2, [SP, #20]
STR	R3, [SP, #24]
; xEventGroup end address is: 0 (R0)
; xEventGroup start address is: 0 (R0)
LDR	R4, [SP, #28]
STR	R4, [SP, #28]
;event_groups.c,326 :: 		EventGroup_t *pxEventBits = ( EventGroup_t * ) xEventGroup;
STR	R0, [SP, #4]
;event_groups.c,327 :: 		EventBits_t uxReturn, uxControlBits = 0;
MOV	R4, #0
STR	R4, [SP, #12]
;event_groups.c,329 :: 		BaseType_t xTimeoutOccurred = pdFALSE;
;event_groups.c,333 :: 		configASSERT( xEventGroup );
CMP	R0, #0
IT	NE
BNE	L_xEventGroupWaitBits18
; xEventGroup end address is: 0 (R0)
L_xEventGroupWaitBits18:
;event_groups.c,334 :: 		configASSERT( ( uxBitsToWaitFor & eventEVENT_BITS_CONTROL_BYTES ) == 0 );
LDR	R4, [SP, #16]
AND	R4, R4, #-16777216
CMP	R4, #0
MOVW	R4, #0
BNE	L__xEventGroupWaitBits77
MOVS	R4, #1
L__xEventGroupWaitBits77:
CMP	R4, #0
IT	NE
BNE	L_xEventGroupWaitBits19
L_xEventGroupWaitBits19:
;event_groups.c,335 :: 		configASSERT( uxBitsToWaitFor != 0 );
LDR	R4, [SP, #16]
CMP	R4, #0
MOVW	R4, #0
BEQ	L__xEventGroupWaitBits78
MOVS	R4, #1
L__xEventGroupWaitBits78:
CMP	R4, #0
IT	NE
BNE	L_xEventGroupWaitBits20
L_xEventGroupWaitBits20:
;event_groups.c,338 :: 		configASSERT( !( ( xTaskGetSchedulerState() == taskSCHEDULER_SUSPENDED ) && ( xTicksToWait != 0 ) ) );
BL	_xTaskGetSchedulerState+0
CMP	R0, #0
IT	NE
BNE	L_xEventGroupWaitBits22
LDR	R4, [SP, #28]
CMP	R4, #0
IT	EQ
BEQ	L_xEventGroupWaitBits22
MOVS	R4, #1
IT	AL
BAL	L_xEventGroupWaitBits21
L_xEventGroupWaitBits22:
MOVS	R4, #0
L_xEventGroupWaitBits21:
CMP	R4, #0
MOVW	R4, #0
BNE	L__xEventGroupWaitBits79
MOVS	R4, #1
L__xEventGroupWaitBits79:
UXTB	R4, R4
CMP	R4, #0
IT	NE
BNE	L_xEventGroupWaitBits23
L_xEventGroupWaitBits23:
;event_groups.c,342 :: 		vTaskSuspendAll();
BL	_vTaskSuspendAll+0
;event_groups.c,344 :: 		const EventBits_t uxCurrentEventBits = pxEventBits->uxEventBits;
LDR	R4, [SP, #4]
LDR	R4, [R4, #0]
; uxCurrentEventBits start address is: 20 (R5)
MOV	R5, R4
;event_groups.c,347 :: 		xWaitConditionMet = prvTestWaitCondition( uxCurrentEventBits, uxBitsToWaitFor, xWaitForAllBits );
LDR	R2, [SP, #24]
LDR	R1, [SP, #16]
MOV	R0, R4
BL	event_groups_prvTestWaitCondition+0
;event_groups.c,349 :: 		if( xWaitConditionMet != pdFALSE )
CMP	R0, #0
IT	EQ
BEQ	L_xEventGroupWaitBits24
;event_groups.c,353 :: 		uxReturn = uxCurrentEventBits;
STR	R5, [SP, #8]
; uxCurrentEventBits end address is: 20 (R5)
;event_groups.c,354 :: 		xTicksToWait = ( TickType_t ) 0;
MOV	R4, #0
STR	R4, [SP, #28]
;event_groups.c,357 :: 		if( xClearOnExit != pdFALSE )
LDR	R4, [SP, #20]
CMP	R4, #0
IT	EQ
BEQ	L_xEventGroupWaitBits25
;event_groups.c,359 :: 		pxEventBits->uxEventBits &= ~uxBitsToWaitFor;
LDR	R4, [SP, #16]
MVN	R5, R4
LDR	R4, [SP, #4]
LDR	R4, [R4, #0]
AND	R5, R4, R5, LSL #0
LDR	R4, [SP, #4]
STR	R5, [R4, #0]
;event_groups.c,360 :: 		}
IT	AL
BAL	L_xEventGroupWaitBits26
L_xEventGroupWaitBits25:
;event_groups.c,364 :: 		}
L_xEventGroupWaitBits26:
;event_groups.c,365 :: 		}
IT	AL
BAL	L_xEventGroupWaitBits27
L_xEventGroupWaitBits24:
;event_groups.c,366 :: 		else if( xTicksToWait == ( TickType_t ) 0 )
; uxCurrentEventBits start address is: 20 (R5)
LDR	R4, [SP, #28]
CMP	R4, #0
IT	NE
BNE	L_xEventGroupWaitBits28
;event_groups.c,370 :: 		uxReturn = uxCurrentEventBits;
STR	R5, [SP, #8]
; uxCurrentEventBits end address is: 20 (R5)
;event_groups.c,371 :: 		}
IT	AL
BAL	L_xEventGroupWaitBits29
L_xEventGroupWaitBits28:
;event_groups.c,378 :: 		if( xClearOnExit != pdFALSE )
LDR	R4, [SP, #20]
CMP	R4, #0
IT	EQ
BEQ	L_xEventGroupWaitBits30
;event_groups.c,380 :: 		uxControlBits |= eventCLEAR_EVENTS_ON_EXIT_BIT;
LDR	R4, [SP, #12]
ORR	R4, R4, #16777216
STR	R4, [SP, #12]
;event_groups.c,381 :: 		}
IT	AL
BAL	L_xEventGroupWaitBits31
L_xEventGroupWaitBits30:
;event_groups.c,385 :: 		}
L_xEventGroupWaitBits31:
;event_groups.c,387 :: 		if( xWaitForAllBits != pdFALSE )
LDR	R4, [SP, #24]
CMP	R4, #0
IT	EQ
BEQ	L_xEventGroupWaitBits32
;event_groups.c,389 :: 		uxControlBits |= eventWAIT_FOR_ALL_BITS;
LDR	R4, [SP, #12]
ORR	R4, R4, #67108864
STR	R4, [SP, #12]
;event_groups.c,390 :: 		}
IT	AL
BAL	L_xEventGroupWaitBits33
L_xEventGroupWaitBits32:
;event_groups.c,394 :: 		}
L_xEventGroupWaitBits33:
;event_groups.c,399 :: 		vTaskPlaceOnUnorderedEventList( &( pxEventBits->xTasksWaitingForBits ), ( uxBitsToWaitFor | uxControlBits ), xTicksToWait );
LDR	R5, [SP, #12]
LDR	R4, [SP, #16]
ORR	R5, R4, R5, LSL #0
LDR	R4, [SP, #4]
ADDS	R4, R4, #4
LDR	R2, [SP, #28]
MOV	R1, R5
MOV	R0, R4
BL	_vTaskPlaceOnUnorderedEventList+0
;event_groups.c,404 :: 		uxReturn = 0;
MOVS	R4, #0
STR	R4, [SP, #8]
;event_groups.c,407 :: 		}
L_xEventGroupWaitBits29:
L_xEventGroupWaitBits27:
;event_groups.c,409 :: 		xAlreadyYielded = xTaskResumeAll();
BL	_xTaskResumeAll+0
; xAlreadyYielded start address is: 0 (R0)
;event_groups.c,411 :: 		if( xTicksToWait != ( TickType_t ) 0 )
LDR	R4, [SP, #28]
CMP	R4, #0
IT	EQ
BEQ	L_xEventGroupWaitBits34
;event_groups.c,413 :: 		if( xAlreadyYielded == pdFALSE )
CMP	R0, #0
IT	NE
BNE	L_xEventGroupWaitBits35
; xAlreadyYielded end address is: 0 (R0)
;event_groups.c,415 :: 		portYIELD_WITHIN_API();
MOVS	R6, #1
SXTB	R6, R6
MOVW	R5, #lo_addr(PENDSVSET_bit+0)
MOVT	R5, #hi_addr(PENDSVSET_bit+0)
_LX	[R5, ByteOffset(PENDSVSET_bit+0)]
BFI	R4, R6, BitPos(PENDSVSET_bit+0), #1
_SX	[R5, ByteOffset(PENDSVSET_bit+0)]
DSB	#15
ISB	#15
;event_groups.c,416 :: 		}
IT	AL
BAL	L_xEventGroupWaitBits36
L_xEventGroupWaitBits35:
;event_groups.c,420 :: 		}
L_xEventGroupWaitBits36:
;event_groups.c,426 :: 		uxReturn = uxTaskResetEventItemValue();
BL	_uxTaskResetEventItemValue+0
STR	R0, [SP, #8]
;event_groups.c,428 :: 		if( ( uxReturn & eventUNBLOCKED_DUE_TO_BIT_SET ) == ( EventBits_t ) 0 )
AND	R4, R0, #33554432
CMP	R4, #0
IT	NE
BNE	L_xEventGroupWaitBits37
;event_groups.c,430 :: 		taskENTER_CRITICAL();
BL	_vPortEnterCritical+0
;event_groups.c,433 :: 		uxReturn = pxEventBits->uxEventBits;
LDR	R4, [SP, #4]
LDR	R4, [R4, #0]
STR	R4, [SP, #8]
;event_groups.c,437 :: 		if( prvTestWaitCondition( uxReturn, uxBitsToWaitFor, xWaitForAllBits ) != pdFALSE )
LDR	R2, [SP, #24]
LDR	R1, [SP, #16]
MOV	R0, R4
BL	event_groups_prvTestWaitCondition+0
CMP	R0, #0
IT	EQ
BEQ	L_xEventGroupWaitBits38
;event_groups.c,439 :: 		if( xClearOnExit != pdFALSE )
LDR	R4, [SP, #20]
CMP	R4, #0
IT	EQ
BEQ	L_xEventGroupWaitBits39
;event_groups.c,441 :: 		pxEventBits->uxEventBits &= ~uxBitsToWaitFor;
LDR	R4, [SP, #16]
MVN	R5, R4
LDR	R4, [SP, #4]
LDR	R4, [R4, #0]
AND	R5, R4, R5, LSL #0
LDR	R4, [SP, #4]
STR	R5, [R4, #0]
;event_groups.c,442 :: 		}
IT	AL
BAL	L_xEventGroupWaitBits40
L_xEventGroupWaitBits39:
;event_groups.c,446 :: 		}
L_xEventGroupWaitBits40:
;event_groups.c,447 :: 		}
IT	AL
BAL	L_xEventGroupWaitBits41
L_xEventGroupWaitBits38:
;event_groups.c,451 :: 		}
L_xEventGroupWaitBits41:
;event_groups.c,453 :: 		taskEXIT_CRITICAL();
BL	_vPortExitCritical+0
;event_groups.c,457 :: 		}
IT	AL
BAL	L_xEventGroupWaitBits42
L_xEventGroupWaitBits37:
;event_groups.c,461 :: 		}
L_xEventGroupWaitBits42:
;event_groups.c,464 :: 		uxReturn &= ~eventEVENT_BITS_CONTROL_BYTES;
LDR	R5, [SP, #8]
MVN	R4, #-16777216
AND	R4, R5, R4, LSL #0
STR	R4, [SP, #8]
;event_groups.c,465 :: 		}
L_xEventGroupWaitBits34:
;event_groups.c,468 :: 		return uxReturn;
LDR	R0, [SP, #8]
;event_groups.c,469 :: 		}
L_end_xEventGroupWaitBits:
LDR	LR, [SP, #0]
ADD	SP, SP, #28
BX	LR
; end of _xEventGroupWaitBits
_xEventGroupClearBits:
;event_groups.c,472 :: 		EventBits_t xEventGroupClearBits( EventGroupHandle_t xEventGroup, const EventBits_t uxBitsToClear )
; uxBitsToClear start address is: 4 (R1)
; xEventGroup start address is: 0 (R0)
SUB	SP, SP, #16
STR	LR, [SP, #0]
MOV	R2, R0
MOV	R0, R1
; uxBitsToClear end address is: 4 (R1)
; xEventGroup end address is: 0 (R0)
; xEventGroup start address is: 8 (R2)
; uxBitsToClear start address is: 0 (R0)
;event_groups.c,474 :: 		EventGroup_t *pxEventBits = ( EventGroup_t * ) xEventGroup;
; pxEventBits start address is: 4 (R1)
MOV	R1, R2
;event_groups.c,479 :: 		configASSERT( xEventGroup );
CMP	R2, #0
IT	NE
BNE	L_xEventGroupClearBits43
; xEventGroup end address is: 8 (R2)
L_xEventGroupClearBits43:
;event_groups.c,480 :: 		configASSERT( ( uxBitsToClear & eventEVENT_BITS_CONTROL_BYTES ) == 0 );
AND	R2, R0, #-16777216
CMP	R2, #0
MOVW	R2, #0
BNE	L__xEventGroupClearBits81
MOVS	R2, #1
L__xEventGroupClearBits81:
CMP	R2, #0
IT	NE
BNE	L_xEventGroupClearBits44
L_xEventGroupClearBits44:
;event_groups.c,482 :: 		taskENTER_CRITICAL();
STR	R1, [SP, #4]
STR	R0, [SP, #8]
BL	_vPortEnterCritical+0
LDR	R0, [SP, #8]
LDR	R1, [SP, #4]
;event_groups.c,488 :: 		uxReturn = pxEventBits->uxEventBits;
LDR	R3, [R1, #0]
STR	R3, [SP, #12]
;event_groups.c,491 :: 		pxEventBits->uxEventBits &= ~uxBitsToClear;
MVN	R2, R0
; uxBitsToClear end address is: 0 (R0)
AND	R2, R3, R2, LSL #0
STR	R2, [R1, #0]
; pxEventBits end address is: 4 (R1)
;event_groups.c,493 :: 		taskEXIT_CRITICAL();
BL	_vPortExitCritical+0
;event_groups.c,495 :: 		return uxReturn;
LDR	R0, [SP, #12]
;event_groups.c,496 :: 		}
L_end_xEventGroupClearBits:
LDR	LR, [SP, #0]
ADD	SP, SP, #16
BX	LR
; end of _xEventGroupClearBits
_xEventGroupGetBitsFromISR:
;event_groups.c,514 :: 		EventBits_t xEventGroupGetBitsFromISR( EventGroupHandle_t xEventGroup )
; xEventGroup start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; xEventGroup end address is: 0 (R0)
; xEventGroup start address is: 0 (R0)
;event_groups.c,517 :: 		EventGroup_t *pxEventBits = ( EventGroup_t * ) xEventGroup;
; pxEventBits start address is: 8 (R2)
MOV	R2, R0
; xEventGroup end address is: 0 (R0)
;event_groups.c,520 :: 		uxSavedInterruptStatus = portSET_INTERRUPT_MASK_FROM_ISR();
BL	event_groups_ulPortRaiseBASEPRI+0
;event_groups.c,522 :: 		uxReturn = pxEventBits->uxEventBits;
LDR	R1, [R2, #0]
; pxEventBits end address is: 8 (R2)
; uxReturn start address is: 8 (R2)
MOV	R2, R1
;event_groups.c,524 :: 		portCLEAR_INTERRUPT_MASK_FROM_ISR( uxSavedInterruptStatus );
BL	event_groups_vPortSetBASEPRI+0
;event_groups.c,526 :: 		return uxReturn;
MOV	R0, R2
; uxReturn end address is: 8 (R2)
;event_groups.c,527 :: 		}
L_end_xEventGroupGetBitsFromISR:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _xEventGroupGetBitsFromISR
_xEventGroupSetBits:
;event_groups.c,530 :: 		EventBits_t xEventGroupSetBits( EventGroupHandle_t xEventGroup, const EventBits_t uxBitsToSet )
; uxBitsToSet start address is: 4 (R1)
; xEventGroup start address is: 0 (R0)
SUB	SP, SP, #32
STR	LR, [SP, #0]
MOV	R3, R0
MOV	R0, R1
; uxBitsToSet end address is: 4 (R1)
; xEventGroup end address is: 0 (R0)
; xEventGroup start address is: 12 (R3)
; uxBitsToSet start address is: 0 (R0)
;event_groups.c,535 :: 		EventBits_t uxBitsToClear = 0, uxBitsWaitedFor, uxControlBits;
MOV	R2, #0
STR	R2, [SP, #24]
;event_groups.c,536 :: 		EventGroup_t *pxEventBits = ( EventGroup_t * ) xEventGroup;
; pxEventBits start address is: 4 (R1)
MOV	R1, R3
;event_groups.c,537 :: 		BaseType_t xMatchFound = pdFALSE;
;event_groups.c,541 :: 		configASSERT( xEventGroup );
CMP	R3, #0
IT	NE
BNE	L_xEventGroupSetBits45
; xEventGroup end address is: 12 (R3)
L_xEventGroupSetBits45:
;event_groups.c,542 :: 		configASSERT( ( uxBitsToSet & eventEVENT_BITS_CONTROL_BYTES ) == 0 );
AND	R2, R0, #-16777216
CMP	R2, #0
MOVW	R2, #0
BNE	L__xEventGroupSetBits84
MOVS	R2, #1
L__xEventGroupSetBits84:
CMP	R2, #0
IT	NE
BNE	L_xEventGroupSetBits46
L_xEventGroupSetBits46:
;event_groups.c,544 :: 		pxList = &( pxEventBits->xTasksWaitingForBits );
ADDS	R2, R1, #4
STR	R2, [SP, #20]
;event_groups.c,545 :: 		pxListEnd = listGET_END_MARKER( pxList ); /*lint !e826 !e740 The mini list structure is used as the list end to save RAM.  This is checked and valid. */
ADDS	R2, #8
STR	R2, [SP, #16]
;event_groups.c,546 :: 		vTaskSuspendAll();
STR	R1, [SP, #4]
STR	R0, [SP, #8]
BL	_vTaskSuspendAll+0
LDR	R0, [SP, #8]
LDR	R1, [SP, #4]
;event_groups.c,550 :: 		pxListItem = listGET_HEAD_ENTRY( pxList );
LDR	R2, [SP, #20]
ADDS	R2, #8
ADDS	R2, R2, #4
LDR	R6, [R2, #0]
; pxListItem start address is: 24 (R6)
;event_groups.c,553 :: 		pxEventBits->uxEventBits |= uxBitsToSet;
LDR	R2, [R1, #0]
ORRS	R2, R0
; uxBitsToSet end address is: 0 (R0)
STR	R2, [R1, #0]
; pxEventBits end address is: 4 (R1)
; pxListItem end address is: 24 (R6)
MOV	R0, R6
;event_groups.c,556 :: 		while( pxListItem != pxListEnd )
L_xEventGroupSetBits47:
; pxListItem start address is: 0 (R0)
; pxEventBits start address is: 4 (R1)
LDR	R2, [SP, #16]
CMP	R0, R2
IT	EQ
BEQ	L_xEventGroupSetBits48
;event_groups.c,558 :: 		pxNext = listGET_NEXT( pxListItem );
ADDS	R2, R0, #4
LDR	R2, [R2, #0]
STR	R2, [SP, #12]
;event_groups.c,559 :: 		uxBitsWaitedFor = listGET_LIST_ITEM_VALUE( pxListItem );
LDR	R4, [R0, #0]
;event_groups.c,560 :: 		xMatchFound = pdFALSE;
MOV	R2, #0
STR	R2, [SP, #28]
;event_groups.c,563 :: 		uxControlBits = uxBitsWaitedFor & eventEVENT_BITS_CONTROL_BYTES;
AND	R3, R4, #-16777216
; uxControlBits start address is: 20 (R5)
MOV	R5, R3
;event_groups.c,564 :: 		uxBitsWaitedFor &= ~eventEVENT_BITS_CONTROL_BYTES;
MVN	R2, #-16777216
AND	R2, R4, R2, LSL #0
; uxBitsWaitedFor start address is: 16 (R4)
MOV	R4, R2
;event_groups.c,566 :: 		if( ( uxControlBits & eventWAIT_FOR_ALL_BITS ) == ( EventBits_t ) 0 )
AND	R2, R3, #67108864
CMP	R2, #0
IT	NE
BNE	L_xEventGroupSetBits49
;event_groups.c,569 :: 		if( ( uxBitsWaitedFor & pxEventBits->uxEventBits ) != ( EventBits_t ) 0 )
LDR	R2, [R1, #0]
AND	R2, R4, R2, LSL #0
CMP	R2, #0
IT	EQ
BEQ	L_xEventGroupSetBits50
;event_groups.c,571 :: 		xMatchFound = pdTRUE;
MOV	R2, #1
STR	R2, [SP, #28]
;event_groups.c,572 :: 		}
IT	AL
BAL	L_xEventGroupSetBits51
L_xEventGroupSetBits50:
;event_groups.c,576 :: 		}
L_xEventGroupSetBits51:
;event_groups.c,577 :: 		}
IT	AL
BAL	L_xEventGroupSetBits52
L_xEventGroupSetBits49:
;event_groups.c,578 :: 		else if( ( uxBitsWaitedFor & pxEventBits->uxEventBits ) == uxBitsWaitedFor )
LDR	R2, [R1, #0]
AND	R2, R4, R2, LSL #0
CMP	R2, R4
IT	NE
BNE	L_xEventGroupSetBits53
;event_groups.c,581 :: 		xMatchFound = pdTRUE;
MOV	R2, #1
STR	R2, [SP, #28]
;event_groups.c,582 :: 		}
IT	AL
BAL	L_xEventGroupSetBits54
L_xEventGroupSetBits53:
;event_groups.c,586 :: 		}
L_xEventGroupSetBits54:
L_xEventGroupSetBits52:
;event_groups.c,588 :: 		if( xMatchFound != pdFALSE )
LDR	R2, [SP, #28]
CMP	R2, #0
IT	EQ
BEQ	L_xEventGroupSetBits55
;event_groups.c,591 :: 		if( ( uxControlBits & eventCLEAR_EVENTS_ON_EXIT_BIT ) != ( EventBits_t ) 0 )
AND	R2, R5, #16777216
; uxControlBits end address is: 20 (R5)
CMP	R2, #0
IT	EQ
BEQ	L_xEventGroupSetBits56
;event_groups.c,593 :: 		uxBitsToClear |= uxBitsWaitedFor;
LDR	R2, [SP, #24]
ORRS	R2, R4
; uxBitsWaitedFor end address is: 16 (R4)
STR	R2, [SP, #24]
;event_groups.c,594 :: 		}
IT	AL
BAL	L_xEventGroupSetBits57
L_xEventGroupSetBits56:
;event_groups.c,598 :: 		}
L_xEventGroupSetBits57:
;event_groups.c,605 :: 		( void ) xTaskRemoveFromUnorderedEventList( pxListItem, pxEventBits->uxEventBits | eventUNBLOCKED_DUE_TO_BIT_SET );
LDR	R2, [R1, #0]
ORR	R2, R2, #33554432
STR	R1, [SP, #4]
MOV	R1, R2
; pxListItem end address is: 0 (R0)
BL	_xTaskRemoveFromUnorderedEventList+0
LDR	R1, [SP, #4]
;event_groups.c,606 :: 		}
L_xEventGroupSetBits55:
;event_groups.c,611 :: 		pxListItem = pxNext;
; pxListItem start address is: 24 (R6)
LDR	R6, [SP, #12]
;event_groups.c,612 :: 		}
; pxListItem end address is: 24 (R6)
MOV	R0, R6
IT	AL
BAL	L_xEventGroupSetBits47
L_xEventGroupSetBits48:
;event_groups.c,616 :: 		pxEventBits->uxEventBits &= ~uxBitsToClear;
LDR	R2, [SP, #24]
MVN	R3, R2
LDR	R2, [R1, #0]
ANDS	R2, R3
STR	R2, [R1, #0]
;event_groups.c,618 :: 		( void ) xTaskResumeAll();
STR	R1, [SP, #4]
BL	_xTaskResumeAll+0
LDR	R1, [SP, #4]
;event_groups.c,620 :: 		return pxEventBits->uxEventBits;
LDR	R2, [R1, #0]
; pxEventBits end address is: 4 (R1)
MOV	R0, R2
;event_groups.c,621 :: 		}
L_end_xEventGroupSetBits:
LDR	LR, [SP, #0]
ADD	SP, SP, #32
BX	LR
; end of _xEventGroupSetBits
_vEventGroupDelete:
;event_groups.c,624 :: 		void vEventGroupDelete( EventGroupHandle_t xEventGroup )
; xEventGroup start address is: 0 (R0)
SUB	SP, SP, #12
STR	LR, [SP, #0]
; xEventGroup end address is: 0 (R0)
; xEventGroup start address is: 0 (R0)
;event_groups.c,626 :: 		EventGroup_t *pxEventBits = ( EventGroup_t * ) xEventGroup;
STR	R0, [SP, #4]
;event_groups.c,627 :: 		const List_t *pxTasksWaitingForBits = &( pxEventBits->xTasksWaitingForBits );
ADDS	R1, R0, #4
; xEventGroup end address is: 0 (R0)
STR	R1, [SP, #8]
;event_groups.c,629 :: 		vTaskSuspendAll();
BL	_vTaskSuspendAll+0
;event_groups.c,633 :: 		while( listCURRENT_LIST_LENGTH( pxTasksWaitingForBits ) > ( UBaseType_t ) 0 )
L_vEventGroupDelete58:
LDR	R1, [SP, #8]
LDR	R1, [R1, #0]
CMP	R1, #0
IT	LS
BLS	L_vEventGroupDelete59
;event_groups.c,637 :: 		configASSERT( pxTasksWaitingForBits->xListEnd.pxNext != ( ListItem_t * ) &( pxTasksWaitingForBits->xListEnd ) );
LDR	R1, [SP, #8]
ADDW	R3, R1, #8
ADDS	R1, R3, #4
LDR	R2, [R1, #0]
MOV	R1, R3
CMP	R2, R1
MOVW	R1, #0
BEQ	L__vEventGroupDelete86
MOVS	R1, #1
L__vEventGroupDelete86:
CMP	R1, #0
IT	NE
BNE	L_vEventGroupDelete60
L_vEventGroupDelete60:
;event_groups.c,638 :: 		( void ) xTaskRemoveFromUnorderedEventList( pxTasksWaitingForBits->xListEnd.pxNext, eventUNBLOCKED_DUE_TO_BIT_SET );
LDR	R1, [SP, #8]
ADDS	R1, #8
ADDS	R1, R1, #4
LDR	R1, [R1, #0]
MOV	R0, R1
MOV	R1, #33554432
BL	_xTaskRemoveFromUnorderedEventList+0
;event_groups.c,639 :: 		}
IT	AL
BAL	L_vEventGroupDelete58
L_vEventGroupDelete59:
;event_groups.c,645 :: 		vPortFree( pxEventBits );
LDR	R0, [SP, #4]
BL	_vPortFree+0
;event_groups.c,662 :: 		( void ) xTaskResumeAll();
BL	_xTaskResumeAll+0
;event_groups.c,663 :: 		}
L_end_vEventGroupDelete:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _vEventGroupDelete
_vEventGroupSetBitsCallback:
;event_groups.c,668 :: 		void vEventGroupSetBitsCallback( void *pvEventGroup, const uint32_t ulBitsToSet )
; ulBitsToSet start address is: 4 (R1)
; pvEventGroup start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; ulBitsToSet end address is: 4 (R1)
; pvEventGroup end address is: 0 (R0)
; pvEventGroup start address is: 0 (R0)
; ulBitsToSet start address is: 4 (R1)
;event_groups.c,670 :: 		( void ) xEventGroupSetBits( pvEventGroup, ( EventBits_t ) ulBitsToSet );
; ulBitsToSet end address is: 4 (R1)
; pvEventGroup end address is: 0 (R0)
BL	_xEventGroupSetBits+0
;event_groups.c,671 :: 		}
L_end_vEventGroupSetBitsCallback:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _vEventGroupSetBitsCallback
_vEventGroupClearBitsCallback:
;event_groups.c,676 :: 		void vEventGroupClearBitsCallback( void *pvEventGroup, const uint32_t ulBitsToClear )
; ulBitsToClear start address is: 4 (R1)
; pvEventGroup start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; ulBitsToClear end address is: 4 (R1)
; pvEventGroup end address is: 0 (R0)
; pvEventGroup start address is: 0 (R0)
; ulBitsToClear start address is: 4 (R1)
;event_groups.c,678 :: 		( void ) xEventGroupClearBits( pvEventGroup, ( EventBits_t ) ulBitsToClear );
; ulBitsToClear end address is: 4 (R1)
; pvEventGroup end address is: 0 (R0)
BL	_xEventGroupClearBits+0
;event_groups.c,679 :: 		}
L_end_vEventGroupClearBitsCallback:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _vEventGroupClearBitsCallback
event_groups_prvTestWaitCondition:
;event_groups.c,682 :: 		static BaseType_t prvTestWaitCondition( const EventBits_t uxCurrentEventBits, const EventBits_t uxBitsToWaitFor, const BaseType_t xWaitForAllBits )
; xWaitForAllBits start address is: 8 (R2)
; uxBitsToWaitFor start address is: 4 (R1)
; uxCurrentEventBits start address is: 0 (R0)
MOV	R3, R2
; xWaitForAllBits end address is: 8 (R2)
; uxBitsToWaitFor end address is: 4 (R1)
; uxCurrentEventBits end address is: 0 (R0)
; uxCurrentEventBits start address is: 0 (R0)
; uxBitsToWaitFor start address is: 4 (R1)
; xWaitForAllBits start address is: 12 (R3)
;event_groups.c,684 :: 		BaseType_t xWaitConditionMet = pdFALSE;
; xWaitConditionMet start address is: 8 (R2)
MOV	R2, #0
;event_groups.c,686 :: 		if( xWaitForAllBits == pdFALSE )
CMP	R3, #0
IT	NE
BNE	L_event_groups_prvTestWaitCondition61
; xWaitForAllBits end address is: 12 (R3)
;event_groups.c,690 :: 		if( ( uxCurrentEventBits & uxBitsToWaitFor ) != ( EventBits_t ) 0 )
AND	R3, R0, R1, LSL #0
; uxCurrentEventBits end address is: 0 (R0)
; uxBitsToWaitFor end address is: 4 (R1)
CMP	R3, #0
IT	EQ
BEQ	L_event_groups_prvTestWaitCondition62
; xWaitConditionMet end address is: 8 (R2)
;event_groups.c,692 :: 		xWaitConditionMet = pdTRUE;
; xWaitConditionMet start address is: 0 (R0)
MOV	R0, #1
;event_groups.c,693 :: 		}
; xWaitConditionMet end address is: 0 (R0)
IT	AL
BAL	L_event_groups_prvTestWaitCondition63
L_event_groups_prvTestWaitCondition62:
;event_groups.c,697 :: 		}
; xWaitConditionMet start address is: 8 (R2)
MOV	R0, R2
L_event_groups_prvTestWaitCondition63:
; xWaitConditionMet end address is: 8 (R2)
;event_groups.c,698 :: 		}
; xWaitConditionMet start address is: 0 (R0)
; xWaitConditionMet end address is: 0 (R0)
IT	AL
BAL	L_event_groups_prvTestWaitCondition64
L_event_groups_prvTestWaitCondition61:
;event_groups.c,703 :: 		if( ( uxCurrentEventBits & uxBitsToWaitFor ) == uxBitsToWaitFor )
; xWaitConditionMet start address is: 8 (R2)
; uxBitsToWaitFor start address is: 4 (R1)
; uxCurrentEventBits start address is: 0 (R0)
AND	R3, R0, R1, LSL #0
; uxCurrentEventBits end address is: 0 (R0)
CMP	R3, R1
IT	NE
BNE	L_event_groups_prvTestWaitCondition65
; uxBitsToWaitFor end address is: 4 (R1)
; xWaitConditionMet end address is: 8 (R2)
;event_groups.c,705 :: 		xWaitConditionMet = pdTRUE;
; xWaitConditionMet start address is: 0 (R0)
MOV	R0, #1
;event_groups.c,706 :: 		}
; xWaitConditionMet end address is: 0 (R0)
IT	AL
BAL	L_event_groups_prvTestWaitCondition66
L_event_groups_prvTestWaitCondition65:
;event_groups.c,710 :: 		}
; xWaitConditionMet start address is: 8 (R2)
MOV	R0, R2
L_event_groups_prvTestWaitCondition66:
; xWaitConditionMet end address is: 8 (R2)
;event_groups.c,711 :: 		}
; xWaitConditionMet start address is: 0 (R0)
; xWaitConditionMet end address is: 0 (R0)
L_event_groups_prvTestWaitCondition64:
;event_groups.c,713 :: 		return xWaitConditionMet;
; xWaitConditionMet start address is: 0 (R0)
; xWaitConditionMet end address is: 0 (R0)
;event_groups.c,714 :: 		}
L_end_prvTestWaitCondition:
BX	LR
; end of event_groups_prvTestWaitCondition
