heap_3_ucPortCountLeadingZeros:
;portmacro.h,183 :: 		static inline uint8_t ucPortCountLeadingZeros(uint32_t ulBitmap)
;portmacro.h,185 :: 		asm CLZ R0, R0;
CLZ	R0, R0
;portmacro.h,186 :: 		return R0;
UXTB	R0, R0
;portmacro.h,187 :: 		}
L_end_ucPortCountLeadingZeros:
BX	LR
; end of heap_3_ucPortCountLeadingZeros
heap_3_vPortRaiseBASEPRI:
;portmacro.h,229 :: 		portFORCE_INLINE static void vPortRaiseBASEPRI( void )
;portmacro.h,234 :: 		CPU_REG_SET(CPU_BASEPRI, ulNewBASEPRI);
MOV	R0, #16
MOV	R12, R0
MSR	#17, R12
;portmacro.h,236 :: 		asm ISB;
ISB	#15
;portmacro.h,237 :: 		asm DSB;
DSB	#15
;portmacro.h,238 :: 		}
L_end_vPortRaiseBASEPRI:
BX	LR
; end of heap_3_vPortRaiseBASEPRI
heap_3_ulPortRaiseBASEPRI:
;portmacro.h,241 :: 		portFORCE_INLINE static uint32_t ulPortRaiseBASEPRI( void )
;portmacro.h,245 :: 		ulOriginalBASEPRI = CPU_REG_GET(CPU_BASEPRI);
MRS	R12, #17
MOV	R0, R12
; ulOriginalBASEPRI start address is: 4 (R1)
MOV	R1, R0
;portmacro.h,247 :: 		CPU_REG_SET(CPU_BASEPRI, ulNewBASEPRI);
MOV	R0, #16
MOV	R12, R0
MSR	#17, R12
;portmacro.h,249 :: 		asm ISB;
ISB	#15
;portmacro.h,250 :: 		asm DSB;
DSB	#15
;portmacro.h,254 :: 		return ulOriginalBASEPRI;
MOV	R0, R1
; ulOriginalBASEPRI end address is: 4 (R1)
;portmacro.h,255 :: 		}
L_end_ulPortRaiseBASEPRI:
BX	LR
; end of heap_3_ulPortRaiseBASEPRI
heap_3_vPortSetBASEPRI:
;portmacro.h,258 :: 		portFORCE_INLINE static void vPortSetBASEPRI( uint32_t ulNewMaskValue )
; ulNewMaskValue start address is: 0 (R0)
; ulNewMaskValue end address is: 0 (R0)
; ulNewMaskValue start address is: 0 (R0)
;portmacro.h,260 :: 		CPU_REG_SET(CPU_BASEPRI, ulNewMaskValue);
MOV	R1, R0
; ulNewMaskValue end address is: 0 (R0)
MOV	R12, R1
MSR	#17, R12
;portmacro.h,261 :: 		}
L_end_vPortSetBASEPRI:
BX	LR
; end of heap_3_vPortSetBASEPRI
_pvPortMalloc:
;heap_3.c,102 :: 		void *pvPortMalloc( size_t xWantedSize )
SUB	SP, SP, #12
STR	LR, [SP, #0]
STR	R0, [SP, #8]
;heap_3.c,106 :: 		vTaskSuspendAll();
BL	_vTaskSuspendAll+0
;heap_3.c,108 :: 		pvReturn = malloc( xWantedSize );
LDR	R0, [SP, #8]
BL	_malloc+0
STR	R0, [SP, #4]
;heap_3.c,111 :: 		( void ) xTaskResumeAll();
BL	_xTaskResumeAll+0
;heap_3.c,123 :: 		return pvReturn;
LDR	R0, [SP, #4]
;heap_3.c,124 :: 		}
L_end_pvPortMalloc:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _pvPortMalloc
_vPortFree:
;heap_3.c,127 :: 		void vPortFree( void *pv )
; pv start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
; pv end address is: 0 (R0)
; pv start address is: 0 (R0)
;heap_3.c,129 :: 		if( pv )
CMP	R0, #0
IT	EQ
BEQ	L_vPortFree0
;heap_3.c,131 :: 		vTaskSuspendAll();
STR	R0, [SP, #4]
BL	_vTaskSuspendAll+0
LDR	R0, [SP, #4]
;heap_3.c,133 :: 		free( pv );
; pv end address is: 0 (R0)
BL	_free+0
;heap_3.c,136 :: 		( void ) xTaskResumeAll();
BL	_xTaskResumeAll+0
;heap_3.c,137 :: 		}
L_vPortFree0:
;heap_3.c,138 :: 		}
L_end_vPortFree:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _vPortFree
