heap_4_ucPortCountLeadingZeros:
;portmacro.h,183 :: 		static inline uint8_t ucPortCountLeadingZeros(uint32_t ulBitmap)
;portmacro.h,185 :: 		asm CLZ R0, R0;
CLZ	R0, R0
;portmacro.h,186 :: 		return R0;
UXTB	R0, R0
;portmacro.h,187 :: 		}
L_end_ucPortCountLeadingZeros:
BX	LR
; end of heap_4_ucPortCountLeadingZeros
heap_4_vPortRaiseBASEPRI:
;portmacro.h,229 :: 		portFORCE_INLINE static void vPortRaiseBASEPRI( void )
;portmacro.h,234 :: 		CPU_REG_SET(CPU_BASEPRI, ulNewBASEPRI);
MOV	R0, #16
MOV	R12, R0
MSR	#17, R12
;portmacro.h,236 :: 		asm ISB;
ISB	#15
;portmacro.h,237 :: 		asm DSB;
DSB	#15
;portmacro.h,238 :: 		}
L_end_vPortRaiseBASEPRI:
BX	LR
; end of heap_4_vPortRaiseBASEPRI
heap_4_ulPortRaiseBASEPRI:
;portmacro.h,241 :: 		portFORCE_INLINE static uint32_t ulPortRaiseBASEPRI( void )
;portmacro.h,245 :: 		ulOriginalBASEPRI = CPU_REG_GET(CPU_BASEPRI);
MRS	R12, #17
MOV	R0, R12
; ulOriginalBASEPRI start address is: 4 (R1)
MOV	R1, R0
;portmacro.h,247 :: 		CPU_REG_SET(CPU_BASEPRI, ulNewBASEPRI);
MOV	R0, #16
MOV	R12, R0
MSR	#17, R12
;portmacro.h,249 :: 		asm ISB;
ISB	#15
;portmacro.h,250 :: 		asm DSB;
DSB	#15
;portmacro.h,254 :: 		return ulOriginalBASEPRI;
MOV	R0, R1
; ulOriginalBASEPRI end address is: 4 (R1)
;portmacro.h,255 :: 		}
L_end_ulPortRaiseBASEPRI:
BX	LR
; end of heap_4_ulPortRaiseBASEPRI
heap_4_vPortSetBASEPRI:
;portmacro.h,258 :: 		portFORCE_INLINE static void vPortSetBASEPRI( uint32_t ulNewMaskValue )
; ulNewMaskValue start address is: 0 (R0)
; ulNewMaskValue end address is: 0 (R0)
; ulNewMaskValue start address is: 0 (R0)
;portmacro.h,260 :: 		CPU_REG_SET(CPU_BASEPRI, ulNewMaskValue);
MOV	R1, R0
; ulNewMaskValue end address is: 0 (R0)
MOV	R12, R1
MSR	#17, R12
;portmacro.h,261 :: 		}
L_end_vPortSetBASEPRI:
BX	LR
; end of heap_4_vPortSetBASEPRI
_pvPortMalloc:
;heap_4.c,155 :: 		void *pvPortMalloc( size_t xWantedSize )
; xWantedSize start address is: 0 (R0)
SUB	SP, SP, #12
STR	LR, [SP, #0]
MOV	R2, R0
; xWantedSize end address is: 0 (R0)
; xWantedSize start address is: 8 (R2)
;heap_4.c,158 :: 		void *pvReturn = NULL;
; pvReturn start address is: 0 (R0)
MOV	R0, #0
;heap_4.c,160 :: 		vTaskSuspendAll();
STR	R0, [SP, #4]
STR	R2, [SP, #8]
BL	_vTaskSuspendAll+0
LDR	R2, [SP, #8]
LDR	R0, [SP, #4]
;heap_4.c,164 :: 		if( pxEnd == NULL )
MOVW	R1, #lo_addr(heap_4_pxEnd+0)
MOVT	R1, #hi_addr(heap_4_pxEnd+0)
LDR	R1, [R1, #0]
CMP	R1, #0
IT	NE
BNE	L_pvPortMalloc0
;heap_4.c,166 :: 		prvHeapInit();
STR	R0, [SP, #4]
STR	R2, [SP, #8]
BL	heap_4_prvHeapInit+0
LDR	R2, [SP, #8]
LDR	R0, [SP, #4]
;heap_4.c,167 :: 		}
IT	AL
BAL	L_pvPortMalloc1
L_pvPortMalloc0:
;heap_4.c,171 :: 		}
L_pvPortMalloc1:
;heap_4.c,177 :: 		if( ( xWantedSize & xBlockAllocatedBit ) == 0 )
MOVW	R1, #lo_addr(heap_4_xBlockAllocatedBit+0)
MOVT	R1, #hi_addr(heap_4_xBlockAllocatedBit+0)
LDR	R1, [R1, #0]
AND	R1, R2, R1, LSL #0
CMP	R1, #0
IT	NE
BNE	L_pvPortMalloc2
;heap_4.c,181 :: 		if( xWantedSize > 0 )
CMP	R2, #0
IT	LS
BLS	L_pvPortMalloc3
;heap_4.c,183 :: 		xWantedSize += xHeapStructSize;
ADDW	R1, R2, #8
MOV	R2, R1
;heap_4.c,187 :: 		if( ( xWantedSize & portBYTE_ALIGNMENT_MASK ) != 0x00 )
AND	R1, R1, #7
CMP	R1, #0
IT	EQ
BEQ	L_pvPortMalloc4
;heap_4.c,190 :: 		xWantedSize += ( portBYTE_ALIGNMENT - ( xWantedSize & portBYTE_ALIGNMENT_MASK ) );
AND	R1, R2, #7
RSB	R1, R1, #8
ADDS	R1, R2, R1
MOV	R2, R1
;heap_4.c,191 :: 		configASSERT( ( xWantedSize & portBYTE_ALIGNMENT_MASK ) == 0 );
AND	R1, R1, #7
CMP	R1, #0
MOVW	R1, #0
BNE	L__pvPortMalloc56
MOVS	R1, #1
L__pvPortMalloc56:
CMP	R1, #0
IT	NE
BNE	L_pvPortMalloc5
L_pvPortMalloc5:
;heap_4.c,192 :: 		}
MOV	R3, R2
IT	AL
BAL	L_pvPortMalloc6
L_pvPortMalloc4:
;heap_4.c,196 :: 		}
MOV	R3, R2
L_pvPortMalloc6:
; xWantedSize end address is: 8 (R2)
;heap_4.c,197 :: 		}
; xWantedSize start address is: 12 (R3)
; xWantedSize end address is: 12 (R3)
IT	AL
BAL	L_pvPortMalloc7
L_pvPortMalloc3:
;heap_4.c,201 :: 		}
; xWantedSize start address is: 8 (R2)
MOV	R3, R2
L_pvPortMalloc7:
; xWantedSize end address is: 8 (R2)
;heap_4.c,203 :: 		if( ( xWantedSize > 0 ) && ( xWantedSize <= xFreeBytesRemaining ) )
; xWantedSize start address is: 12 (R3)
CMP	R3, #0
IT	LS
BLS	L__pvPortMalloc50
MOVW	R1, #lo_addr(heap_4_xFreeBytesRemaining+0)
MOVT	R1, #hi_addr(heap_4_xFreeBytesRemaining+0)
LDR	R1, [R1, #0]
CMP	R3, R1
IT	HI
BHI	L__pvPortMalloc49
L__pvPortMalloc46:
;heap_4.c,207 :: 		pxPreviousBlock = &xStart;
; pxPreviousBlock start address is: 8 (R2)
MOVW	R2, #lo_addr(heap_4_xStart+0)
MOVT	R2, #hi_addr(heap_4_xStart+0)
;heap_4.c,208 :: 		pxBlock = xStart.pxNextFreeBlock;
MOVW	R1, #lo_addr(heap_4_xStart+0)
MOVT	R1, #hi_addr(heap_4_xStart+0)
; pxBlock start address is: 20 (R5)
LDR	R5, [R1, #0]
; xWantedSize end address is: 12 (R3)
; pxPreviousBlock end address is: 8 (R2)
; pxBlock end address is: 20 (R5)
; pvReturn end address is: 0 (R0)
;heap_4.c,209 :: 		while( ( pxBlock->xBlockSize < xWantedSize ) && ( pxBlock->pxNextFreeBlock != NULL ) )
L_pvPortMalloc11:
; pxBlock start address is: 20 (R5)
; pxPreviousBlock start address is: 8 (R2)
; xWantedSize start address is: 12 (R3)
; pvReturn start address is: 0 (R0)
ADDS	R1, R5, #4
LDR	R1, [R1, #0]
CMP	R1, R3
IT	CS
BCS	L__pvPortMalloc48
LDR	R1, [R5, #0]
CMP	R1, #0
IT	EQ
BEQ	L__pvPortMalloc47
; pxPreviousBlock end address is: 8 (R2)
L__pvPortMalloc45:
;heap_4.c,211 :: 		pxPreviousBlock = pxBlock;
; pxPreviousBlock start address is: 8 (R2)
MOV	R2, R5
;heap_4.c,212 :: 		pxBlock = pxBlock->pxNextFreeBlock;
LDR	R5, [R5, #0]
;heap_4.c,213 :: 		}
IT	AL
BAL	L_pvPortMalloc11
;heap_4.c,209 :: 		while( ( pxBlock->xBlockSize < xWantedSize ) && ( pxBlock->pxNextFreeBlock != NULL ) )
L__pvPortMalloc48:
L__pvPortMalloc47:
;heap_4.c,217 :: 		if( pxBlock != pxEnd )
MOVW	R1, #lo_addr(heap_4_pxEnd+0)
MOVT	R1, #hi_addr(heap_4_pxEnd+0)
LDR	R1, [R1, #0]
CMP	R5, R1
IT	EQ
BEQ	L_pvPortMalloc15
; pvReturn end address is: 0 (R0)
;heap_4.c,221 :: 		pvReturn = ( void * ) ( ( ( uint8_t * ) pxPreviousBlock->pxNextFreeBlock ) + xHeapStructSize );
LDR	R1, [R2, #0]
ADDS	R1, #8
; pvReturn start address is: 24 (R6)
MOV	R6, R1
;heap_4.c,225 :: 		pxPreviousBlock->pxNextFreeBlock = pxBlock->pxNextFreeBlock;
LDR	R1, [R5, #0]
STR	R1, [R2, #0]
; pxPreviousBlock end address is: 8 (R2)
;heap_4.c,229 :: 		if( ( pxBlock->xBlockSize - xWantedSize ) > heapMINIMUM_BLOCK_SIZE )
ADDS	R1, R5, #4
LDR	R1, [R1, #0]
SUB	R1, R1, R3
CMP	R1, #16
IT	LS
BLS	L_pvPortMalloc16
;heap_4.c,235 :: 		pxNewBlockLink = ( void * ) ( ( ( uint8_t * ) pxBlock ) + xWantedSize );
ADDS	R1, R5, R3
; pxNewBlockLink start address is: 0 (R0)
MOV	R0, R1
;heap_4.c,236 :: 		configASSERT( ( ( ( size_t ) pxNewBlockLink ) & portBYTE_ALIGNMENT_MASK ) == 0 );
AND	R1, R1, #7
CMP	R1, #0
MOVW	R1, #0
BNE	L__pvPortMalloc57
MOVS	R1, #1
L__pvPortMalloc57:
CMP	R1, #0
IT	NE
BNE	L_pvPortMalloc17
L_pvPortMalloc17:
;heap_4.c,240 :: 		pxNewBlockLink->xBlockSize = pxBlock->xBlockSize - xWantedSize;
ADDS	R2, R0, #4
ADDS	R1, R5, #4
LDR	R1, [R1, #0]
SUB	R1, R1, R3
STR	R1, [R2, #0]
;heap_4.c,241 :: 		pxBlock->xBlockSize = xWantedSize;
ADDS	R1, R5, #4
STR	R3, [R1, #0]
; xWantedSize end address is: 12 (R3)
;heap_4.c,244 :: 		prvInsertBlockIntoFreeList( pxNewBlockLink );
; pxNewBlockLink end address is: 0 (R0)
BL	heap_4_prvInsertBlockIntoFreeList+0
;heap_4.c,245 :: 		}
IT	AL
BAL	L_pvPortMalloc18
L_pvPortMalloc16:
;heap_4.c,249 :: 		}
L_pvPortMalloc18:
;heap_4.c,251 :: 		xFreeBytesRemaining -= pxBlock->xBlockSize;
ADDS	R1, R5, #4
LDR	R2, [R1, #0]
MOVW	R3, #lo_addr(heap_4_xFreeBytesRemaining+0)
MOVT	R3, #hi_addr(heap_4_xFreeBytesRemaining+0)
LDR	R1, [R3, #0]
SUB	R2, R1, R2
STR	R2, [R3, #0]
;heap_4.c,253 :: 		if( xFreeBytesRemaining < xMinimumEverFreeBytesRemaining )
MOVW	R1, #lo_addr(heap_4_xMinimumEverFreeBytesRemaining+0)
MOVT	R1, #hi_addr(heap_4_xMinimumEverFreeBytesRemaining+0)
LDR	R1, [R1, #0]
CMP	R2, R1
IT	CS
BCS	L_pvPortMalloc19
;heap_4.c,255 :: 		xMinimumEverFreeBytesRemaining = xFreeBytesRemaining;
MOVW	R1, #lo_addr(heap_4_xFreeBytesRemaining+0)
MOVT	R1, #hi_addr(heap_4_xFreeBytesRemaining+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(heap_4_xMinimumEverFreeBytesRemaining+0)
MOVT	R1, #hi_addr(heap_4_xMinimumEverFreeBytesRemaining+0)
STR	R2, [R1, #0]
;heap_4.c,256 :: 		}
IT	AL
BAL	L_pvPortMalloc20
L_pvPortMalloc19:
;heap_4.c,260 :: 		}
L_pvPortMalloc20:
;heap_4.c,264 :: 		pxBlock->xBlockSize |= xBlockAllocatedBit;
ADDS	R3, R5, #4
LDR	R2, [R3, #0]
MOVW	R1, #lo_addr(heap_4_xBlockAllocatedBit+0)
MOVT	R1, #hi_addr(heap_4_xBlockAllocatedBit+0)
LDR	R1, [R1, #0]
ORR	R1, R2, R1, LSL #0
STR	R1, [R3, #0]
;heap_4.c,265 :: 		pxBlock->pxNextFreeBlock = NULL;
MOVS	R1, #0
STR	R1, [R5, #0]
; pxBlock end address is: 20 (R5)
;heap_4.c,266 :: 		}
MOV	R0, R6
; pvReturn end address is: 24 (R6)
IT	AL
BAL	L_pvPortMalloc21
L_pvPortMalloc15:
;heap_4.c,270 :: 		}
; pvReturn start address is: 0 (R0)
L_pvPortMalloc21:
; pvReturn end address is: 0 (R0)
;heap_4.c,271 :: 		}
; pvReturn start address is: 0 (R0)
IT	AL
BAL	L_pvPortMalloc22
;heap_4.c,203 :: 		if( ( xWantedSize > 0 ) && ( xWantedSize <= xFreeBytesRemaining ) )
L__pvPortMalloc50:
L__pvPortMalloc49:
;heap_4.c,275 :: 		}
L_pvPortMalloc22:
; pvReturn end address is: 0 (R0)
;heap_4.c,276 :: 		}
; pvReturn start address is: 0 (R0)
IT	AL
BAL	L_pvPortMalloc23
L_pvPortMalloc2:
;heap_4.c,280 :: 		}
L_pvPortMalloc23:
; pvReturn end address is: 0 (R0)
;heap_4.c,284 :: 		( void ) xTaskResumeAll();
; pvReturn start address is: 0 (R0)
STR	R0, [SP, #4]
BL	_xTaskResumeAll+0
LDR	R0, [SP, #4]
;heap_4.c,300 :: 		configASSERT( ( ( ( size_t ) pvReturn ) & ( size_t ) portBYTE_ALIGNMENT_MASK ) == 0 );
AND	R1, R0, #7
CMP	R1, #0
MOVW	R1, #0
BNE	L__pvPortMalloc58
MOVS	R1, #1
L__pvPortMalloc58:
CMP	R1, #0
IT	NE
BNE	L_pvPortMalloc24
L_pvPortMalloc24:
;heap_4.c,301 :: 		return pvReturn;
; pvReturn end address is: 0 (R0)
;heap_4.c,302 :: 		}
L_end_pvPortMalloc:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _pvPortMalloc
_vPortFree:
;heap_4.c,305 :: 		void vPortFree( void *pv )
; pv start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
MOV	R1, R0
; pv end address is: 0 (R0)
; pv start address is: 4 (R1)
;heap_4.c,307 :: 		uint8_t *puc = ( uint8_t * ) pv;
; puc start address is: 0 (R0)
MOV	R0, R1
;heap_4.c,310 :: 		if( pv != NULL )
CMP	R1, #0
IT	EQ
BEQ	L_vPortFree25
; pv end address is: 4 (R1)
;heap_4.c,314 :: 		puc -= xHeapStructSize;
SUBW	R1, R0, #8
; puc end address is: 0 (R0)
;heap_4.c,317 :: 		pxLink = ( void * ) puc;
; pxLink start address is: 0 (R0)
MOV	R0, R1
;heap_4.c,320 :: 		configASSERT( ( pxLink->xBlockSize & xBlockAllocatedBit ) != 0 );
ADDS	R1, R1, #4
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(heap_4_xBlockAllocatedBit+0)
MOVT	R1, #hi_addr(heap_4_xBlockAllocatedBit+0)
LDR	R1, [R1, #0]
AND	R1, R2, R1, LSL #0
CMP	R1, #0
MOVW	R1, #0
BEQ	L__vPortFree60
MOVS	R1, #1
L__vPortFree60:
CMP	R1, #0
IT	NE
BNE	L_vPortFree26
L_vPortFree26:
;heap_4.c,321 :: 		configASSERT( pxLink->pxNextFreeBlock == NULL );
LDR	R1, [R0, #0]
CMP	R1, #0
MOVW	R1, #0
BNE	L__vPortFree61
MOVS	R1, #1
L__vPortFree61:
CMP	R1, #0
IT	NE
BNE	L_vPortFree27
L_vPortFree27:
;heap_4.c,323 :: 		if( ( pxLink->xBlockSize & xBlockAllocatedBit ) != 0 )
ADDS	R1, R0, #4
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(heap_4_xBlockAllocatedBit+0)
MOVT	R1, #hi_addr(heap_4_xBlockAllocatedBit+0)
LDR	R1, [R1, #0]
AND	R1, R2, R1, LSL #0
CMP	R1, #0
IT	EQ
BEQ	L_vPortFree28
;heap_4.c,325 :: 		if( pxLink->pxNextFreeBlock == NULL )
LDR	R1, [R0, #0]
CMP	R1, #0
IT	NE
BNE	L_vPortFree29
;heap_4.c,329 :: 		pxLink->xBlockSize &= ~xBlockAllocatedBit;
ADDS	R3, R0, #4
MOVW	R1, #lo_addr(heap_4_xBlockAllocatedBit+0)
MOVT	R1, #hi_addr(heap_4_xBlockAllocatedBit+0)
LDR	R1, [R1, #0]
MVN	R2, R1
LDR	R1, [R3, #0]
ANDS	R1, R2
STR	R1, [R3, #0]
;heap_4.c,331 :: 		vTaskSuspendAll();
STR	R0, [SP, #4]
BL	_vTaskSuspendAll+0
LDR	R0, [SP, #4]
;heap_4.c,334 :: 		xFreeBytesRemaining += pxLink->xBlockSize;
ADDS	R1, R0, #4
LDR	R3, [R1, #0]
MOVW	R2, #lo_addr(heap_4_xFreeBytesRemaining+0)
MOVT	R2, #hi_addr(heap_4_xFreeBytesRemaining+0)
LDR	R1, [R2, #0]
ADDS	R1, R1, R3
STR	R1, [R2, #0]
;heap_4.c,336 :: 		prvInsertBlockIntoFreeList( ( ( BlockLink_t * ) pxLink ) );
; pxLink end address is: 0 (R0)
BL	heap_4_prvInsertBlockIntoFreeList+0
;heap_4.c,338 :: 		( void ) xTaskResumeAll();
BL	_xTaskResumeAll+0
;heap_4.c,339 :: 		}
IT	AL
BAL	L_vPortFree30
L_vPortFree29:
;heap_4.c,343 :: 		}
L_vPortFree30:
;heap_4.c,344 :: 		}
IT	AL
BAL	L_vPortFree31
L_vPortFree28:
;heap_4.c,348 :: 		}
L_vPortFree31:
;heap_4.c,349 :: 		}
L_vPortFree25:
;heap_4.c,350 :: 		}
L_end_vPortFree:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _vPortFree
_xPortGetFreeHeapSize:
;heap_4.c,353 :: 		size_t xPortGetFreeHeapSize( void )
;heap_4.c,355 :: 		return xFreeBytesRemaining;
MOVW	R0, #lo_addr(heap_4_xFreeBytesRemaining+0)
MOVT	R0, #hi_addr(heap_4_xFreeBytesRemaining+0)
LDR	R0, [R0, #0]
;heap_4.c,356 :: 		}
L_end_xPortGetFreeHeapSize:
BX	LR
; end of _xPortGetFreeHeapSize
_xPortGetMinimumEverFreeHeapSize:
;heap_4.c,359 :: 		size_t xPortGetMinimumEverFreeHeapSize( void )
;heap_4.c,361 :: 		return xMinimumEverFreeBytesRemaining;
MOVW	R0, #lo_addr(heap_4_xMinimumEverFreeBytesRemaining+0)
MOVT	R0, #hi_addr(heap_4_xMinimumEverFreeBytesRemaining+0)
LDR	R0, [R0, #0]
;heap_4.c,362 :: 		}
L_end_xPortGetMinimumEverFreeHeapSize:
BX	LR
; end of _xPortGetMinimumEverFreeHeapSize
_vPortInitialiseBlocks:
;heap_4.c,365 :: 		void vPortInitialiseBlocks( void )
;heap_4.c,368 :: 		}
L_end_vPortInitialiseBlocks:
BX	LR
; end of _vPortInitialiseBlocks
heap_4_prvHeapInit:
;heap_4.c,371 :: 		static void prvHeapInit( void )
;heap_4.c,376 :: 		size_t xTotalHeapSize = configTOTAL_HEAP_SIZE;
; xTotalHeapSize start address is: 8 (R2)
MOV	R2, #8192
;heap_4.c,379 :: 		uxAddress = ( size_t ) ucHeap;
MOVW	R0, #lo_addr(heap_4_ucHeap+0)
MOVT	R0, #hi_addr(heap_4_ucHeap+0)
; uxAddress start address is: 16 (R4)
MOV	R4, R0
;heap_4.c,381 :: 		if( ( uxAddress & portBYTE_ALIGNMENT_MASK ) != 0 )
AND	R0, R0, #7
CMP	R0, #0
IT	EQ
BEQ	L_heap_4_prvHeapInit44
;heap_4.c,383 :: 		uxAddress += ( portBYTE_ALIGNMENT - 1 );
ADDS	R1, R4, #7
; uxAddress end address is: 16 (R4)
;heap_4.c,384 :: 		uxAddress &= ~( ( size_t ) portBYTE_ALIGNMENT_MASK );
MVN	R0, #7
ANDS	R1, R0
; uxAddress start address is: 12 (R3)
MOV	R3, R1
;heap_4.c,385 :: 		xTotalHeapSize -= uxAddress - ( size_t ) ucHeap;
MOVW	R0, #lo_addr(heap_4_ucHeap+0)
MOVT	R0, #hi_addr(heap_4_ucHeap+0)
SUB	R0, R1, R0
SUB	R2, R2, R0
; uxAddress end address is: 12 (R3)
; xTotalHeapSize end address is: 8 (R2)
MOV	R4, R3
;heap_4.c,386 :: 		}
IT	AL
BAL	L_heap_4_prvHeapInit32
L_heap_4_prvHeapInit44:
;heap_4.c,381 :: 		if( ( uxAddress & portBYTE_ALIGNMENT_MASK ) != 0 )
;heap_4.c,386 :: 		}
L_heap_4_prvHeapInit32:
;heap_4.c,388 :: 		pucAlignedHeap = ( uint8_t * ) uxAddress;
; xTotalHeapSize start address is: 8 (R2)
; uxAddress start address is: 16 (R4)
; pucAlignedHeap start address is: 12 (R3)
MOV	R3, R4
;heap_4.c,392 :: 		xStart.pxNextFreeBlock = ( void * ) pucAlignedHeap;
MOVW	R0, #lo_addr(heap_4_xStart+0)
MOVT	R0, #hi_addr(heap_4_xStart+0)
STR	R4, [R0, #0]
;heap_4.c,393 :: 		xStart.xBlockSize = ( size_t ) 0;
MOV	R1, #0
MOVW	R0, #lo_addr(heap_4_xStart+4)
MOVT	R0, #hi_addr(heap_4_xStart+4)
STR	R1, [R0, #0]
;heap_4.c,397 :: 		uxAddress = ( ( size_t ) pucAlignedHeap ) + xTotalHeapSize;
ADDS	R0, R4, R2
; xTotalHeapSize end address is: 8 (R2)
; uxAddress end address is: 16 (R4)
;heap_4.c,398 :: 		uxAddress -= xHeapStructSize;
SUBW	R1, R0, #8
;heap_4.c,399 :: 		uxAddress &= ~( ( size_t ) portBYTE_ALIGNMENT_MASK );
MVN	R0, #7
AND	R0, R1, R0, LSL #0
; uxAddress start address is: 16 (R4)
MOV	R4, R0
;heap_4.c,400 :: 		pxEnd = ( void * ) uxAddress;
MOVW	R2, #lo_addr(heap_4_pxEnd+0)
MOVT	R2, #hi_addr(heap_4_pxEnd+0)
STR	R0, [R2, #0]
;heap_4.c,401 :: 		pxEnd->xBlockSize = 0;
ADDS	R1, R0, #4
MOVS	R0, #0
STR	R0, [R1, #0]
;heap_4.c,402 :: 		pxEnd->pxNextFreeBlock = NULL;
MOVS	R1, #0
MOV	R0, R2
LDR	R0, [R0, #0]
STR	R1, [R0, #0]
;heap_4.c,406 :: 		pxFirstFreeBlock = ( void * ) pucAlignedHeap;
; pxFirstFreeBlock start address is: 20 (R5)
MOV	R5, R3
;heap_4.c,407 :: 		pxFirstFreeBlock->xBlockSize = uxAddress - ( size_t ) pxFirstFreeBlock;
ADDS	R1, R3, #4
SUB	R0, R4, R3
; pucAlignedHeap end address is: 12 (R3)
; uxAddress end address is: 16 (R4)
STR	R0, [R1, #0]
;heap_4.c,408 :: 		pxFirstFreeBlock->pxNextFreeBlock = pxEnd;
MOV	R0, R2
LDR	R0, [R0, #0]
STR	R0, [R5, #0]
;heap_4.c,411 :: 		xMinimumEverFreeBytesRemaining = pxFirstFreeBlock->xBlockSize;
ADDS	R2, R5, #4
; pxFirstFreeBlock end address is: 20 (R5)
LDR	R1, [R2, #0]
MOVW	R0, #lo_addr(heap_4_xMinimumEverFreeBytesRemaining+0)
MOVT	R0, #hi_addr(heap_4_xMinimumEverFreeBytesRemaining+0)
STR	R1, [R0, #0]
;heap_4.c,412 :: 		xFreeBytesRemaining = pxFirstFreeBlock->xBlockSize;
LDR	R1, [R2, #0]
MOVW	R0, #lo_addr(heap_4_xFreeBytesRemaining+0)
MOVT	R0, #hi_addr(heap_4_xFreeBytesRemaining+0)
STR	R1, [R0, #0]
;heap_4.c,415 :: 		xBlockAllocatedBit = ( ( size_t ) 1 ) << ( ( sizeof( size_t ) * heapBITS_PER_BYTE ) - 1 );
MOV	R1, #-2147483648
MOVW	R0, #lo_addr(heap_4_xBlockAllocatedBit+0)
MOVT	R0, #hi_addr(heap_4_xBlockAllocatedBit+0)
STR	R1, [R0, #0]
;heap_4.c,416 :: 		}
L_end_prvHeapInit:
BX	LR
; end of heap_4_prvHeapInit
heap_4_prvInsertBlockIntoFreeList:
;heap_4.c,419 :: 		static void prvInsertBlockIntoFreeList( BlockLink_t *pxBlockToInsert )
; pxBlockToInsert start address is: 0 (R0)
MOV	R1, R0
; pxBlockToInsert end address is: 0 (R0)
; pxBlockToInsert start address is: 4 (R1)
;heap_4.c,426 :: 		for( pxIterator = &xStart; pxIterator->pxNextFreeBlock < pxBlockToInsert; pxIterator = pxIterator->pxNextFreeBlock )
; pxIterator start address is: 0 (R0)
MOVW	R0, #lo_addr(heap_4_xStart+0)
MOVT	R0, #hi_addr(heap_4_xStart+0)
; pxBlockToInsert end address is: 4 (R1)
; pxIterator end address is: 0 (R0)
MOV	R2, R1
L_heap_4_prvInsertBlockIntoFreeList33:
; pxIterator start address is: 0 (R0)
; pxBlockToInsert start address is: 8 (R2)
LDR	R1, [R0, #0]
CMP	R1, R2
IT	CS
BCS	L_heap_4_prvInsertBlockIntoFreeList34
LDR	R0, [R0, #0]
;heap_4.c,429 :: 		}
IT	AL
BAL	L_heap_4_prvInsertBlockIntoFreeList33
L_heap_4_prvInsertBlockIntoFreeList34:
;heap_4.c,434 :: 		if( ( puc + pxIterator->xBlockSize ) == ( uint8_t * ) pxBlockToInsert )
ADDS	R1, R0, #4
LDR	R1, [R1, #0]
ADDS	R1, R0, R1
CMP	R1, R2
IT	NE
BNE	L_heap_4_prvInsertBlockIntoFreeList36
;heap_4.c,436 :: 		pxIterator->xBlockSize += pxBlockToInsert->xBlockSize;
ADDS	R3, R0, #4
ADDS	R1, R2, #4
; pxBlockToInsert end address is: 8 (R2)
LDR	R2, [R1, #0]
LDR	R1, [R3, #0]
ADDS	R1, R1, R2
STR	R1, [R3, #0]
;heap_4.c,437 :: 		pxBlockToInsert = pxIterator;
; pxBlockToInsert start address is: 16 (R4)
MOV	R4, R0
;heap_4.c,438 :: 		}
; pxBlockToInsert end address is: 16 (R4)
IT	AL
BAL	L_heap_4_prvInsertBlockIntoFreeList37
L_heap_4_prvInsertBlockIntoFreeList36:
;heap_4.c,442 :: 		}
; pxBlockToInsert start address is: 8 (R2)
MOV	R4, R2
L_heap_4_prvInsertBlockIntoFreeList37:
; pxBlockToInsert end address is: 8 (R2)
;heap_4.c,447 :: 		if( ( puc + pxBlockToInsert->xBlockSize ) == ( uint8_t * ) pxIterator->pxNextFreeBlock )
; pxBlockToInsert start address is: 16 (R4)
ADDS	R1, R4, #4
LDR	R1, [R1, #0]
ADDS	R2, R4, R1
LDR	R1, [R0, #0]
CMP	R2, R1
IT	NE
BNE	L_heap_4_prvInsertBlockIntoFreeList38
;heap_4.c,449 :: 		if( pxIterator->pxNextFreeBlock != pxEnd )
LDR	R2, [R0, #0]
MOVW	R1, #lo_addr(heap_4_pxEnd+0)
MOVT	R1, #hi_addr(heap_4_pxEnd+0)
LDR	R1, [R1, #0]
CMP	R2, R1
IT	EQ
BEQ	L_heap_4_prvInsertBlockIntoFreeList39
;heap_4.c,452 :: 		pxBlockToInsert->xBlockSize += pxIterator->pxNextFreeBlock->xBlockSize;
ADDS	R3, R4, #4
LDR	R1, [R0, #0]
ADDS	R1, R1, #4
LDR	R2, [R1, #0]
LDR	R1, [R3, #0]
ADDS	R1, R1, R2
STR	R1, [R3, #0]
;heap_4.c,453 :: 		pxBlockToInsert->pxNextFreeBlock = pxIterator->pxNextFreeBlock->pxNextFreeBlock;
LDR	R1, [R0, #0]
LDR	R1, [R1, #0]
STR	R1, [R4, #0]
;heap_4.c,454 :: 		}
IT	AL
BAL	L_heap_4_prvInsertBlockIntoFreeList40
L_heap_4_prvInsertBlockIntoFreeList39:
;heap_4.c,457 :: 		pxBlockToInsert->pxNextFreeBlock = pxEnd;
MOVW	R1, #lo_addr(heap_4_pxEnd+0)
MOVT	R1, #hi_addr(heap_4_pxEnd+0)
LDR	R1, [R1, #0]
STR	R1, [R4, #0]
;heap_4.c,458 :: 		}
L_heap_4_prvInsertBlockIntoFreeList40:
;heap_4.c,459 :: 		}
IT	AL
BAL	L_heap_4_prvInsertBlockIntoFreeList41
L_heap_4_prvInsertBlockIntoFreeList38:
;heap_4.c,462 :: 		pxBlockToInsert->pxNextFreeBlock = pxIterator->pxNextFreeBlock;
LDR	R1, [R0, #0]
STR	R1, [R4, #0]
;heap_4.c,463 :: 		}
L_heap_4_prvInsertBlockIntoFreeList41:
;heap_4.c,469 :: 		if( pxIterator != pxBlockToInsert )
CMP	R0, R4
IT	EQ
BEQ	L_heap_4_prvInsertBlockIntoFreeList42
;heap_4.c,471 :: 		pxIterator->pxNextFreeBlock = pxBlockToInsert;
STR	R4, [R0, #0]
; pxIterator end address is: 0 (R0)
; pxBlockToInsert end address is: 16 (R4)
;heap_4.c,472 :: 		}
IT	AL
BAL	L_heap_4_prvInsertBlockIntoFreeList43
L_heap_4_prvInsertBlockIntoFreeList42:
;heap_4.c,476 :: 		}
L_heap_4_prvInsertBlockIntoFreeList43:
;heap_4.c,477 :: 		}
L_end_prvInsertBlockIntoFreeList:
BX	LR
; end of heap_4_prvInsertBlockIntoFreeList
