port_ucPortCountLeadingZeros:
;portmacro.h,183 :: 		static inline uint8_t ucPortCountLeadingZeros(uint32_t ulBitmap)
;portmacro.h,185 :: 		asm CLZ R0, R0;
CLZ	R0, R0
;portmacro.h,186 :: 		return R0;
UXTB	R0, R0
;portmacro.h,187 :: 		}
L_end_ucPortCountLeadingZeros:
BX	LR
; end of port_ucPortCountLeadingZeros
port_vPortRaiseBASEPRI:
;portmacro.h,229 :: 		portFORCE_INLINE static void vPortRaiseBASEPRI( void )
;portmacro.h,234 :: 		CPU_REG_SET(CPU_BASEPRI, ulNewBASEPRI);
MOV	R0, #16
MOV	R12, R0
MSR	#17, R12
;portmacro.h,236 :: 		asm ISB;
ISB	#15
;portmacro.h,237 :: 		asm DSB;
DSB	#15
;portmacro.h,238 :: 		}
L_end_vPortRaiseBASEPRI:
BX	LR
; end of port_vPortRaiseBASEPRI
port_ulPortRaiseBASEPRI:
;portmacro.h,241 :: 		portFORCE_INLINE static uint32_t ulPortRaiseBASEPRI( void )
;portmacro.h,245 :: 		ulOriginalBASEPRI = CPU_REG_GET(CPU_BASEPRI);
MRS	R12, #17
MOV	R0, R12
; ulOriginalBASEPRI start address is: 4 (R1)
MOV	R1, R0
;portmacro.h,247 :: 		CPU_REG_SET(CPU_BASEPRI, ulNewBASEPRI);
MOV	R0, #16
MOV	R12, R0
MSR	#17, R12
;portmacro.h,249 :: 		asm ISB;
ISB	#15
;portmacro.h,250 :: 		asm DSB;
DSB	#15
;portmacro.h,254 :: 		return ulOriginalBASEPRI;
MOV	R0, R1
; ulOriginalBASEPRI end address is: 4 (R1)
;portmacro.h,255 :: 		}
L_end_ulPortRaiseBASEPRI:
BX	LR
; end of port_ulPortRaiseBASEPRI
port_vPortSetBASEPRI:
;portmacro.h,258 :: 		portFORCE_INLINE static void vPortSetBASEPRI( uint32_t ulNewMaskValue )
; ulNewMaskValue start address is: 0 (R0)
; ulNewMaskValue end address is: 0 (R0)
; ulNewMaskValue start address is: 0 (R0)
;portmacro.h,260 :: 		CPU_REG_SET(CPU_BASEPRI, ulNewMaskValue);
MOV	R1, R0
; ulNewMaskValue end address is: 0 (R0)
MOV	R12, R1
MSR	#17, R12
;portmacro.h,261 :: 		}
L_end_vPortSetBASEPRI:
BX	LR
; end of port_vPortSetBASEPRI
_pxPortInitialiseStack:
;port.c,192 :: 		StackType_t *pxTopOfStack, TaskFunction_t pxCode, void *pvParameters)
; pvParameters start address is: 8 (R2)
; pxCode start address is: 4 (R1)
; pxTopOfStack start address is: 0 (R0)
; pvParameters end address is: 8 (R2)
; pxCode end address is: 4 (R1)
; pxTopOfStack end address is: 0 (R0)
; pxTopOfStack start address is: 0 (R0)
; pxCode start address is: 4 (R1)
; pvParameters start address is: 8 (R2)
;port.c,199 :: 		pxTopOfStack--;
SUBS	R3, R0, #4
MOV	R0, R3
;port.c,202 :: 		*pxTopOfStack = (StackType_t)pvParameters;
STR	R2, [R3, #0]
;port.c,203 :: 		pxTopOfStack--;
SUBS	R4, R0, #4
MOV	R0, R4
;port.c,205 :: 		*pxTopOfStack = portINITIAL_XPSR;    // xPSR
MOV	R3, #16777216
STR	R3, [R4, #0]
;port.c,206 :: 		pxTopOfStack--;
SUBS	R3, R0, #4
MOV	R0, R3
;port.c,207 :: 		*pxTopOfStack = (StackType_t)pxCode; // PC
STR	R1, [R3, #0]
; pxCode end address is: 4 (R1)
;port.c,208 :: 		pxTopOfStack--;
SUBS	R4, R0, #4
MOV	R0, R4
;port.c,209 :: 		*pxTopOfStack = (StackType_t)portTASK_RETURN_ADDRESS; // LR
MOVW	R3, #lo_addr(port_prvTaskExitError+0)
MOVT	R3, #hi_addr(port_prvTaskExitError+0)
STR	R3, [R4, #0]
;port.c,212 :: 		pxTopOfStack -= 5; // R12, R3, R2 and R1.
SUBW	R3, R0, #20
MOV	R0, R3
;port.c,213 :: 		*pxTopOfStack = (StackType_t)pvParameters; // R0
STR	R2, [R3, #0]
; pvParameters end address is: 8 (R2)
;port.c,217 :: 		pxTopOfStack--;
SUBS	R4, R0, #4
MOV	R0, R4
;port.c,218 :: 		*pxTopOfStack = portINITIAL_EXEC_RETURN;
MVN	R3, #2
STR	R3, [R4, #0]
;port.c,220 :: 		pxTopOfStack -= 8; // R11, R10, R9, R8, R7, R6, R5 and R4.
SUBW	R3, R0, #32
; pxTopOfStack end address is: 0 (R0)
;port.c,222 :: 		return pxTopOfStack;
MOV	R0, R3
;port.c,223 :: 		}
L_end_pxPortInitialiseStack:
BX	LR
; end of _pxPortInitialiseStack
port_prvTaskExitError:
;port.c,226 :: 		static void prvTaskExitError()
SUB	SP, SP, #4
STR	LR, [SP, #0]
;port.c,234 :: 		configASSERT(uxCriticalNesting == ~0UL);
MOVW	R0, #lo_addr(port_uxCriticalNesting+0)
MOVT	R0, #hi_addr(port_uxCriticalNesting+0)
LDR	R0, [R0, #0]
CMP	R0, #-1
MOVW	R0, #0
BNE	L_port_prvTaskExitError24
MOVS	R0, #1
L_port_prvTaskExitError24:
CMP	R0, #0
IT	NE
BNE	L_port_prvTaskExitError0
L_port_prvTaskExitError0:
;port.c,235 :: 		portDISABLE_INTERRUPTS();
BL	port_vPortRaiseBASEPRI+0
;port.c,236 :: 		while (1);
L_port_prvTaskExitError1:
IT	AL
BAL	L_port_prvTaskExitError1
;port.c,237 :: 		}
L_end_prvTaskExitError:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of port_prvTaskExitError
_vPortSVCHandler:
;port.c,240 :: 		void vPortSVCHandler() iv IVT_INT_SVCall ics ICS_OFF
;port.c,244 :: 		LDR R3, =_pxCurrentTCB
LDR	R3, _pxCurrentTCB+0
;port.c,246 :: 		LDR R1, [R3]
LDR	R1, [R3, #0]
;port.c,248 :: 		LDR R0, [R1]
LDR	R0, [R1, #0]
;port.c,251 :: 		LDM R0!, (R4-R11, R14)
LDM	R0, (R4, R5, R6, R7, R8, R9, R10, R11, R14)
;port.c,253 :: 		MSR CPU_PSP, R0
MSR	#9, R0
;port.c,254 :: 		ISB
ISB	#15
;port.c,255 :: 		MOV R0, #0
MOV	R0, #0
;port.c,256 :: 		MSR CPU_BASEPRI, R0
MSR	#17, R0
;port.c,257 :: 		BX R14
BX	LR
;port.c,258 :: 		}
B	#4
	_pxCurrentTCB+0
NOP
;port.c,259 :: 		}
L_end_vPortSVCHandler:
BX	LR
; end of _vPortSVCHandler
port_prvPortStartFirstTask:
;port.c,262 :: 		static void prvPortStartFirstTask()
;port.c,266 :: 		LDR R0, =0xE000ED08
LDR	R0, [PC, #-536810232]
;port.c,267 :: 		LDR R0, [R0]
LDR	R0, [R0, #0]
;port.c,268 :: 		LDR R0, [R0]
LDR	R0, [R0, #0]
;port.c,270 :: 		MSR CPU_MSP, R0
MSR	#8, R0
;port.c,275 :: 		MOV R0, #0
MOV	R0, #0
;port.c,276 :: 		MSR CPU_CONTROL, R0
MSR	#20, R0
;port.c,278 :: 		CPSIE I
CPSIE	i
;port.c,279 :: 		CPSIE F
CPSIE	f
;port.c,280 :: 		DSB
DSB	#15
;port.c,281 :: 		ISB
ISB	#15
;port.c,283 :: 		SVC #0
SVC	#0
;port.c,284 :: 		NOP
NOP
;port.c,285 :: 		};
B	#4
	#-536810232
NOP
;port.c,286 :: 		}
L_end_prvPortStartFirstTask:
BX	LR
; end of port_prvPortStartFirstTask
_xPortStartScheduler:
;port.c,290 :: 		BaseType_t xPortStartScheduler()
SUB	SP, SP, #4
STR	LR, [SP, #0]
;port.c,294 :: 		configASSERT(configMAX_SYSCALL_INTERRUPT_PRIORITY);
L_xPortStartScheduler3:
;port.c,299 :: 		volatile uint8_t * const pucFirstUserPriorityRegister = &NVIC_IPR0;
; pucFirstUserPriorityRegister start address is: 12 (R3)
MOVW	R3, #lo_addr(NVIC_IPR0+0)
MOVT	R3, #hi_addr(NVIC_IPR0+0)
;port.c,308 :: 		ulOriginalPriority = *pucFirstUserPriorityRegister;
LDRB	R0, [R3, #0]
; ulOriginalPriority start address is: 8 (R2)
UXTB	R2, R0
;port.c,312 :: 		*pucFirstUserPriorityRegister = portMAX_8_BIT_VALUE;
MOVS	R0, #255
STRB	R0, [R3, #0]
;port.c,315 :: 		ucMaxPriorityValue = *pucFirstUserPriorityRegister;
LDRB	R0, [R3, #0]
; ucMaxPriorityValue start address is: 16 (R4)
UXTB	R4, R0
;port.c,318 :: 		configASSERT(ucMaxPriorityValue ==
AND	R0, R4, #255
UXTB	R0, R0
CMP	R4, R0
MOVW	R0, #0
BNE	L__xPortStartScheduler28
MOVS	R0, #1
L__xPortStartScheduler28:
CMP	R0, #0
IT	NE
BNE	L_xPortStartScheduler4
L_xPortStartScheduler4:
;port.c,323 :: 		configMAX_SYSCALL_INTERRUPT_PRIORITY & ucMaxPriorityValue;
AND	R1, R4, #16
MOVW	R0, #lo_addr(port_ucMaxSysCallPriority+0)
MOVT	R0, #hi_addr(port_ucMaxSysCallPriority+0)
STRB	R1, [R0, #0]
;port.c,327 :: 		ulMaxPRIGROUPValue = portMAX_PRIGROUP_BITS;
MOVS	R1, #7
MOVW	R0, #lo_addr(port_ulMaxPRIGROUPValue+0)
MOVT	R0, #hi_addr(port_ulMaxPRIGROUPValue+0)
STR	R1, [R0, #0]
; ulOriginalPriority end address is: 8 (R2)
; pucFirstUserPriorityRegister end address is: 12 (R3)
; ucMaxPriorityValue end address is: 16 (R4)
;port.c,328 :: 		while (
L_xPortStartScheduler5:
;port.c,329 :: 		(ucMaxPriorityValue & portTOP_BIT_OF_BYTE) == portTOP_BIT_OF_BYTE)
; ucMaxPriorityValue start address is: 16 (R4)
; ulOriginalPriority start address is: 8 (R2)
; pucFirstUserPriorityRegister start address is: 12 (R3)
AND	R0, R4, #128
UXTB	R0, R0
CMP	R0, #128
IT	NE
BNE	L_xPortStartScheduler6
;port.c,331 :: 		ulMaxPRIGROUPValue--;
MOVW	R1, #lo_addr(port_ulMaxPRIGROUPValue+0)
MOVT	R1, #hi_addr(port_ulMaxPRIGROUPValue+0)
LDR	R0, [R1, #0]
SUBS	R0, R0, #1
STR	R0, [R1, #0]
;port.c,332 :: 		ucMaxPriorityValue <<= (uint8_t)0x01;
LSLS	R0, R4, #1
UXTB	R4, R0
;port.c,333 :: 		}
; ucMaxPriorityValue end address is: 16 (R4)
IT	AL
BAL	L_xPortStartScheduler5
L_xPortStartScheduler6:
;port.c,357 :: 		ulMaxPRIGROUPValue <<= portPRIGROUP_SHIFT;
MOVW	R1, #lo_addr(port_ulMaxPRIGROUPValue+0)
MOVT	R1, #hi_addr(port_ulMaxPRIGROUPValue+0)
LDR	R0, [R1, #0]
LSLS	R0, R0, #8
STR	R0, [R1, #0]
;port.c,358 :: 		ulMaxPRIGROUPValue &= portPRIORITY_GROUP_MASK;
AND	R0, R0, #1792
STR	R0, [R1, #0]
;port.c,362 :: 		*pucFirstUserPriorityRegister = ulOriginalPriority;
STRB	R2, [R3, #0]
; ulOriginalPriority end address is: 8 (R2)
; pucFirstUserPriorityRegister end address is: 12 (R3)
;port.c,367 :: 		SCB_SHPR3 |= portNVIC_PENDSV_PRI;
MOVW	R0, #lo_addr(SCB_SHPR3+0)
MOVT	R0, #hi_addr(SCB_SHPR3+0)
LDR	R0, [R0, #0]
ORR	R1, R0, #16711680
MOVW	R0, #lo_addr(SCB_SHPR3+0)
MOVT	R0, #hi_addr(SCB_SHPR3+0)
STR	R1, [R0, #0]
;port.c,368 :: 		SCB_SHPR3 |= portNVIC_SYSTICK_PRI;
MOVW	R0, #lo_addr(SCB_SHPR3+0)
MOVT	R0, #hi_addr(SCB_SHPR3+0)
LDR	R0, [R0, #0]
ORR	R1, R0, #-16777216
MOVW	R0, #lo_addr(SCB_SHPR3+0)
MOVT	R0, #hi_addr(SCB_SHPR3+0)
STR	R1, [R0, #0]
;port.c,372 :: 		vPortSetupTimerInterrupt();
BL	_vPortSetupTimerInterrupt+0
;port.c,375 :: 		uxCriticalNesting = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(port_uxCriticalNesting+0)
MOVT	R0, #hi_addr(port_uxCriticalNesting+0)
STR	R1, [R0, #0]
;port.c,378 :: 		vPortEnableVFP();
BL	port_vPortEnableVFP+0
;port.c,381 :: 		*(portFPCCR) |= portASPEN_AND_LSPEN_BITS;
MOVW	R0, -536809676
MOVT	R0, 57344
LDR	R0, [R0, #0]
ORR	R1, R0, #-1073741824
MOVW	R0, -536809676
MOVT	R0, 57344
STR	R1, [R0, #0]
;port.c,384 :: 		prvPortStartFirstTask();
BL	port_prvPortStartFirstTask+0
;port.c,390 :: 		prvTaskExitError();
BL	port_prvTaskExitError+0
;port.c,393 :: 		return 0;
MOVS	R0, #0
;port.c,394 :: 		}
L_end_xPortStartScheduler:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _xPortStartScheduler
_vPortEndScheduler:
;port.c,402 :: 		void vPortEndScheduler()
;port.c,406 :: 		configASSERT(uxCriticalNesting == 1000UL);
MOVW	R0, #lo_addr(port_uxCriticalNesting+0)
MOVT	R0, #hi_addr(port_uxCriticalNesting+0)
LDR	R0, [R0, #0]
CMP	R0, #1000
MOVW	R0, #0
BNE	L__vPortEndScheduler30
MOVS	R0, #1
L__vPortEndScheduler30:
CMP	R0, #0
IT	NE
BNE	L_vPortEndScheduler7
L_vPortEndScheduler7:
;port.c,407 :: 		}
L_end_vPortEndScheduler:
BX	LR
; end of _vPortEndScheduler
_vPortEnterCritical:
;port.c,410 :: 		void vPortEnterCritical()
SUB	SP, SP, #4
STR	LR, [SP, #0]
;port.c,412 :: 		portDISABLE_INTERRUPTS();
BL	port_vPortRaiseBASEPRI+0
;port.c,413 :: 		uxCriticalNesting++;
MOVW	R1, #lo_addr(port_uxCriticalNesting+0)
MOVT	R1, #hi_addr(port_uxCriticalNesting+0)
LDR	R0, [R1, #0]
ADDS	R0, R0, #1
STR	R0, [R1, #0]
;port.c,420 :: 		if (uxCriticalNesting == 1)
CMP	R0, #1
IT	NE
BNE	L_vPortEnterCritical8
;port.c,422 :: 		configASSERT((SCB_ICSR & portVECTACTIVE_MASK) == 0);
MOVW	R0, #lo_addr(SCB_ICSR+0)
MOVT	R0, #hi_addr(SCB_ICSR+0)
LDR	R0, [R0, #0]
AND	R0, R0, #255
CMP	R0, #0
MOVW	R0, #0
BNE	L__vPortEnterCritical32
MOVS	R0, #1
L__vPortEnterCritical32:
CMP	R0, #0
IT	NE
BNE	L_vPortEnterCritical9
L_vPortEnterCritical9:
;port.c,423 :: 		}
L_vPortEnterCritical8:
;port.c,424 :: 		}
L_end_vPortEnterCritical:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _vPortEnterCritical
_vPortExitCritical:
;port.c,427 :: 		void vPortExitCritical()
SUB	SP, SP, #4
STR	LR, [SP, #0]
;port.c,429 :: 		configASSERT(uxCriticalNesting);
MOVW	R0, #lo_addr(port_uxCriticalNesting+0)
MOVT	R0, #hi_addr(port_uxCriticalNesting+0)
LDR	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_vPortExitCritical10
L_vPortExitCritical10:
;port.c,430 :: 		uxCriticalNesting--;
MOVW	R1, #lo_addr(port_uxCriticalNesting+0)
MOVT	R1, #hi_addr(port_uxCriticalNesting+0)
LDR	R0, [R1, #0]
SUBS	R0, R0, #1
STR	R0, [R1, #0]
;port.c,431 :: 		if( uxCriticalNesting == 0 )
CMP	R0, #0
IT	NE
BNE	L_vPortExitCritical11
;port.c,433 :: 		portENABLE_INTERRUPTS();
MOVS	R0, #0
BL	port_vPortSetBASEPRI+0
;port.c,434 :: 		}
L_vPortExitCritical11:
;port.c,435 :: 		}
L_end_vPortExitCritical:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _vPortExitCritical
_xPortPendSVHandler:
;port.c,446 :: 		ics ICS_OFF
SUB	SP, SP, #4
STR	LR, [SP, #0]
;port.c,452 :: 		ADD SP, SP, #4
ADD	SP, SP, #4
;port.c,454 :: 		MRS R0, CPU_PSP
MRS	R0, #9
;port.c,455 :: 		ISB
ISB	#15
;port.c,457 :: 		LDR R3, =_pxCurrentTCB
LDR	R3, _pxCurrentTCB+0
;port.c,458 :: 		LDR R2, [R3]
LDR	R2, [R3, #0]
;port.c,461 :: 		TST R14, #0x10
TST	LR, #16
;port.c,462 :: 		IT  EQ
IT	EQ
;port.c,463 :: 		VSTMDBEQ R0!, (S16-S31)
VSTMDBEQ	#0, R0, (S16, S17, S18, S19, S20, S21, S22, S23, S24, S25, S26, S27, S28, S29, S30, S31)
;port.c,466 :: 		STMDB R0!, (R4-R11, R14)
STMDB	R0, (R4, R5, R6, R7, R8, R9, R10, R11, R14)
;port.c,469 :: 		STR R0, [R2]
STR	R0, [R2, #0]
;port.c,471 :: 		STMDB SP!, (R3)
STMDB	SP, (R3)
;port.c,472 :: 		LDR R0, =_ucMaxSyscallInterruptPriority
LDR	R0, [PC, #16]
;port.c,473 :: 		LDR R1, [R0]
LDR	R1, [R0, #0]
;port.c,474 :: 		MSR CPU_BASEPRI, R1
MSR	#17, R1
;port.c,475 :: 		DSB
DSB	#15
;port.c,476 :: 		ISB
ISB	#15
;port.c,477 :: 		BL _vTaskSwitchContext
BL	_vTaskSwitchContext+0
;port.c,478 :: 		MOV R0, #0
MOV	R0, #0
;port.c,479 :: 		MSR CPU_BASEPRI, R0
MSR	#17, R0
;port.c,480 :: 		LDM SP!, (R3)
LDM	SP, (R3)
;port.c,483 :: 		LDR R1, [R3]
LDR	R1, [R3, #0]
;port.c,484 :: 		LDR R0, [R1]
LDR	R0, [R1, #0]
;port.c,487 :: 		LDM R0!, (R4-R11, R14)
LDM	R0, (R4, R5, R6, R7, R8, R9, R10, R11, R14)
;port.c,491 :: 		TST R14, #0x10
TST	LR, #16
;port.c,492 :: 		IT EQ
IT	EQ
;port.c,493 :: 		VLDMIAEQ R0!, (S16-S31)
VLDMEQ	#0, R0, (S16, S17, S18, S19, S20, S21, S22, S23, S24, S25, S26, S27, S28, S29, S30, S31)
;port.c,495 :: 		MSR CPU_PSP, R0
MSR	#9, R0
;port.c,496 :: 		ISB
ISB	#15
;port.c,497 :: 		BX R14
BX	LR
;port.c,498 :: 		}
B	#8
	_pxCurrentTCB+0
	#16
NOP
;port.c,499 :: 		}
L_end_xPortPendSVHandler:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _xPortPendSVHandler
_xPortSysTickHandler:
;port.c,502 :: 		void xPortSysTickHandler() iv IVT_INT_SysTick ics ICS_AUTO
SUB	SP, SP, #4
STR	LR, [SP, #0]
;port.c,509 :: 		portDISABLE_INTERRUPTS();
BL	port_vPortRaiseBASEPRI+0
;port.c,512 :: 		if( xTaskIncrementTick() != pdFALSE )
BL	_xTaskIncrementTick+0
CMP	R0, #0
IT	EQ
BEQ	L_xPortSysTickHandler12
;port.c,516 :: 		PENDSVSET_bit = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(PENDSVSET_bit+0)
MOVT	R1, #hi_addr(PENDSVSET_bit+0)
_LX	[R1, ByteOffset(PENDSVSET_bit+0)]
BFI	R0, R2, BitPos(PENDSVSET_bit+0), #1
_SX	[R1, ByteOffset(PENDSVSET_bit+0)]
;port.c,517 :: 		}
L_xPortSysTickHandler12:
;port.c,519 :: 		portENABLE_INTERRUPTS();
MOVS	R0, #0
BL	port_vPortSetBASEPRI+0
;port.c,520 :: 		}
L_end_xPortSysTickHandler:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _xPortSysTickHandler
_vPortSetupTimerInterrupt:
;port.c,704 :: 		void vPortSetupTimerInterrupt()
;port.c,719 :: 		STK_CTRL = 0UL;
MOV	R1, #0
MOVW	R0, #lo_addr(STK_CTRL+0)
MOVT	R0, #hi_addr(STK_CTRL+0)
STR	R1, [R0, #0]
;port.c,720 :: 		STK_VAL = 0UL;
MOV	R1, #0
MOVW	R0, #lo_addr(STK_VAL+0)
MOVT	R0, #hi_addr(STK_VAL+0)
STR	R1, [R0, #0]
;port.c,723 :: 		STK_LOAD = (configSYSTICK_CLOCK_HZ / configTICK_RATE_HZ) - 1UL;
MOVW	R1, #54463
MOVT	R1, #1
MOVW	R0, #lo_addr(STK_LOAD+0)
MOVT	R0, #hi_addr(STK_LOAD+0)
STR	R1, [R0, #0]
;port.c,724 :: 		STK_CTRL |= 0x7;
MOVW	R0, #lo_addr(STK_CTRL+0)
MOVT	R0, #hi_addr(STK_CTRL+0)
LDR	R0, [R0, #0]
ORR	R1, R0, #7
MOVW	R0, #lo_addr(STK_CTRL+0)
MOVT	R0, #hi_addr(STK_CTRL+0)
STR	R1, [R0, #0]
;port.c,725 :: 		}
L_end_vPortSetupTimerInterrupt:
BX	LR
; end of _vPortSetupTimerInterrupt
port_vPortEnableVFP:
;port.c,731 :: 		static void vPortEnableVFP()
;port.c,735 :: 		LDR R0, =0xE000ED88
LDR	R0, [PC, #-536810104]
;port.c,736 :: 		LDR R1, [R0]
LDR	R1, [R0, #0]
;port.c,739 :: 		ORR R1, R1, #0xF00000
ORR	R1, R1, #15728640
;port.c,740 :: 		STR R1, [R0]
STR	R1, [R0, #0]
;port.c,741 :: 		BX R14
BX	LR
;port.c,742 :: 		};
B	#4
	#-536810104
NOP
;port.c,743 :: 		}
L_end_vPortEnableVFP:
BX	LR
; end of port_vPortEnableVFP
_xPortIsInsideInterrupt:
;port.c,746 :: 		BaseType_t xPortIsInsideInterrupt()
;port.c,751 :: 		if( CPU_REG_GET( CPU_IPSR ) == 0 )
MRS	R12, #5
MOV	R0, R12
CMP	R0, #0
IT	NE
BNE	L_xPortIsInsideInterrupt13
;port.c,753 :: 		xReturn = pdFALSE;
; xReturn start address is: 0 (R0)
MOV	R0, #0
;port.c,754 :: 		}
; xReturn end address is: 0 (R0)
IT	AL
BAL	L_xPortIsInsideInterrupt14
L_xPortIsInsideInterrupt13:
;port.c,757 :: 		xReturn = pdTRUE;
; xReturn start address is: 0 (R0)
MOV	R0, #1
; xReturn end address is: 0 (R0)
;port.c,758 :: 		}
L_xPortIsInsideInterrupt14:
;port.c,760 :: 		return xReturn;
; xReturn start address is: 0 (R0)
; xReturn end address is: 0 (R0)
;port.c,761 :: 		}
L_end_xPortIsInsideInterrupt:
BX	LR
; end of _xPortIsInsideInterrupt
_vPortValidateInterruptPriority:
;port.c,766 :: 		void vPortValidateInterruptPriority()
;port.c,772 :: 		ulCurrentInterrupt = CPU_REG_GET(CPU_IPSR);
MRS	R12, #5
MOV	R0, R12
; ulCurrentInterrupt start address is: 4 (R1)
MOV	R1, R0
;port.c,775 :: 		if( ulCurrentInterrupt >= portFIRST_USER_INTERRUPT_NUMBER )
CMP	R1, #16
IT	CC
BCC	L_vPortValidateInterruptPriority15
;port.c,779 :: 		- portFIRST_USER_INTERRUPT_NUMBER + ulCurrentInterrupt);
MOVW	R0, #lo_addr(NVIC_IPR0+-16)
MOVT	R0, #hi_addr(NVIC_IPR0+-16)
ADDS	R0, R0, R1
; ulCurrentInterrupt end address is: 4 (R1)
LDRB	R1, [R0, #0]
;port.c,804 :: 		configASSERT(ucCurrentPriority >= ucMaxSysCallPriority);
MOVW	R0, #lo_addr(port_ucMaxSysCallPriority+0)
MOVT	R0, #hi_addr(port_ucMaxSysCallPriority+0)
LDRB	R0, [R0, #0]
CMP	R1, R0
MOVW	R0, #0
BCC	L__vPortValidateInterruptPriority40
MOVS	R0, #1
L__vPortValidateInterruptPriority40:
CMP	R0, #0
IT	NE
BNE	L_vPortValidateInterruptPriority16
L_vPortValidateInterruptPriority16:
;port.c,805 :: 		}
L_vPortValidateInterruptPriority15:
;port.c,820 :: 		configASSERT((SCB_AIRCR & portPRIORITY_GROUP_MASK)
MOVW	R0, #lo_addr(SCB_AIRCR+0)
MOVT	R0, #hi_addr(SCB_AIRCR+0)
LDR	R0, [R0, #0]
AND	R1, R0, #1792
MOVW	R0, #lo_addr(port_ulMaxPRIGROUPValue+0)
MOVT	R0, #hi_addr(port_ulMaxPRIGROUPValue+0)
LDR	R0, [R0, #0]
CMP	R1, R0
MOVW	R0, #0
BHI	L__vPortValidateInterruptPriority41
MOVS	R0, #1
L__vPortValidateInterruptPriority41:
CMP	R0, #0
IT	NE
BNE	L_vPortValidateInterruptPriority17
L_vPortValidateInterruptPriority17:
;port.c,822 :: 		}
L_end_vPortValidateInterruptPriority:
BX	LR
; end of _vPortValidateInterruptPriority
