USB_driver3_ucPortCountLeadingZeros:
;portmacro.h,183 :: 		static inline uint8_t ucPortCountLeadingZeros(uint32_t ulBitmap)
;portmacro.h,185 :: 		asm CLZ R0, R0;
CLZ	R0, R0
;portmacro.h,186 :: 		return R0;
UXTB	R0, R0
;portmacro.h,187 :: 		}
L_end_ucPortCountLeadingZeros:
BX	LR
; end of USB_driver3_ucPortCountLeadingZeros
USB_driver3_vPortRaiseBASEPRI:
;portmacro.h,229 :: 		portFORCE_INLINE static void vPortRaiseBASEPRI( void )
;portmacro.h,234 :: 		CPU_REG_SET(CPU_BASEPRI, ulNewBASEPRI);
MOV	R0, #16
MOV	R12, R0
MSR	#17, R12
;portmacro.h,236 :: 		asm ISB;
ISB	#15
;portmacro.h,237 :: 		asm DSB;
DSB	#15
;portmacro.h,238 :: 		}
L_end_vPortRaiseBASEPRI:
BX	LR
; end of USB_driver3_vPortRaiseBASEPRI
USB_driver3_ulPortRaiseBASEPRI:
;portmacro.h,241 :: 		portFORCE_INLINE static uint32_t ulPortRaiseBASEPRI( void )
;portmacro.h,245 :: 		ulOriginalBASEPRI = CPU_REG_GET(CPU_BASEPRI);
MRS	R12, #17
MOV	R0, R12
; ulOriginalBASEPRI start address is: 4 (R1)
MOV	R1, R0
;portmacro.h,247 :: 		CPU_REG_SET(CPU_BASEPRI, ulNewBASEPRI);
MOV	R0, #16
MOV	R12, R0
MSR	#17, R12
;portmacro.h,249 :: 		asm ISB;
ISB	#15
;portmacro.h,250 :: 		asm DSB;
DSB	#15
;portmacro.h,254 :: 		return ulOriginalBASEPRI;
MOV	R0, R1
; ulOriginalBASEPRI end address is: 4 (R1)
;portmacro.h,255 :: 		}
L_end_ulPortRaiseBASEPRI:
BX	LR
; end of USB_driver3_ulPortRaiseBASEPRI
USB_driver3_vPortSetBASEPRI:
;portmacro.h,258 :: 		portFORCE_INLINE static void vPortSetBASEPRI( uint32_t ulNewMaskValue )
; ulNewMaskValue start address is: 0 (R0)
; ulNewMaskValue end address is: 0 (R0)
; ulNewMaskValue start address is: 0 (R0)
;portmacro.h,260 :: 		CPU_REG_SET(CPU_BASEPRI, ulNewMaskValue);
MOV	R1, R0
; ulNewMaskValue end address is: 0 (R0)
MOV	R12, R1
MSR	#17, R12
;portmacro.h,261 :: 		}
L_end_vPortSetBASEPRI:
BX	LR
; end of USB_driver3_vPortSetBASEPRI
_USBInterrupt:
;USB_driver3.c,83 :: 		void USBInterrupt() iv IVT_INT_OTG_FS ics ICS_AUTO {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;USB_driver3.c,85 :: 		USB_Interrupt_Proc();    // USB interrupt fires all the time. Can't set semaphore here.
BL	_USB_Interrupt_Proc+0
;USB_driver3.c,86 :: 		}
L_end_USBInterrupt:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _USBInterrupt
_USB_Initialize:
;USB_driver3.c,91 :: 		void USB_Initialize(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;USB_driver3.c,93 :: 		HID_Enable(&USB_RdBuff,&USB_WrBuff);
MOVW	R1, #lo_addr(_USB_WrBuff+0)
MOVT	R1, #hi_addr(_USB_WrBuff+0)
MOVW	R0, #lo_addr(_USB_RdBuff+0)
MOVT	R0, #hi_addr(_USB_RdBuff+0)
BL	_HID_Enable+0
;USB_driver3.c,94 :: 		USB_Initialized = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(_USB_Initialized+0)
MOVT	R0, #hi_addr(_USB_Initialized+0)
STRB	R1, [R0, #0]
;USB_driver3.c,95 :: 		}
L_end_USB_Initialize:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _USB_Initialize
_USB_CheckIn:
;USB_driver3.c,102 :: 		void USB_CheckIn(void) {
SUB	SP, SP, #12
STR	LR, [SP, #0]
;USB_driver3.c,110 :: 		if (HID_Read() != 0) {
BL	_HID_Read+0
CMP	R0, #0
IT	EQ
BEQ	L_USB_CheckIn0
;USB_driver3.c,111 :: 		switch (USB_RdBuff[0]) {      // The first character in read buffer is a command
IT	AL
BAL	L_USB_CheckIn1
;USB_driver3.c,112 :: 		case 'a': // Diagnostic test of USB
L_USB_CheckIn3:
;USB_driver3.c,113 :: 		USB_PutQueue("Command 'a' received\r\n");
MOVW	R0, #lo_addr(?lstr1_USB_driver3+0)
MOVT	R0, #hi_addr(?lstr1_USB_driver3+0)
BL	_USB_PutQueue+0
;USB_driver3.c,114 :: 		break;
IT	AL
BAL	L_USB_CheckIn2
;USB_driver3.c,115 :: 		case 'b': // Set date/time from data in message
L_USB_CheckIn4:
;USB_driver3.c,119 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 8 (R2)
MOV	R2, R0
;USB_driver3.c,120 :: 		BufNum[0]  = USB_RdBuff[0];   // Command
MOVW	R1, #lo_addr(_USB_RdBuff+0)
MOVT	R1, #hi_addr(_USB_RdBuff+0)
LDRB	R1, [R1, #0]
STRB	R1, [R0, #0]
;USB_driver3.c,121 :: 		BufNum[1]  = USB_RdBuff[1];   // Comma
ADDS	R1, R2, #1
MOVW	R0, #lo_addr(_USB_RdBuff+1)
MOVT	R0, #hi_addr(_USB_RdBuff+1)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_driver3.c,122 :: 		BufNum[2]  = USB_RdBuff[2];   // Year
ADDS	R1, R2, #2
MOVW	R0, #lo_addr(_USB_RdBuff+2)
MOVT	R0, #hi_addr(_USB_RdBuff+2)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_driver3.c,123 :: 		BufNum[3]  = USB_RdBuff[3];   // Year
ADDS	R1, R2, #3
MOVW	R0, #lo_addr(_USB_RdBuff+3)
MOVT	R0, #hi_addr(_USB_RdBuff+3)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_driver3.c,124 :: 		BufNum[4]  = USB_RdBuff[4];   // Comma
ADDS	R1, R2, #4
MOVW	R0, #lo_addr(_USB_RdBuff+4)
MOVT	R0, #hi_addr(_USB_RdBuff+4)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_driver3.c,125 :: 		BufNum[5]  = USB_RdBuff[5];   // Month
ADDS	R1, R2, #5
MOVW	R0, #lo_addr(_USB_RdBuff+5)
MOVT	R0, #hi_addr(_USB_RdBuff+5)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_driver3.c,126 :: 		BufNum[6]  = USB_RdBuff[6];   // Month
ADDS	R1, R2, #6
MOVW	R0, #lo_addr(_USB_RdBuff+6)
MOVT	R0, #hi_addr(_USB_RdBuff+6)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_driver3.c,127 :: 		BufNum[7]  = USB_RdBuff[7];   // Comma
ADDS	R1, R2, #7
MOVW	R0, #lo_addr(_USB_RdBuff+7)
MOVT	R0, #hi_addr(_USB_RdBuff+7)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_driver3.c,128 :: 		BufNum[8]  = USB_RdBuff[8];   // Day
ADDW	R1, R2, #8
MOVW	R0, #lo_addr(_USB_RdBuff+8)
MOVT	R0, #hi_addr(_USB_RdBuff+8)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_driver3.c,129 :: 		BufNum[9]  = USB_RdBuff[9];   // Day
ADDW	R1, R2, #9
MOVW	R0, #lo_addr(_USB_RdBuff+9)
MOVT	R0, #hi_addr(_USB_RdBuff+9)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_driver3.c,130 :: 		BufNum[10] = USB_RdBuff[10];  // Comma
ADDW	R1, R2, #10
MOVW	R0, #lo_addr(_USB_RdBuff+10)
MOVT	R0, #hi_addr(_USB_RdBuff+10)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_driver3.c,131 :: 		BufNum[11] = USB_RdBuff[11];  // DoW
ADDW	R1, R2, #11
MOVW	R0, #lo_addr(_USB_RdBuff+11)
MOVT	R0, #hi_addr(_USB_RdBuff+11)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_driver3.c,132 :: 		BufNum[12] = USB_RdBuff[12];  // DoW
ADDW	R1, R2, #12
MOVW	R0, #lo_addr(_USB_RdBuff+12)
MOVT	R0, #hi_addr(_USB_RdBuff+12)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_driver3.c,133 :: 		BufNum[13] = USB_RdBuff[13];  // Comma
ADDW	R1, R2, #13
MOVW	R0, #lo_addr(_USB_RdBuff+13)
MOVT	R0, #hi_addr(_USB_RdBuff+13)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_driver3.c,134 :: 		BufNum[14] = USB_RdBuff[14];  // Hour
ADDW	R1, R2, #14
MOVW	R0, #lo_addr(_USB_RdBuff+14)
MOVT	R0, #hi_addr(_USB_RdBuff+14)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_driver3.c,135 :: 		BufNum[15] = USB_RdBuff[15];  // Hour
ADDW	R1, R2, #15
MOVW	R0, #lo_addr(_USB_RdBuff+15)
MOVT	R0, #hi_addr(_USB_RdBuff+15)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_driver3.c,136 :: 		BufNum[16] = USB_RdBuff[16];  // Comma
ADDW	R1, R2, #16
MOVW	R0, #lo_addr(_USB_RdBuff+16)
MOVT	R0, #hi_addr(_USB_RdBuff+16)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_driver3.c,137 :: 		BufNum[17] = USB_RdBuff[17];  // Minute
ADDW	R1, R2, #17
MOVW	R0, #lo_addr(_USB_RdBuff+17)
MOVT	R0, #hi_addr(_USB_RdBuff+17)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_driver3.c,138 :: 		BufNum[18] = USB_RdBuff[18];  // Minute
ADDW	R1, R2, #18
MOVW	R0, #lo_addr(_USB_RdBuff+18)
MOVT	R0, #hi_addr(_USB_RdBuff+18)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_driver3.c,139 :: 		BufNum[19] = USB_RdBuff[19];  // Comma
ADDW	R1, R2, #19
MOVW	R0, #lo_addr(_USB_RdBuff+19)
MOVT	R0, #hi_addr(_USB_RdBuff+19)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_driver3.c,140 :: 		BufNum[20] = USB_RdBuff[20];  // Second
ADDW	R1, R2, #20
MOVW	R0, #lo_addr(_USB_RdBuff+20)
MOVT	R0, #hi_addr(_USB_RdBuff+20)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_driver3.c,141 :: 		BufNum[21] = USB_RdBuff[21];  // Second
ADDW	R1, R2, #21
MOVW	R0, #lo_addr(_USB_RdBuff+21)
MOVT	R0, #hi_addr(_USB_RdBuff+21)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_driver3.c,142 :: 		BufNum[22] = '\r';            // Return
ADDW	R1, R2, #22
MOVS	R0, #13
STRB	R0, [R1, #0]
;USB_driver3.c,143 :: 		BufNum[23] = '\n';            // New line
ADDW	R1, R2, #23
MOVS	R0, #10
STRB	R0, [R1, #0]
;USB_driver3.c,144 :: 		BufNum[24] = 0;               // Nul
ADDW	R1, R2, #24
MOVS	R0, #0
STRB	R0, [R1, #0]
;USB_driver3.c,145 :: 		USB_PutQueue(BufNum);         // Send back date-time for verification
MOV	R0, R2
; BufNum end address is: 8 (R2)
BL	_USB_PutQueue+0
;USB_driver3.c,149 :: 		DateTimeSet.ampm = 0;
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(_DateTimeSet+0)
MOVT	R0, #hi_addr(_DateTimeSet+0)
STRB	R1, [R0, #0]
;USB_driver3.c,150 :: 		Str[3] = 0;
ADD	R2, SP, #8
ADDS	R1, R2, #3
MOVS	R0, #0
STRB	R0, [R1, #0]
;USB_driver3.c,151 :: 		Str[0] = USB_RdBuff[20];
MOVW	R0, #lo_addr(_USB_RdBuff+20)
MOVT	R0, #hi_addr(_USB_RdBuff+20)
LDRB	R0, [R0, #0]
STRB	R0, [R2, #0]
;USB_driver3.c,152 :: 		Str[1] = USB_RdBuff[21];
ADDS	R1, R2, #1
MOVW	R0, #lo_addr(_USB_RdBuff+21)
MOVT	R0, #hi_addr(_USB_RdBuff+21)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_driver3.c,153 :: 		DateTimeSet.seconds = atoi(Str);
MOV	R0, R2
BL	_atoi+0
MOVW	R1, #lo_addr(_DateTimeSet+1)
MOVT	R1, #hi_addr(_DateTimeSet+1)
STRB	R0, [R1, #0]
;USB_driver3.c,154 :: 		Str[0] = USB_RdBuff[17];
ADD	R2, SP, #8
MOVW	R0, #lo_addr(_USB_RdBuff+17)
MOVT	R0, #hi_addr(_USB_RdBuff+17)
LDRB	R0, [R0, #0]
STRB	R0, [R2, #0]
;USB_driver3.c,155 :: 		Str[1] = USB_RdBuff[18];
ADDS	R1, R2, #1
MOVW	R0, #lo_addr(_USB_RdBuff+18)
MOVT	R0, #hi_addr(_USB_RdBuff+18)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_driver3.c,156 :: 		DateTimeSet.minutes = atoi(Str);
MOV	R0, R2
BL	_atoi+0
MOVW	R1, #lo_addr(_DateTimeSet+2)
MOVT	R1, #hi_addr(_DateTimeSet+2)
STRB	R0, [R1, #0]
;USB_driver3.c,157 :: 		Str[0] = USB_RdBuff[14];
ADD	R2, SP, #8
MOVW	R0, #lo_addr(_USB_RdBuff+14)
MOVT	R0, #hi_addr(_USB_RdBuff+14)
LDRB	R0, [R0, #0]
STRB	R0, [R2, #0]
;USB_driver3.c,158 :: 		Str[1] = USB_RdBuff[15];
ADDS	R1, R2, #1
MOVW	R0, #lo_addr(_USB_RdBuff+15)
MOVT	R0, #hi_addr(_USB_RdBuff+15)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_driver3.c,159 :: 		DateTimeSet.hours   = atoi(Str);
MOV	R0, R2
BL	_atoi+0
MOVW	R1, #lo_addr(_DateTimeSet+3)
MOVT	R1, #hi_addr(_DateTimeSet+3)
STRB	R0, [R1, #0]
;USB_driver3.c,160 :: 		Str[0] = USB_RdBuff[8];
ADD	R2, SP, #8
MOVW	R0, #lo_addr(_USB_RdBuff+8)
MOVT	R0, #hi_addr(_USB_RdBuff+8)
LDRB	R0, [R0, #0]
STRB	R0, [R2, #0]
;USB_driver3.c,161 :: 		Str[1] = USB_RdBuff[9];
ADDS	R1, R2, #1
MOVW	R0, #lo_addr(_USB_RdBuff+9)
MOVT	R0, #hi_addr(_USB_RdBuff+9)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_driver3.c,162 :: 		DateTimeSet.day     = atoi(Str);
MOV	R0, R2
BL	_atoi+0
MOVW	R1, #lo_addr(_DateTimeSet+4)
MOVT	R1, #hi_addr(_DateTimeSet+4)
STRB	R0, [R1, #0]
;USB_driver3.c,163 :: 		Str[0] = USB_RdBuff[5];
ADD	R2, SP, #8
MOVW	R0, #lo_addr(_USB_RdBuff+5)
MOVT	R0, #hi_addr(_USB_RdBuff+5)
LDRB	R0, [R0, #0]
STRB	R0, [R2, #0]
;USB_driver3.c,164 :: 		Str[1] = USB_RdBuff[6];
ADDS	R1, R2, #1
MOVW	R0, #lo_addr(_USB_RdBuff+6)
MOVT	R0, #hi_addr(_USB_RdBuff+6)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_driver3.c,165 :: 		DateTimeSet.month   = atoi(Str);
MOV	R0, R2
BL	_atoi+0
MOVW	R1, #lo_addr(_DateTimeSet+5)
MOVT	R1, #hi_addr(_DateTimeSet+5)
STRB	R0, [R1, #0]
;USB_driver3.c,166 :: 		Str[0] = USB_RdBuff[2];
ADD	R2, SP, #8
MOVW	R0, #lo_addr(_USB_RdBuff+2)
MOVT	R0, #hi_addr(_USB_RdBuff+2)
LDRB	R0, [R0, #0]
STRB	R0, [R2, #0]
;USB_driver3.c,167 :: 		Str[1] = USB_RdBuff[3];
ADDS	R1, R2, #1
MOVW	R0, #lo_addr(_USB_RdBuff+3)
MOVT	R0, #hi_addr(_USB_RdBuff+3)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;USB_driver3.c,168 :: 		DateTimeSet.year    = atoi(Str);
MOV	R0, R2
BL	_atoi+0
MOVW	R1, #lo_addr(_DateTimeSet+6)
MOVT	R1, #hi_addr(_DateTimeSet+6)
STRH	R0, [R1, #0]
;USB_driver3.c,169 :: 		RTC_Write(&DateTimeSet);
MOVW	R0, #lo_addr(_DateTimeSet+0)
MOVT	R0, #hi_addr(_DateTimeSet+0)
BL	_RTC_Write+0
;USB_driver3.c,171 :: 		UART2_PutQueue("Time and date set in RTC\r\n");
MOVW	R0, #lo_addr(?lstr2_USB_driver3+0)
MOVT	R0, #hi_addr(?lstr2_USB_driver3+0)
BL	_UART2_PutQueue+0
;USB_driver3.c,173 :: 		break;
IT	AL
BAL	L_USB_CheckIn2
;USB_driver3.c,174 :: 		case 'c': // Show RTC Date/Time
L_USB_CheckIn5:
;USB_driver3.c,175 :: 		GetTime();
BL	_GetTime+0
;USB_driver3.c,176 :: 		break;
IT	AL
BAL	L_USB_CheckIn2
;USB_driver3.c,177 :: 		case 'd':
L_USB_CheckIn6:
;USB_driver3.c,179 :: 		break;
IT	AL
BAL	L_USB_CheckIn2
;USB_driver3.c,180 :: 		case 'e':
L_USB_CheckIn7:
;USB_driver3.c,182 :: 		break;
IT	AL
BAL	L_USB_CheckIn2
;USB_driver3.c,183 :: 		case 'f':
L_USB_CheckIn8:
;USB_driver3.c,185 :: 		break;
IT	AL
BAL	L_USB_CheckIn2
;USB_driver3.c,186 :: 		case 'g': // Give semaphore
L_USB_CheckIn9:
;USB_driver3.c,187 :: 		if (xSemaphoreGive(usbSemHandle) == pdPASS)
MOVW	R0, #lo_addr(_usbSemHandle+0)
MOVT	R0, #hi_addr(_usbSemHandle+0)
LDR	R0, [R0, #0]
MOV	R3, #0
MOV	R2, #0
MOVS	R1, #0
BL	_xQueueGenericSend+0
CMP	R0, #1
IT	NE
BNE	L_USB_CheckIn10
;USB_driver3.c,188 :: 		USB_PutQueue("Semaphore given\r\n");
MOVW	R0, #lo_addr(?lstr3_USB_driver3+0)
MOVT	R0, #hi_addr(?lstr3_USB_driver3+0)
BL	_USB_PutQueue+0
IT	AL
BAL	L_USB_CheckIn11
L_USB_CheckIn10:
;USB_driver3.c,190 :: 		USB_PutQueue("Semaphore queue full\r\n");
MOVW	R0, #lo_addr(?lstr4_USB_driver3+0)
MOVT	R0, #hi_addr(?lstr4_USB_driver3+0)
BL	_USB_PutQueue+0
L_USB_CheckIn11:
;USB_driver3.c,191 :: 		break;
IT	AL
BAL	L_USB_CheckIn2
;USB_driver3.c,192 :: 		case 'h': // Take semaphore
L_USB_CheckIn12:
;USB_driver3.c,193 :: 		if (xSemaphoreTake(usbSemHandle,0) == pdPASS)
MOVW	R0, #lo_addr(_usbSemHandle+0)
MOVT	R0, #hi_addr(_usbSemHandle+0)
LDR	R0, [R0, #0]
MOV	R3, #0
MOVS	R2, #0
MOVS	R1, #0
BL	_xQueueGenericReceive+0
CMP	R0, #1
IT	NE
BNE	L_USB_CheckIn13
;USB_driver3.c,194 :: 		USB_PutQueue("Had a semaphore\r\n");
MOVW	R0, #lo_addr(?lstr5_USB_driver3+0)
MOVT	R0, #hi_addr(?lstr5_USB_driver3+0)
BL	_USB_PutQueue+0
IT	AL
BAL	L_USB_CheckIn14
L_USB_CheckIn13:
;USB_driver3.c,196 :: 		USB_PutQueue("Semaphore queue empty\r\n");
MOVW	R0, #lo_addr(?lstr6_USB_driver3+0)
MOVT	R0, #hi_addr(?lstr6_USB_driver3+0)
BL	_USB_PutQueue+0
L_USB_CheckIn14:
;USB_driver3.c,197 :: 		break;
IT	AL
BAL	L_USB_CheckIn2
;USB_driver3.c,198 :: 		case 'i':
L_USB_CheckIn15:
;USB_driver3.c,199 :: 		break;
IT	AL
BAL	L_USB_CheckIn2
;USB_driver3.c,200 :: 		case 'j': // Start auto-reload timer with this command
L_USB_CheckIn16:
;USB_driver3.c,201 :: 		StartAutoReloadTimer();
BL	_StartAutoReloadTimer+0
;USB_driver3.c,202 :: 		break;
IT	AL
BAL	L_USB_CheckIn2
;USB_driver3.c,203 :: 		case 'k': // Test to turn PD8 LED on
L_USB_CheckIn17:
;USB_driver3.c,204 :: 		IndOn();
BL	_IndOn+0
;USB_driver3.c,205 :: 		break;
IT	AL
BAL	L_USB_CheckIn2
;USB_driver3.c,206 :: 		case 'l': // Test to turn PD8 LED off
L_USB_CheckIn18:
;USB_driver3.c,207 :: 		IndOff();
BL	_IndOff+0
;USB_driver3.c,208 :: 		break;
IT	AL
BAL	L_USB_CheckIn2
;USB_driver3.c,209 :: 		case 'm': // Test to toggle PD8 LED
L_USB_CheckIn19:
;USB_driver3.c,210 :: 		IndTog();
BL	_IndTog+0
;USB_driver3.c,211 :: 		break;
IT	AL
BAL	L_USB_CheckIn2
;USB_driver3.c,212 :: 		case 'n': // Change auto-reload timer period to 100ms. Also starts the timer.
L_USB_CheckIn20:
;USB_driver3.c,213 :: 		ChangeReloadTimerPeriod(100);
MOVS	R0, #100
BL	_ChangeReloadTimerPeriod+0
;USB_driver3.c,214 :: 		break;
IT	AL
BAL	L_USB_CheckIn2
;USB_driver3.c,215 :: 		case 'o': // Stop auto-reload timer
L_USB_CheckIn21:
;USB_driver3.c,216 :: 		StopAutoReloadTimer();
BL	_StopAutoReloadTimer+0
;USB_driver3.c,217 :: 		break;
IT	AL
BAL	L_USB_CheckIn2
;USB_driver3.c,218 :: 		case 'p': // Display the number of free bytes in the heap
L_USB_CheckIn22:
;USB_driver3.c,219 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;USB_driver3.c,220 :: 		sprintf(BufNum,"%Ld\r\n",xPortGetFreeHeapSize());
STR	R3, [SP, #4]
BL	_xPortGetFreeHeapSize+0
LDR	R3, [SP, #4]
MOVW	R2, #lo_addr(?lstr_7_USB_driver3+0)
MOVT	R2, #hi_addr(?lstr_7_USB_driver3+0)
MOV	R1, R3
STR	R3, [SP, #4]
PUSH	(R0)
PUSH	(R2)
PUSH	(R1)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;USB_driver3.c,221 :: 		USB_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_USB_PutQueue+0
;USB_driver3.c,222 :: 		break;
IT	AL
BAL	L_USB_CheckIn2
;USB_driver3.c,223 :: 		case 'q': // Display the minimum number of bytes on the heap since starting
L_USB_CheckIn23:
;USB_driver3.c,224 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;USB_driver3.c,225 :: 		sprintf(BufNum,"%Ld\r\n",xPortGetMinimumEverFreeHeapSize());
STR	R3, [SP, #4]
BL	_xPortGetMinimumEverFreeHeapSize+0
LDR	R3, [SP, #4]
MOVW	R2, #lo_addr(?lstr_8_USB_driver3+0)
MOVT	R2, #hi_addr(?lstr_8_USB_driver3+0)
MOV	R1, R3
STR	R3, [SP, #4]
PUSH	(R0)
PUSH	(R2)
PUSH	(R1)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;USB_driver3.c,226 :: 		USB_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_USB_PutQueue+0
;USB_driver3.c,227 :: 		break;
IT	AL
BAL	L_USB_CheckIn2
;USB_driver3.c,228 :: 		case 'r': //
L_USB_CheckIn24:
;USB_driver3.c,229 :: 		break;
IT	AL
BAL	L_USB_CheckIn2
;USB_driver3.c,230 :: 		case 's':
L_USB_CheckIn25:
;USB_driver3.c,231 :: 		UART2_PutQueue("Hello\r\n");
MOVW	R0, #lo_addr(?lstr9_USB_driver3+0)
MOVT	R0, #hi_addr(?lstr9_USB_driver3+0)
BL	_UART2_PutQueue+0
;USB_driver3.c,232 :: 		break;
IT	AL
BAL	L_USB_CheckIn2
;USB_driver3.c,233 :: 		case 't': // This command starts the one-shot timer
L_USB_CheckIn26:
;USB_driver3.c,234 :: 		StartOneShotTimer();
BL	_StartOneShotTimer+0
;USB_driver3.c,235 :: 		break;
IT	AL
BAL	L_USB_CheckIn2
;USB_driver3.c,236 :: 		case 'u': // Change timer period to 1000ms. Also starts the timer.
L_USB_CheckIn27:
;USB_driver3.c,237 :: 		ChangeTimerPeriod(1000);
MOVW	R0, #1000
BL	_ChangeTimerPeriod+0
;USB_driver3.c,238 :: 		break;
IT	AL
BAL	L_USB_CheckIn2
;USB_driver3.c,239 :: 		case 'v': // Change timer period to 100ms. Also starts the timer.
L_USB_CheckIn28:
;USB_driver3.c,240 :: 		ChangeTimerPeriod(100);
MOVS	R0, #100
BL	_ChangeTimerPeriod+0
;USB_driver3.c,241 :: 		break;
IT	AL
BAL	L_USB_CheckIn2
;USB_driver3.c,242 :: 		case 'w': // Test for hardware timer
L_USB_CheckIn29:
;USB_driver3.c,243 :: 		Timer8_Ch2_Start(); // Flash PC7 LED
BL	_Timer8_Ch2_Start+0
;USB_driver3.c,244 :: 		break;
IT	AL
BAL	L_USB_CheckIn2
;USB_driver3.c,245 :: 		case 'x': // Send many messages to USB
L_USB_CheckIn30:
;USB_driver3.c,246 :: 		DisplayTIM8Regs();
BL	_DisplayTIM8Regs+0
;USB_driver3.c,247 :: 		break;
IT	AL
BAL	L_USB_CheckIn2
;USB_driver3.c,248 :: 		case 'y':
L_USB_CheckIn31:
;USB_driver3.c,249 :: 		break;
IT	AL
BAL	L_USB_CheckIn2
;USB_driver3.c,251 :: 		case 'z': // Force a system reset
L_USB_CheckIn32:
;USB_driver3.c,252 :: 		SystemReset();
BL	_SystemReset+0
;USB_driver3.c,253 :: 		break;
IT	AL
BAL	L_USB_CheckIn2
;USB_driver3.c,257 :: 		default:  // Catch all other unimplemented commands
L_USB_CheckIn33:
;USB_driver3.c,258 :: 		BufNum = GetBuffer();  // Get a free buffer
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;USB_driver3.c,259 :: 		(void)sprintf(BufNum,"Unknown command: %c\r\n",USB_RdBuff[0]);
MOVW	R1, #lo_addr(_USB_RdBuff+0)
MOVT	R1, #hi_addr(_USB_RdBuff+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_10_USB_driver3+0)
MOVT	R1, #hi_addr(?lstr_10_USB_driver3+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;USB_driver3.c,260 :: 		USB_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_USB_PutQueue+0
;USB_driver3.c,261 :: 		break;
IT	AL
BAL	L_USB_CheckIn2
;USB_driver3.c,262 :: 		}
L_USB_CheckIn1:
MOVW	R0, #lo_addr(_USB_RdBuff+0)
MOVT	R0, #hi_addr(_USB_RdBuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #97
IT	EQ
BEQ	L_USB_CheckIn3
MOVW	R0, #lo_addr(_USB_RdBuff+0)
MOVT	R0, #hi_addr(_USB_RdBuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #98
IT	EQ
BEQ	L_USB_CheckIn4
MOVW	R0, #lo_addr(_USB_RdBuff+0)
MOVT	R0, #hi_addr(_USB_RdBuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #99
IT	EQ
BEQ	L_USB_CheckIn5
MOVW	R0, #lo_addr(_USB_RdBuff+0)
MOVT	R0, #hi_addr(_USB_RdBuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #100
IT	EQ
BEQ	L_USB_CheckIn6
MOVW	R0, #lo_addr(_USB_RdBuff+0)
MOVT	R0, #hi_addr(_USB_RdBuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #101
IT	EQ
BEQ	L_USB_CheckIn7
MOVW	R0, #lo_addr(_USB_RdBuff+0)
MOVT	R0, #hi_addr(_USB_RdBuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #102
IT	EQ
BEQ	L_USB_CheckIn8
MOVW	R0, #lo_addr(_USB_RdBuff+0)
MOVT	R0, #hi_addr(_USB_RdBuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #103
IT	EQ
BEQ	L_USB_CheckIn9
MOVW	R0, #lo_addr(_USB_RdBuff+0)
MOVT	R0, #hi_addr(_USB_RdBuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #104
IT	EQ
BEQ	L_USB_CheckIn12
MOVW	R0, #lo_addr(_USB_RdBuff+0)
MOVT	R0, #hi_addr(_USB_RdBuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #105
IT	EQ
BEQ	L_USB_CheckIn15
MOVW	R0, #lo_addr(_USB_RdBuff+0)
MOVT	R0, #hi_addr(_USB_RdBuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #106
IT	EQ
BEQ	L_USB_CheckIn16
MOVW	R0, #lo_addr(_USB_RdBuff+0)
MOVT	R0, #hi_addr(_USB_RdBuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #107
IT	EQ
BEQ	L_USB_CheckIn17
MOVW	R0, #lo_addr(_USB_RdBuff+0)
MOVT	R0, #hi_addr(_USB_RdBuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #108
IT	EQ
BEQ	L_USB_CheckIn18
MOVW	R0, #lo_addr(_USB_RdBuff+0)
MOVT	R0, #hi_addr(_USB_RdBuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #109
IT	EQ
BEQ	L_USB_CheckIn19
MOVW	R0, #lo_addr(_USB_RdBuff+0)
MOVT	R0, #hi_addr(_USB_RdBuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #110
IT	EQ
BEQ	L_USB_CheckIn20
MOVW	R0, #lo_addr(_USB_RdBuff+0)
MOVT	R0, #hi_addr(_USB_RdBuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #111
IT	EQ
BEQ	L_USB_CheckIn21
MOVW	R0, #lo_addr(_USB_RdBuff+0)
MOVT	R0, #hi_addr(_USB_RdBuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #112
IT	EQ
BEQ	L_USB_CheckIn22
MOVW	R0, #lo_addr(_USB_RdBuff+0)
MOVT	R0, #hi_addr(_USB_RdBuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #113
IT	EQ
BEQ	L_USB_CheckIn23
MOVW	R0, #lo_addr(_USB_RdBuff+0)
MOVT	R0, #hi_addr(_USB_RdBuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #114
IT	EQ
BEQ	L_USB_CheckIn24
MOVW	R0, #lo_addr(_USB_RdBuff+0)
MOVT	R0, #hi_addr(_USB_RdBuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #115
IT	EQ
BEQ	L_USB_CheckIn25
MOVW	R0, #lo_addr(_USB_RdBuff+0)
MOVT	R0, #hi_addr(_USB_RdBuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #116
IT	EQ
BEQ	L_USB_CheckIn26
MOVW	R0, #lo_addr(_USB_RdBuff+0)
MOVT	R0, #hi_addr(_USB_RdBuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #117
IT	EQ
BEQ	L_USB_CheckIn27
MOVW	R0, #lo_addr(_USB_RdBuff+0)
MOVT	R0, #hi_addr(_USB_RdBuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #118
IT	EQ
BEQ	L_USB_CheckIn28
MOVW	R0, #lo_addr(_USB_RdBuff+0)
MOVT	R0, #hi_addr(_USB_RdBuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #119
IT	EQ
BEQ	L_USB_CheckIn29
MOVW	R0, #lo_addr(_USB_RdBuff+0)
MOVT	R0, #hi_addr(_USB_RdBuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #120
IT	EQ
BEQ	L_USB_CheckIn30
MOVW	R0, #lo_addr(_USB_RdBuff+0)
MOVT	R0, #hi_addr(_USB_RdBuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #121
IT	EQ
BEQ	L_USB_CheckIn31
MOVW	R0, #lo_addr(_USB_RdBuff+0)
MOVT	R0, #hi_addr(_USB_RdBuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #122
IT	EQ
BEQ	L_USB_CheckIn32
IT	AL
BAL	L_USB_CheckIn33
L_USB_CheckIn2:
;USB_driver3.c,263 :: 		}
L_USB_CheckIn0:
;USB_driver3.c,264 :: 		}
L_end_USB_CheckIn:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _USB_CheckIn
_USB_PutQueue:
;USB_driver3.c,269 :: 		void USB_PutQueue(char *msg) {
SUB	SP, SP, #8
STR	LR, [SP, #0]
STR	R0, [SP, #4]
;USB_driver3.c,272 :: 		rtnCode = xQueueSend(xPointerQueue, &msg, 0); // No blocking
ADD	R2, SP, #4
MOVW	R1, #lo_addr(_xPointerQueue+0)
MOVT	R1, #hi_addr(_xPointerQueue+0)
LDR	R1, [R1, #0]
MOV	R3, #0
MOV	R0, R1
MOV	R1, R2
MOVS	R2, #0
BL	_xQueueGenericSend+0
;USB_driver3.c,274 :: 		if (rtnCode == pdFAIL)
CMP	R0, #0
IT	NE
BNE	L_USB_PutQueue34
;USB_driver3.c,275 :: 		Timer8_Ch2_Start(); // Flash PC7 LED if pdFAIL
BL	_Timer8_Ch2_Start+0
L_USB_PutQueue34:
;USB_driver3.c,276 :: 		}
L_end_USB_PutQueue:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _USB_PutQueue
_USB_CheckOut:
;USB_driver3.c,283 :: 		void USB_CheckOut(void) {
SUB	SP, SP, #12
STR	LR, [SP, #0]
;USB_driver3.c,284 :: 		char RetryCount = 0;          // Set to zero on entry to this function
MOVS	R0, #0
STRB	R0, [SP, #8]
;USB_driver3.c,288 :: 		rtnCode = xQueueReceive(xPointerQueue, &pcReceivedAddr, 0xFFFFFFFFU); // Block here
ADD	R1, SP, #4
MOVW	R0, #lo_addr(_xPointerQueue+0)
MOVT	R0, #hi_addr(_xPointerQueue+0)
LDR	R0, [R0, #0]
MOV	R3, #0
MOV	R2, #-1
BL	_xQueueGenericReceive+0
;USB_driver3.c,290 :: 		if (rtnCode == pdPASS) {
CMP	R0, #1
IT	NE
BNE	L_USB_CheckOut35
;USB_driver3.c,291 :: 		while (((HID_Write(pcReceivedAddr,64) == 0)) && (RetryCount < 5)) { // Send 64 bytes to USB
L_USB_CheckOut36:
MOVS	R1, #64
LDR	R0, [SP, #4]
BL	_HID_Write+0
CMP	R0, #0
IT	NE
BNE	L__USB_CheckOut47
LDRB	R0, [SP, #8]
CMP	R0, #5
IT	CS
BCS	L__USB_CheckOut46
L__USB_CheckOut45:
;USB_driver3.c,292 :: 		RetryCount++;       // Try 5 times
LDRB	R0, [SP, #8]
ADDS	R0, R0, #1
STRB	R0, [SP, #8]
;USB_driver3.c,293 :: 		}
IT	AL
BAL	L_USB_CheckOut36
;USB_driver3.c,291 :: 		while (((HID_Write(pcReceivedAddr,64) == 0)) && (RetryCount < 5)) { // Send 64 bytes to USB
L__USB_CheckOut47:
L__USB_CheckOut46:
;USB_driver3.c,294 :: 		} else {
IT	AL
BAL	L_USB_CheckOut40
L_USB_CheckOut35:
;USB_driver3.c,295 :: 		Timer8_Ch2_Start();      // Flash PC7 LED if pdFAIL
BL	_Timer8_Ch2_Start+0
;USB_driver3.c,296 :: 		}
L_USB_CheckOut40:
;USB_driver3.c,297 :: 		}
L_end_USB_CheckOut:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _USB_CheckOut
_usbRcvTask:
;USB_driver3.c,303 :: 		void usbRcvTask(void *pvParameters) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;USB_driver3.c,305 :: 		USB_Initialize();             // Initialize USB hardware
BL	_USB_Initialize+0
;USB_driver3.c,308 :: 		usbSemHandle = xSemaphoreCreateBinary();
MOVS	R2, #3
MOVS	R1, #0
MOV	R0, #1
BL	_xQueueGenericCreate+0
MOVW	R1, #lo_addr(_usbSemHandle+0)
MOVT	R1, #hi_addr(_usbSemHandle+0)
STR	R0, [R1, #0]
;USB_driver3.c,311 :: 		while (1) {
L_usbRcvTask41:
;USB_driver3.c,312 :: 		USB_CheckIn(); // Check for incoming USB messages
BL	_USB_CheckIn+0
;USB_driver3.c,314 :: 		}
IT	AL
BAL	L_usbRcvTask41
;USB_driver3.c,315 :: 		}
L_end_usbRcvTask:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _usbRcvTask
_usbXmtTask:
;USB_driver3.c,322 :: 		void usbXmtTask(void *pvParameters) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;USB_driver3.c,325 :: 		xPointerQueue = xQueueCreate(64, sizeof(char *));
MOVS	R2, #0
MOVS	R1, #4
MOVS	R0, #64
BL	_xQueueGenericCreate+0
MOVW	R1, #lo_addr(_xPointerQueue+0)
MOVT	R1, #hi_addr(_xPointerQueue+0)
STR	R0, [R1, #0]
;USB_driver3.c,328 :: 		vTaskDelay(pdMS_TO_TICKS(14000));
MOVW	R0, #14000
MOVT	R0, #0
BL	_vTaskDelay+0
;USB_driver3.c,329 :: 		USB_PutQueue(" ");                      // Output blank line
MOVW	R1, #lo_addr(?lstr11_USB_driver3+0)
MOVT	R1, #hi_addr(?lstr11_USB_driver3+0)
MOV	R0, R1
BL	_USB_PutQueue+0
;USB_driver3.c,330 :: 		USB_PutQueue("Program started\r\n");    // Send opening message on USB
MOVW	R1, #lo_addr(?lstr12_USB_driver3+0)
MOVT	R1, #hi_addr(?lstr12_USB_driver3+0)
MOV	R0, R1
BL	_USB_PutQueue+0
;USB_driver3.c,333 :: 		Timer8_Initialize();
BL	_Timer8_Initialize+0
;USB_driver3.c,334 :: 		Timer8_Ch2_Start();
BL	_Timer8_Ch2_Start+0
;USB_driver3.c,336 :: 		while (1) {
L_usbXmtTask43:
;USB_driver3.c,337 :: 		USB_CheckOut(); // Check for outgoing USB messages
BL	_USB_CheckOut+0
;USB_driver3.c,338 :: 		}
IT	AL
BAL	L_usbXmtTask43
;USB_driver3.c,339 :: 		}
L_end_usbXmtTask:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _usbXmtTask
